"use strict";
(self["webpackChunkjupyterlab_optuna"] = self["webpackChunkjupyterlab_optuna"] || []).push([["optuna_dashboard_pkg_pkg_index_js"],{

/***/ "../optuna_dashboard/pkg/action.js":
/*!*****************************************!*\
  !*** ../optuna_dashboard/pkg/action.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   actionCreator: () => (/* binding */ actionCreator)
/* harmony export */ });
/* harmony import */ var notistack__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! notistack */ "../optuna_dashboard/node_modules/notistack/notistack.esm.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _apiClientProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./apiClientProvider */ "../optuna_dashboard/pkg/apiClientProvider.js");
/* harmony import */ var _dominatedTrials__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./dominatedTrials */ "../optuna_dashboard/pkg/dominatedTrials.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./state */ "../optuna_dashboard/pkg/state.js");





// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
const actionCreator = () => {
    const { apiClient } = (0,_apiClientProvider__WEBPACK_IMPORTED_MODULE_2__.useAPIClient)();
    const { enqueueSnackbar } = (0,notistack__WEBPACK_IMPORTED_MODULE_0__.useSnackbar)();
    const [studySummaries, setStudySummaries] = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.studySummariesState);
    const [studyDetails, setStudyDetails] = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.studyDetailsState);
    const setReloadInterval = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.reloadIntervalState);
    const setUploading = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.isFileUploading);
    const setTrialsUpdating = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.trialsUpdatingState);
    const setArtifactIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.artifactIsAvailable);
    const setPlotlypyIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.plotlypyIsAvailableState);
    const setStudySummariesLoading = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useSetRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.studySummariesLoadingState);
    const [studyDetailLoading, setStudyDetailLoading] = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilState)(_state__WEBPACK_IMPORTED_MODULE_4__.studyDetailLoadingState);
    const setStudyDetailState = (studyId, study) => {
        setStudyDetails((prevVal) => {
            const newVal = Object.assign({}, prevVal);
            newVal[studyId] = study;
            return newVal;
        });
    };
    const setTrial = (studyId, trialIndex, trial) => {
        const newTrials = [...studyDetails[studyId].trials];
        newTrials[trialIndex] = trial;
        const newStudy = Object.assign({}, studyDetails[studyId]);
        newStudy.trials = newTrials;
        setStudyDetailState(studyId, newStudy);
    };
    const setTrialUpdating = (trialId, updating) => {
        setTrialsUpdating((prev) => {
            const newVal = Object.assign({}, prev);
            newVal[trialId] = updating;
            return newVal;
        });
    };
    const setTrialNote = (studyId, index, note) => {
        const newTrial = Object.assign({}, studyDetails[studyId].trials[index]);
        newTrial.note = note;
        setTrial(studyId, index, newTrial);
    };
    const setTrialArtifacts = (studyId, trialIndex, artifacts) => {
        const newTrial = Object.assign({}, studyDetails[studyId].trials[trialIndex]);
        newTrial.artifacts = artifacts;
        setTrial(studyId, trialIndex, newTrial);
    };
    const setStudyArtifacts = (studyId, artifacts) => {
        const newStudy = Object.assign({}, studyDetails[studyId]);
        newStudy.artifacts = artifacts;
        setStudyDetailState(studyId, newStudy);
    };
    const deleteTrialArtifactState = (studyId, trialId, artifact_id) => {
        const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
        if (index === -1) {
            return;
        }
        const artifacts = studyDetails[studyId].trials[index].artifacts;
        const artifactIndex = artifacts.findIndex((a) => a.artifact_id === artifact_id);
        const newArtifacts = [
            ...artifacts.slice(0, artifactIndex),
            ...artifacts.slice(artifactIndex + 1, artifacts.length),
        ];
        setTrialArtifacts(studyId, index, newArtifacts);
    };
    const deleteStudyArtifactState = (studyId, artifact_id) => {
        const artifacts = studyDetails[studyId].artifacts;
        const artifactIndex = artifacts.findIndex((a) => a.artifact_id === artifact_id);
        const newArtifacts = [
            ...artifacts.slice(0, artifactIndex),
            ...artifacts.slice(artifactIndex + 1, artifacts.length),
        ];
        setStudyArtifacts(studyId, newArtifacts);
    };
    const setTrialStateValues = (studyId, index, state, values) => {
        var _a, _b;
        const newTrial = Object.assign({}, studyDetails[studyId].trials[index]);
        newTrial.state = state;
        newTrial.values = values;
        const newTrials = [...studyDetails[studyId].trials];
        newTrials[index] = newTrial;
        const newStudy = Object.assign({}, studyDetails[studyId]);
        newStudy.trials = newTrials;
        // Update Best Trials
        if (state === "Complete" && newStudy.directions.length === 1) {
            // Single objective optimization
            const bestValue = (_b = (_a = newStudy.best_trials.at(0)) === null || _a === void 0 ? void 0 : _a.values) === null || _b === void 0 ? void 0 : _b.at(0);
            const currentValue = values === null || values === void 0 ? void 0 : values.at(0);
            if (newStudy.best_trials.length === 0) {
                newStudy.best_trials = [newTrial];
            }
            else if (bestValue !== undefined && currentValue !== undefined) {
                if (newStudy.directions[0] === "minimize" && currentValue < bestValue) {
                    newStudy.best_trials = [newTrial];
                }
                else if (newStudy.directions[0] === "maximize" &&
                    currentValue > bestValue) {
                    newStudy.best_trials = [newTrial];
                }
                else if (currentValue === bestValue) {
                    newStudy.best_trials = [...newStudy.best_trials, newTrial];
                }
            }
        }
        else if (state === "Complete") {
            // Multi objective optimization
            newStudy.best_trials = (0,_dominatedTrials__WEBPACK_IMPORTED_MODULE_3__.getDominatedTrials)(newStudy.trials, newStudy.directions);
        }
        setStudyDetailState(studyId, newStudy);
    };
    const setTrialUserAttrs = (studyId, index, user_attrs) => {
        const newTrial = Object.assign({}, studyDetails[studyId].trials[index]);
        newTrial.user_attrs = Object.keys(user_attrs).map((key) => ({
            key: key,
            value: user_attrs[key].toString(),
        }));
        const newTrials = [...studyDetails[studyId].trials];
        newTrials[index] = newTrial;
        const newStudy = Object.assign({}, studyDetails[studyId]);
        newStudy.trials = newTrials;
        setStudyDetailState(studyId, newStudy);
    };
    const updateAPIMeta = () => {
        apiClient.getMetaInfo().then((r) => {
            setArtifactIsAvailable(r.artifact_is_available);
            setPlotlypyIsAvailable(r.plotlypy_is_available);
        });
    };
    const updateStudySummaries = (successMsg) => {
        setStudySummariesLoading(true);
        apiClient
            .getStudySummaries()
            .then((studySummaries) => {
            setStudySummariesLoading(false);
            setStudySummaries(studySummaries);
            if (successMsg) {
                enqueueSnackbar(successMsg, { variant: "success" });
            }
        })
            .catch((err) => {
            setStudySummariesLoading(false);
            enqueueSnackbar(`Failed to fetch study list.`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const updateStudyDetail = (studyId) => {
        if (studyDetailLoading[studyId]) {
            return;
        }
        setStudyDetailLoading(Object.assign(Object.assign({}, studyDetailLoading), { [studyId]: true }));
        let nLocalFixedTrials = 0;
        if (studyId in studyDetails) {
            const currentTrials = studyDetails[studyId].trials;
            const firstUpdatable = currentTrials.findIndex((trial) => ["Running", "Waiting"].includes(trial.state));
            nLocalFixedTrials =
                firstUpdatable === -1 ? currentTrials.length : firstUpdatable;
        }
        apiClient
            .getStudyDetail(studyId, nLocalFixedTrials)
            .then((study) => {
            setStudyDetailLoading(Object.assign(Object.assign({}, studyDetailLoading), { [studyId]: false }));
            const currentFixedTrials = studyId in studyDetails
                ? studyDetails[studyId].trials.slice(0, nLocalFixedTrials)
                : [];
            study.trials = currentFixedTrials.concat(study.trials);
            setStudyDetailState(studyId, study);
        })
            .catch((err) => {
            var _a;
            setStudyDetailLoading(Object.assign(Object.assign({}, studyDetailLoading), { [studyId]: false }));
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            if (reason !== undefined) {
                enqueueSnackbar(`Failed to fetch study (reason=${reason})`, {
                    variant: "error",
                });
            }
            console.log(err);
        });
    };
    const createNewStudy = (studyName, directions) => {
        apiClient
            .createNewStudy(studyName, directions)
            .then((study_summary) => {
            const newVal = [...studySummaries, study_summary];
            setStudySummaries(newVal);
            enqueueSnackbar(`Success to create a study (study_name=${studyName})`, {
                variant: "success",
            });
        })
            .catch((err) => {
            enqueueSnackbar(`Failed to create a study (study_name=${studyName})`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const deleteStudy = (studyId, removeAssociatedArtifacts) => {
        apiClient
            .deleteStudy(studyId, removeAssociatedArtifacts)
            .then(() => {
            setStudySummaries(studySummaries.filter((s) => s.study_id !== studyId));
            enqueueSnackbar(`Success to delete a study (id=${studyId})`, {
                variant: "success",
            });
        })
            .catch((err) => {
            enqueueSnackbar(`Failed to delete study (id=${studyId})`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const renameStudy = (studyId, studyName) => {
        apiClient
            .renameStudy(studyId, studyName)
            .then((study) => {
            const newStudySummaries = [
                ...studySummaries.filter((s) => s.study_id !== studyId),
                study,
            ];
            setStudySummaries(newStudySummaries);
            enqueueSnackbar(`Success to delete a study (id=${studyId})`, {
                variant: "success",
            });
        })
            .catch((err) => {
            enqueueSnackbar(`Failed to rename study (id=${studyId})`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const saveReloadInterval = (interval) => {
        setReloadInterval(interval);
    };
    const saveStudyNote = (studyId, note) => {
        return apiClient
            .saveStudyNote(studyId, note)
            .then(() => {
            const newStudy = Object.assign({}, studyDetails[studyId]);
            newStudy.note = note;
            setStudyDetailState(studyId, newStudy);
            enqueueSnackbar(`Success to save the note`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            if (err.response.status === 409) {
                const newStudy = Object.assign({}, studyDetails[studyId]);
                newStudy.note = err.response.data.note;
                setStudyDetailState(studyId, newStudy);
            }
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            if (reason !== undefined) {
                enqueueSnackbar(`Failed: ${reason}`, {
                    variant: "error",
                });
            }
            throw err;
        });
    };
    const saveTrialNote = (studyId, trialId, note) => {
        return apiClient
            .saveTrialNote(studyId, trialId, note)
            .then(() => {
            const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
            if (index === -1) {
                enqueueSnackbar(`Unexpected error happens. Please reload the page.`, {
                    variant: "error",
                });
                return;
            }
            setTrialNote(studyId, index, note);
            enqueueSnackbar(`Success to save the note`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            if (err.response.status === 409) {
                const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
                if (index === -1) {
                    enqueueSnackbar(`Unexpected error happens. Please reload the page.`, {
                        variant: "error",
                    });
                    return;
                }
                setTrialNote(studyId, index, err.response.data.note);
            }
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            if (reason !== undefined) {
                enqueueSnackbar(`Failed: ${reason}`, {
                    variant: "error",
                });
            }
            throw err;
        });
    };
    const uploadTrialArtifact = (studyId, trialId, file) => {
        const reader = new FileReader();
        setUploading(true);
        reader.readAsDataURL(file);
        reader.onload = (upload) => {
            var _a;
            apiClient
                .uploadTrialArtifact(studyId, trialId, file.name, (_a = upload.target) === null || _a === void 0 ? void 0 : _a.result)
                .then((res) => {
                setUploading(false);
                const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
                if (index === -1) {
                    return;
                }
                setTrialArtifacts(studyId, index, res.artifacts);
            })
                .catch((err) => {
                var _a;
                setUploading(false);
                const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
                enqueueSnackbar(`Failed to upload ${reason}`, { variant: "error" });
            });
        };
        reader.onerror = (error) => {
            enqueueSnackbar(`Failed to read the file ${error}`, { variant: "error" });
            console.log(error);
        };
    };
    const uploadStudyArtifact = (studyId, file) => {
        const reader = new FileReader();
        setUploading(true);
        reader.readAsDataURL(file);
        reader.onload = (upload) => {
            var _a;
            apiClient
                .uploadStudyArtifact(studyId, file.name, (_a = upload.target) === null || _a === void 0 ? void 0 : _a.result)
                .then((res) => {
                setUploading(false);
                setStudyArtifacts(studyId, res.artifacts);
            })
                .catch((err) => {
                var _a;
                setUploading(false);
                const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
                enqueueSnackbar(`Failed to upload ${reason}`, { variant: "error" });
            });
        };
        reader.onerror = (error) => {
            enqueueSnackbar(`Failed to read the file ${error}`, { variant: "error" });
            console.log(error);
        };
    };
    const deleteTrialArtifact = (studyId, trialId, artifactId) => {
        apiClient
            .deleteTrialArtifact(studyId, trialId, artifactId)
            .then(() => {
            deleteTrialArtifactState(studyId, trialId, artifactId);
            enqueueSnackbar(`Success to delete an artifact.`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to delete ${reason}.`, {
                variant: "error",
            });
        });
    };
    const deleteStudyArtifact = (studyId, artifactId) => {
        apiClient
            .deleteStudyArtifact(studyId, artifactId)
            .then(() => {
            deleteStudyArtifactState(studyId, artifactId);
            enqueueSnackbar(`Success to delete an artifact.`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to delete ${reason}.`, {
                variant: "error",
            });
        });
    };
    const makeTrialFail = (studyId, trialId) => {
        const message = `id=${trialId}, state=Fail`;
        setTrialUpdating(trialId, true);
        apiClient
            .tellTrial(trialId, "Fail")
            .then(() => {
            const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
            if (index === -1) {
                enqueueSnackbar(`Unexpected error happens. Please reload the page.`, {
                    variant: "error",
                });
                return;
            }
            setTrialStateValues(studyId, index, "Fail");
            enqueueSnackbar(`Successfully updated trial (${message})`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            setTrialUpdating(trialId, false);
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to update trial (${message}). Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const makeTrialComplete = (studyId, trialId, values) => {
        const message = `id=${trialId}, state=Complete, values=${values}`;
        setTrialUpdating(trialId, true);
        apiClient
            .tellTrial(trialId, "Complete", values)
            .then(() => {
            const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
            if (index === -1) {
                enqueueSnackbar(`Unexpected error happens. Please reload the page.`, {
                    variant: "error",
                });
                return;
            }
            setTrialStateValues(studyId, index, "Complete", values);
        })
            .catch((err) => {
            var _a;
            setTrialUpdating(trialId, false);
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to update trial (${message}). Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const saveTrialUserAttrs = (studyId, trialId, user_attrs) => {
        const message = `id=${trialId}, user_attrs=${JSON.stringify(user_attrs)}`;
        setTrialUpdating(trialId, true);
        apiClient
            .saveTrialUserAttrs(trialId, user_attrs)
            .then(() => {
            const index = studyDetails[studyId].trials.findIndex((t) => t.trial_id === trialId);
            if (index === -1) {
                enqueueSnackbar(`Unexpected error happens. Please reload the page.`, {
                    variant: "error",
                });
                return;
            }
            setTrialUserAttrs(studyId, index, user_attrs);
            enqueueSnackbar(`Successfully updated trial (${message})`, {
                variant: "success",
            });
        })
            .catch((err) => {
            var _a;
            setTrialUpdating(trialId, false);
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to update trial (${message}). Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const updatePreference = (studyId, candidates, clicked) => {
        apiClient.reportPreference(studyId, candidates, clicked).catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to report preference. Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const skipPreferentialTrial = (studyId, trialId) => {
        apiClient.skipPreferentialTrial(studyId, trialId).catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to skip trial. Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const updateFeedbackComponent = (studyId, compoennt_type) => {
        apiClient
            .reportFeedbackComponent(studyId, compoennt_type)
            .then(() => {
            const newStudy = Object.assign({}, studyDetails[studyId]);
            newStudy.feedback_component_type = compoennt_type;
            setStudyDetailState(studyId, newStudy);
        })
            .catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to report feedback component. Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const removePreferentialHistory = (studyId, historyId) => {
        apiClient
            .removePreferentialHistory(studyId, historyId)
            .then(() => {
            var _a, _b, _c, _d;
            const newStudy = Object.assign({}, studyDetails[studyId]);
            newStudy.preference_history = (_a = newStudy.preference_history) === null || _a === void 0 ? void 0 : _a.map((h) => h.id === historyId ? Object.assign(Object.assign({}, h), { is_removed: true }) : h);
            const removed = (_c = (_b = newStudy.preference_history) === null || _b === void 0 ? void 0 : _b.filter((h) => h.id === historyId).pop()) === null || _c === void 0 ? void 0 : _c.preferences;
            newStudy.preferences = (_d = newStudy.preferences) === null || _d === void 0 ? void 0 : _d.filter((p) => !(removed === null || removed === void 0 ? void 0 : removed.some((r) => r[0] === p[0] && r[1] === p[1])));
            setStudyDetailState(studyId, newStudy);
        })
            .catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to switch history. Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    const restorePreferentialHistory = (studyId, historyId) => {
        apiClient
            .restorePreferentialHistory(studyId, historyId)
            .then(() => {
            var _a, _b, _c, _d;
            const newStudy = Object.assign({}, studyDetails[studyId]);
            newStudy.preference_history = (_a = newStudy.preference_history) === null || _a === void 0 ? void 0 : _a.map((h) => h.id === historyId ? Object.assign(Object.assign({}, h), { is_removed: false }) : h);
            const restored = (_c = (_b = newStudy.preference_history) === null || _b === void 0 ? void 0 : _b.filter((h) => h.id === historyId).pop()) === null || _c === void 0 ? void 0 : _c.preferences;
            newStudy.preferences = (_d = newStudy.preferences) === null || _d === void 0 ? void 0 : _d.concat(restored !== null && restored !== void 0 ? restored : []);
            setStudyDetailState(studyId, newStudy);
        })
            .catch((err) => {
            var _a;
            const reason = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to switch history. Reason: ${reason}`, {
                variant: "error",
            });
            console.log(err);
        });
    };
    return {
        updateAPIMeta,
        updateStudyDetail,
        updateStudySummaries,
        createNewStudy,
        deleteStudy,
        renameStudy,
        saveReloadInterval,
        saveStudyNote,
        saveTrialNote,
        uploadTrialArtifact,
        uploadStudyArtifact,
        deleteTrialArtifact,
        deleteStudyArtifact,
        makeTrialComplete,
        makeTrialFail,
        saveTrialUserAttrs,
        updatePreference,
        skipPreferentialTrial,
        removePreferentialHistory,
        restorePreferentialHistory,
        updateFeedbackComponent,
    };
};


/***/ }),

/***/ "../optuna_dashboard/pkg/apiClient.js":
/*!********************************************!*\
  !*** ../optuna_dashboard/pkg/apiClient.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   APIClient: () => (/* binding */ APIClient),
/* harmony export */   CompareStudiesPlotType: () => (/* binding */ CompareStudiesPlotType),
/* harmony export */   PlotType: () => (/* binding */ PlotType)
/* harmony export */ });
var PlotType;
(function (PlotType) {
    PlotType["Contour"] = "contour";
    PlotType["Slice"] = "slice";
    PlotType["ParallelCoordinate"] = "parallel_coordinate";
    PlotType["Rank"] = "rank";
    PlotType["EDF"] = "edf";
    PlotType["Timeline"] = "timeline";
    PlotType["ParamImportances"] = "param_importances";
    PlotType["ParetoFront"] = "pareto_front";
})(PlotType || (PlotType = {}));
var CompareStudiesPlotType;
(function (CompareStudiesPlotType) {
    CompareStudiesPlotType["EDF"] = "edf";
})(CompareStudiesPlotType || (CompareStudiesPlotType = {}));
class APIClient {
    constructor() { }
    convertTrialResponse(response) {
        return {
            trial_id: response.trial_id,
            study_id: response.study_id,
            number: response.number,
            state: response.state,
            values: response.values,
            intermediate_values: response.intermediate_values,
            datetime_start: response.datetime_start
                ? new Date(response.datetime_start)
                : undefined,
            datetime_complete: response.datetime_complete
                ? new Date(response.datetime_complete)
                : undefined,
            params: response.params,
            fixed_params: response.fixed_params,
            user_attrs: response.user_attrs,
            note: response.note,
            artifacts: response.artifacts,
            constraints: response.constraints,
        };
    }
    convertPreferenceHistory(response) {
        return {
            id: response.history.id,
            candidates: response.history.candidates,
            clicked: response.history.clicked,
            feedback_mode: response.history.mode,
            timestamp: new Date(response.history.timestamp),
            preferences: response.history.preferences,
            is_removed: response.is_removed,
        };
    }
}


/***/ }),

/***/ "../optuna_dashboard/pkg/apiClientProvider.js":
/*!****************************************************!*\
  !*** ../optuna_dashboard/pkg/apiClientProvider.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   APIClientContext: () => (/* binding */ APIClientContext),
/* harmony export */   APIClientProvider: () => (/* binding */ APIClientProvider),
/* harmony export */   useAPIClient: () => (/* binding */ useAPIClient)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const APIClientContext = (0,react__WEBPACK_IMPORTED_MODULE_0__.createContext)(undefined);
const useAPIClient = () => {
    const context = (0,react__WEBPACK_IMPORTED_MODULE_0__.useContext)(APIClientContext);
    if (context === undefined) {
        throw new Error("useAPIClient must be used within a APIClientProvider.");
    }
    return context;
};
function APIClientProvider({ apiClient, children, }) {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(APIClientContext.Provider, { value: { apiClient } }, children));
}


/***/ }),

/***/ "../optuna_dashboard/pkg/axiosClient.js":
/*!**********************************************!*\
  !*** ../optuna_dashboard/pkg/axiosClient.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AxiosClient: () => (/* binding */ AxiosClient)
/* harmony export */ });
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! axios */ "../optuna_dashboard/node_modules/axios/lib/axios.js");
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./apiClient */ "../optuna_dashboard/pkg/apiClient.js");


class AxiosClient extends _apiClient__WEBPACK_IMPORTED_MODULE_0__.APIClient {
    constructor(API_ENDPOINT) {
        super();
        this.getMetaInfo = () => this.axiosInstance
            .get(`/api/meta`)
            .then((res) => res.data);
        this.getStudyDetail = (studyId, nLocalTrials) => this.axiosInstance
            .get(`/api/studies/${studyId}`, {
            params: {
                after: nLocalTrials,
            },
        })
            .then((res) => {
            var _a, _b;
            const trials = res.data.trials.map((trial) => {
                return this.convertTrialResponse(trial);
            });
            const best_trials = res.data.best_trials.map((trial) => {
                return this.convertTrialResponse(trial);
            });
            return {
                id: studyId,
                name: res.data.name,
                datetime_start: new Date(res.data.datetime_start),
                directions: res.data.directions,
                user_attrs: res.data.user_attrs,
                trials: trials,
                best_trials: best_trials,
                union_search_space: res.data.union_search_space,
                intersection_search_space: res.data.intersection_search_space,
                union_user_attrs: res.data.union_user_attrs,
                has_intermediate_values: res.data.has_intermediate_values,
                note: res.data.note,
                metric_names: res.data.objective_names,
                form_widgets: res.data.form_widgets,
                is_preferential: res.data.is_preferential,
                feedback_component_type: res.data.feedback_component_type,
                preferences: res.data.preferences,
                preference_history: (_a = res.data.preference_history) === null || _a === void 0 ? void 0 : _a.map(this.convertPreferenceHistory),
                plotly_graph_objects: res.data.plotly_graph_objects,
                artifacts: res.data.artifacts,
                skipped_trial_numbers: (_b = res.data.skipped_trial_numbers) !== null && _b !== void 0 ? _b : [],
            };
        });
        this.getStudySummaries = () => this.axiosInstance
            .get(`/api/studies`, {})
            .then((res) => {
            return res.data.study_summaries.map((study) => {
                return {
                    study_id: study.study_id,
                    study_name: study.study_name,
                    directions: study.directions,
                    user_attrs: study.user_attrs,
                    is_preferential: study.is_preferential,
                    datetime_start: study.datetime_start
                        ? new Date(study.datetime_start)
                        : undefined,
                };
            });
        });
        this.createNewStudy = (studyName, directions) => this.axiosInstance
            .post(`/api/studies`, {
            study_name: studyName,
            directions,
        })
            .then((res) => {
            const study_summary = res.data.study_summary;
            return {
                study_id: study_summary.study_id,
                study_name: study_summary.study_name,
                directions: study_summary.directions,
                // best_trial: undefined,
                user_attrs: study_summary.user_attrs,
                is_preferential: study_summary.is_preferential,
                datetime_start: study_summary.datetime_start
                    ? new Date(study_summary.datetime_start)
                    : undefined,
            };
        });
        this.deleteStudy = (studyId, removeAssociatedArtifacts) => this.axiosInstance
            .delete(`/api/studies/${studyId}`, {
            data: {
                remove_associated_artifacts: removeAssociatedArtifacts,
            },
        })
            .then(() => {
            return;
        });
        this.renameStudy = (studyId, studyName) => this.axiosInstance
            .post(`/api/studies/${studyId}/rename`, {
            study_name: studyName,
        })
            .then((res) => {
            return {
                study_id: res.data.study_id,
                study_name: res.data.study_name,
                directions: res.data.directions,
                user_attrs: res.data.user_attrs,
                is_preferential: res.data.is_prefential,
                datetime_start: res.data.datetime_start
                    ? new Date(res.data.datetime_start)
                    : undefined,
            };
        });
        this.saveStudyNote = (studyId, note) => this.axiosInstance
            .put(`/api/studies/${studyId}/note`, note)
            .then(() => {
            return;
        });
        this.saveTrialNote = (studyId, trialId, note) => this.axiosInstance
            .put(`/api/studies/${studyId}/${trialId}/note`, note)
            .then(() => {
            return;
        });
        this.uploadTrialArtifact = (studyId, trialId, fileName, dataUrl) => this.axiosInstance
            .post(`/api/artifacts/${studyId}/${trialId}`, {
            file: dataUrl,
            filename: fileName,
        })
            .then((res) => {
            return res.data;
        });
        this.uploadStudyArtifact = (studyId, fileName, dataUrl) => this.axiosInstance
            .post(`/api/artifacts/${studyId}`, {
            file: dataUrl,
            filename: fileName,
        })
            .then((res) => {
            return res.data;
        });
        this.deleteTrialArtifact = (studyId, trialId, artifactId) => this.axiosInstance
            .delete(`/api/artifacts/${studyId}/${trialId}/${artifactId}`)
            .then(() => {
            return;
        });
        this.deleteStudyArtifact = (studyId, artifactId) => this.axiosInstance
            .delete(`/api/artifacts/${studyId}/${artifactId}`)
            .then(() => {
            return;
        });
        this.tellTrial = (trialId, state, values) => this.axiosInstance
            .post(`/api/trials/${trialId}/tell`, {
            state,
            values,
        })
            .then(() => {
            return;
        });
        this.saveTrialUserAttrs = (trialId, user_attrs) => this.axiosInstance
            .post(`/api/trials/${trialId}/user-attrs`, { user_attrs })
            .then(() => {
            return;
        });
        this.getParamImportances = (studyId) => this.axiosInstance
            .get(`/api/studies/${studyId}/param_importances`)
            .then((res) => {
            return res.data.param_importances;
        });
        this.reportPreference = (studyId, candidates, clicked) => this.axiosInstance
            .post(`/api/studies/${studyId}/preference`, {
            candidates: candidates,
            clicked: clicked,
            mode: "ChooseWorst",
        })
            .then(() => {
            return;
        });
        this.skipPreferentialTrial = (studyId, trialId) => this.axiosInstance
            .post(`/api/studies/${studyId}/${trialId}/skip`)
            .then(() => {
            return;
        });
        this.removePreferentialHistory = (studyId, historyUuid) => this.axiosInstance
            .delete(`/api/studies/${studyId}/preference/${historyUuid}`)
            .then(() => {
            return;
        });
        this.restorePreferentialHistory = (studyId, historyUuid) => this.axiosInstance
            .post(`/api/studies/${studyId}/preference/${historyUuid}`)
            .then(() => {
            return;
        });
        this.reportFeedbackComponent = (studyId, component_type) => this.axiosInstance
            .put(`/api/studies/${studyId}/preference_feedback_component`, component_type)
            .then(() => {
            return;
        });
        this.getPlot = (studyId, plotType) => this.axiosInstance
            .get(`/api/studies/${studyId}/plot/${plotType}`)
            .then((res) => res.data);
        this.getCompareStudiesPlot = (studyIds, plotType) => this.axiosInstance
            .get(`/api/compare-studies/plot/${plotType}`, {
            params: { study_ids: studyIds },
        })
            .then((res) => res.data);
        this.axiosInstance = axios__WEBPACK_IMPORTED_MODULE_1__["default"].create({ baseURL: API_ENDPOINT });
    }
}


/***/ }),

/***/ "../optuna_dashboard/pkg/components/App.js":
/*!*************************************************!*\
  !*** ../optuna_dashboard/pkg/components/App.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   App: () => (/* binding */ App)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/system/useMediaQuery/useMediaQuery.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/createTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/ThemeProvider.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CssBaseline/CssBaseline.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material_colors_blue__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material/colors/blue */ "../tslib/react/node_modules/@mui/material/colors/blue.js");
/* harmony import */ var _mui_material_colors_pink__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material/colors/pink */ "../tslib/react/node_modules/@mui/material/colors/pink.js");
/* harmony import */ var notistack__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! notistack */ "../optuna_dashboard/node_modules/notistack/notistack.esm.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _tanstack_react_query__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @tanstack/react-query */ "../optuna_dashboard/node_modules/@tanstack/query-core/build/modern/queryClient.js");
/* harmony import */ var _tanstack_react_query__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @tanstack/react-query */ "../optuna_dashboard/node_modules/@tanstack/react-query/build/modern/QueryClientProvider.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _CompareStudies__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./CompareStudies */ "../optuna_dashboard/pkg/components/CompareStudies.js");
/* harmony import */ var _StudyDetail__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./StudyDetail */ "../optuna_dashboard/pkg/components/StudyDetail.js");
/* harmony import */ var _StudyList__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./StudyList */ "../optuna_dashboard/pkg/components/StudyList.js");












const queryClient = new _tanstack_react_query__WEBPACK_IMPORTED_MODULE_7__.QueryClient({
    defaultOptions: {
        queries: {
            retry: false,
            refetchOnMount: false,
            refetchOnReconnect: false,
            refetchOnWindowFocus: false,
        },
    },
});
const App = () => {
    const prefersDarkMode = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])("(prefers-color-scheme: dark)");
    const [colorMode, setColorMode] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)("light");
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        setColorMode(prefersDarkMode ? "dark" : "light");
    }, [prefersDarkMode]);
    const theme = (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => (0,_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"])({
        palette: {
            mode: colorMode,
            primary: _mui_material_colors_blue__WEBPACK_IMPORTED_MODULE_10__["default"],
            secondary: _mui_material_colors_pink__WEBPACK_IMPORTED_MODULE_11__["default"],
        },
    }), [colorMode]);
    const toggleColorMode = () => {
        setColorMode(colorMode === "dark" ? "light" : "dark");
    };
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_3__.useConstants)();
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_tanstack_react_query__WEBPACK_IMPORTED_MODULE_12__.QueryClientProvider, { client: queryClient },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(recoil__WEBPACK_IMPORTED_MODULE_2__.RecoilRoot, null,
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { theme: theme },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], null),
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                        backgroundColor: colorMode === "dark" ? "#121212" : "#ffffff",
                        width: "100%",
                        minHeight: "100vh",
                    } },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(notistack__WEBPACK_IMPORTED_MODULE_0__.SnackbarProvider, { maxSnack: 3 },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_16__.BrowserRouter, null,
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Routes, null,
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/analytics", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "analytics" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/trials", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "trialList" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/trialTable", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "trialTable" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/note", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "note" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/graph", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "graph" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "top" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/studies/:studyId/preference-history", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyDetail__WEBPACK_IMPORTED_MODULE_5__.StudyDetail, { toggleColorMode: toggleColorMode, page: "preferenceHistory" }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/compare-studies", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_CompareStudies__WEBPACK_IMPORTED_MODULE_4__.CompareStudies, { toggleColorMode: toggleColorMode }) }),
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(react_router_dom__WEBPACK_IMPORTED_MODULE_17__.Route, { path: url_prefix + "/", element: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_StudyList__WEBPACK_IMPORTED_MODULE_6__.StudyList, { toggleColorMode: toggleColorMode }) })))))))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/AppDrawer.js":
/*!*******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/AppDrawer.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AppDrawer: () => (/* binding */ AppDrawer)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_AutoGraph__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/icons-material/AutoGraph */ "../tslib/react/node_modules/@mui/icons-material/esm/AutoGraph.js");
/* harmony import */ var _mui_icons_material_Brightness4__WEBPACK_IMPORTED_MODULE_36__ = __webpack_require__(/*! @mui/icons-material/Brightness4 */ "../tslib/react/node_modules/@mui/icons-material/esm/Brightness4.js");
/* harmony import */ var _mui_icons_material_Brightness7__WEBPACK_IMPORTED_MODULE_37__ = __webpack_require__(/*! @mui/icons-material/Brightness7 */ "../tslib/react/node_modules/@mui/icons-material/esm/Brightness7.js");
/* harmony import */ var _mui_icons_material_ChevronLeft__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/icons-material/ChevronLeft */ "../tslib/react/node_modules/@mui/icons-material/esm/ChevronLeft.js");
/* harmony import */ var _mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/icons-material/ChevronRight */ "../tslib/react/node_modules/@mui/icons-material/esm/ChevronRight.js");
/* harmony import */ var _mui_icons_material_RateReview__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/icons-material/RateReview */ "../tslib/react/node_modules/@mui/icons-material/esm/RateReview.js");
/* harmony import */ var _mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! @mui/icons-material/Settings */ "../tslib/react/node_modules/@mui/icons-material/esm/Settings.js");
/* harmony import */ var _mui_icons_material_Sync__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! @mui/icons-material/Sync */ "../tslib/react/node_modules/@mui/icons-material/esm/Sync.js");
/* harmony import */ var _mui_icons_material_SyncDisabled__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! @mui/icons-material/SyncDisabled */ "../tslib/react/node_modules/@mui/icons-material/esm/SyncDisabled.js");
/* harmony import */ var _mui_icons_material_TableView__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/icons-material/TableView */ "../tslib/react/node_modules/@mui/icons-material/esm/TableView.js");
/* harmony import */ var _mui_icons_material_ViewList__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/icons-material/ViewList */ "../tslib/react/node_modules/@mui/icons-material/esm/ViewList.js");
/* harmony import */ var _mui_material_AppBar__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material/AppBar */ "../tslib/react/node_modules/@mui/material/AppBar/AppBar.js");
/* harmony import */ var _mui_material_Box__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material/Box */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material_Divider__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material/Divider */ "../tslib/react/node_modules/@mui/material/Divider/Divider.js");
/* harmony import */ var _mui_material_Drawer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material/Drawer */ "../tslib/react/node_modules/@mui/material/Drawer/Drawer.js");
/* harmony import */ var _mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material/IconButton */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material_List__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material/List */ "../tslib/react/node_modules/@mui/material/List/List.js");
/* harmony import */ var _mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material/ListItem */ "../tslib/react/node_modules/@mui/material/ListItem/ListItem.js");
/* harmony import */ var _mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material/ListItemButton */ "../tslib/react/node_modules/@mui/material/ListItemButton/ListItemButton.js");
/* harmony import */ var _mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material/ListItemIcon */ "../tslib/react/node_modules/@mui/material/ListItemIcon/ListItemIcon.js");
/* harmony import */ var _mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material/ListItemText */ "../tslib/react/node_modules/@mui/material/ListItemText/ListItemText.js");
/* harmony import */ var _mui_material_Modal__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! @mui/material/Modal */ "../tslib/react/node_modules/@mui/material/Modal/Modal.js");
/* harmony import */ var _mui_material_Toolbar__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material/Toolbar */ "../tslib/react/node_modules/@mui/material/Toolbar/Toolbar.js");
/* harmony import */ var _mui_material_styles__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material/styles */ "../tslib/react/node_modules/@mui/material/styles/styled.js");
/* harmony import */ var _mui_material_styles__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material/styles */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _Settings__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./Settings */ "../optuna_dashboard/pkg/components/Settings.js");
/* harmony import */ var _mui_icons_material_GitHub__WEBPACK_IMPORTED_MODULE_38__ = __webpack_require__(/*! @mui/icons-material/GitHub */ "../tslib/react/node_modules/@mui/icons-material/esm/GitHub.js");
/* harmony import */ var _mui_icons_material_History__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/icons-material/History */ "../tslib/react/node_modules/@mui/icons-material/esm/History.js");
/* harmony import */ var _mui_icons_material_Lan__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/icons-material/Lan */ "../tslib/react/node_modules/@mui/icons-material/esm/Lan.js");
/* harmony import */ var _mui_icons_material_Menu__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/icons-material/Menu */ "../tslib/react/node_modules/@mui/icons-material/esm/Menu.js");
/* harmony import */ var _mui_icons_material_OpenInNew__WEBPACK_IMPORTED_MODULE_39__ = __webpack_require__(/*! @mui/icons-material/OpenInNew */ "../tslib/react/node_modules/@mui/icons-material/esm/OpenInNew.js");
/* harmony import */ var _mui_icons_material_QueryStats__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/icons-material/QueryStats */ "../tslib/react/node_modules/@mui/icons-material/esm/QueryStats.js");
/* harmony import */ var _mui_icons_material_ThumbUpAlt__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/icons-material/ThumbUpAlt */ "../tslib/react/node_modules/@mui/icons-material/esm/ThumbUpAlt.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");







































const drawerWidth = 240;
const openedMixin = (theme) => ({
    width: drawerWidth,
    transition: theme.transitions.create("width", {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.enteringScreen,
    }),
    overflowX: "hidden",
});
const closedMixin = (theme) => ({
    transition: theme.transitions.create("width", {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen,
    }),
    overflowX: "hidden",
    width: `calc(${theme.spacing(7)} + 1px)`,
    [theme.breakpoints.up("sm")]: {
        width: `calc(${theme.spacing(8)} + 1px)`,
    },
});
const DrawerHeader = (0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_6__["default"])("div")(({ theme }) => (Object.assign({ display: "flex", alignItems: "center", justifyContent: "flex-end", padding: theme.spacing(0, 1) }, theme.mixins.toolbar)));
const AppBar = (0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_6__["default"])(_mui_material_AppBar__WEBPACK_IMPORTED_MODULE_7__["default"], {
    shouldForwardProp: (prop) => prop !== "open",
})(({ theme, open }) => (Object.assign({ zIndex: theme.zIndex.drawer + 1, transition: theme.transitions.create(["width", "margin"], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen,
    }) }, (open && {
    marginLeft: drawerWidth,
    width: `calc(100% - ${drawerWidth}px)`,
    transition: theme.transitions.create(["width", "margin"], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.enteringScreen,
    }),
}))));
const Drawer = (0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_6__["default"])(_mui_material_Drawer__WEBPACK_IMPORTED_MODULE_8__["default"], {
    shouldForwardProp: (prop) => prop !== "open",
})(({ theme, open }) => (Object.assign(Object.assign({ width: drawerWidth, flexShrink: 0, whiteSpace: "nowrap", boxSizing: "border-box" }, (open && Object.assign(Object.assign({}, openedMixin(theme)), { "& .MuiDrawer-paper": openedMixin(theme) }))), (!open && Object.assign(Object.assign({}, closedMixin(theme)), { "& .MuiDrawer-paper": closedMixin(theme) })))));
const AppDrawer = ({ studyId, toggleColorMode, page, toolbar, children }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_5__.useConstants)();
    const theme = (0,_mui_material_styles__WEBPACK_IMPORTED_MODULE_9__["default"])();
    const constants = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_5__.useConstants)();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_4__.actionCreator)();
    const [open, setOpen] = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilState)(_state__WEBPACK_IMPORTED_MODULE_2__.drawerOpenState);
    const reloadInterval = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_2__.reloadIntervalState);
    const isPreferential = studyId !== undefined ? (0,_state__WEBPACK_IMPORTED_MODULE_2__.useStudyIsPreferential)(studyId) : null;
    const styleListItem = {
        display: "block",
    };
    const styleListItemButton = {
        minHeight: 48,
        justifyContent: open ? "initial" : "center",
        px: 2.5,
    };
    const styleListItemIcon = {
        minWidth: 0,
        mr: open ? 3 : "auto",
        justifyContent: "center",
    };
    const styleListItemText = {
        opacity: open ? 1 : 0,
    };
    const styleSwitch = {
        display: open ? "inherit" : "none",
    };
    const mainSx = {
        flexGrow: 1,
    };
    if (constants.environment === "jupyterlab") {
        // 100vh - (the height of Optuna Dashboard toolbar) - (the height of JupyterLab toolbar)
        mainSx.height = `calc(100vh - ${theme.mixins.toolbar.minHeight}px - 29px)`;
        mainSx.overflow = "auto";
    }
    const handleDrawerOpen = () => {
        setOpen(true);
    };
    const handleDrawerClose = () => {
        setOpen(false);
    };
    const [settingOpen, setSettingOpen] = react__WEBPACK_IMPORTED_MODULE_0___default().useState(false);
    const handleSettingOpen = () => {
        setSettingOpen(true);
    };
    const handleSettingClose = () => {
        setSettingOpen(false);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Box__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { display: "flex", width: "100%" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(AppBar, { position: "fixed", open: open },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Toolbar__WEBPACK_IMPORTED_MODULE_11__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { color: "inherit", "aria-label": "open drawer", onClick: handleDrawerOpen, edge: "start", sx: Object.assign({ marginRight: 5 }, (open && { display: "none" })) },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Menu__WEBPACK_IMPORTED_MODULE_13__["default"], null)),
                toolbar)),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(Drawer, { variant: "permanent", open: open },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(DrawerHeader, null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { onClick: handleDrawerClose }, theme.direction === "rtl" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_14__["default"], null)) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ChevronLeft__WEBPACK_IMPORTED_MODULE_15__["default"], null)))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_16__["default"], null),
            studyId !== undefined && page && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_List__WEBPACK_IMPORTED_MODULE_17__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "Top", disablePadding: true, sx: styleListItem, title: isPreferential ? "Feedback Preference" : "History" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}`, sx: styleListItemButton, selected: page === "top" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon }, isPreferential ? react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ThumbUpAlt__WEBPACK_IMPORTED_MODULE_22__["default"], null) : react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_AutoGraph__WEBPACK_IMPORTED_MODULE_23__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: isPreferential ? "Feedback Preference" : "History", sx: styleListItemText }))),
                isPreferential && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "PreferenceHistory", disablePadding: true, sx: styleListItem, title: "Preference (History)" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/preference-history`, sx: styleListItemButton, selected: page === "preferenceHistory" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_History__WEBPACK_IMPORTED_MODULE_25__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Preferences (History)", sx: styleListItemText })))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "Analytics", disablePadding: true, sx: styleListItem, title: "Analytics" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/analytics`, sx: styleListItemButton, selected: page === "analytics" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_QueryStats__WEBPACK_IMPORTED_MODULE_26__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Analytics", sx: styleListItemText }))),
                isPreferential && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "PreferenceGraph", disablePadding: true, sx: styleListItem, title: "Preference (Graph)" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/graph`, sx: styleListItemButton, selected: page === "graph" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Lan__WEBPACK_IMPORTED_MODULE_27__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Preferences (Graph)", sx: styleListItemText })))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "TableList", disablePadding: true, sx: styleListItem, title: "Trials (List)" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/trials`, sx: styleListItemButton, selected: page === "trialList" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ViewList__WEBPACK_IMPORTED_MODULE_28__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Trials (List)", sx: styleListItemText }))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "TrialTable", disablePadding: true, sx: styleListItem, title: "Trials (Table)" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/trialTable`, sx: styleListItemButton, selected: page === "trialTable" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_TableView__WEBPACK_IMPORTED_MODULE_29__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Trials (Table)", sx: styleListItemText }))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "Note", disablePadding: true, sx: styleListItem, title: "Note" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_20__.Link, to: `${url_prefix}/studies/${studyId}/note`, sx: styleListItemButton, selected: page === "note" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_RateReview__WEBPACK_IMPORTED_MODULE_30__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Note", sx: styleListItemText }))))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Box__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { flexGrow: 1 } }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_16__["default"], null),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_List__WEBPACK_IMPORTED_MODULE_17__["default"], null,
                studyId !== undefined && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "LiveUpdate", disablePadding: true, sx: styleListItem, title: "Live Update" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: styleListItemButton, onClick: () => {
                            action.saveReloadInterval(reloadInterval === -1 ? 10 : -1);
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon }, reloadInterval === -1 ? react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_SyncDisabled__WEBPACK_IMPORTED_MODULE_31__["default"], null) : react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Sync__WEBPACK_IMPORTED_MODULE_32__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Live Update", sx: styleListItemText }),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_33__["default"], { edge: "end", checked: reloadInterval !== -1, sx: styleSwitch, inputProps: {
                                "aria-labelledby": "switch-list-label-live-update",
                            } })))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "Settings", disablePadding: true, sx: styleListItem, title: "Settings" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: styleListItemButton, onClick: handleSettingOpen },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_34__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Settings", sx: styleListItemText })),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Modal__WEBPACK_IMPORTED_MODULE_35__["default"], { open: settingOpen, onClose: handleSettingClose, "aria-labelledby": "modal-modal-title", "aria-describedby": "modal-modal-description" },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Box__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                                position: "absolute",
                                top: "50%",
                                left: "50%",
                                transform: "translate(-50%, -50%)",
                                overflow: "scroll",
                                width: "600px",
                                height: "600px",
                                bgcolor: "background.paper",
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Settings__WEBPACK_IMPORTED_MODULE_3__.Settings, { handleClose: handleSettingClose })))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "DarkMode", disablePadding: true, sx: styleListItem, title: "Dark Mode" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: styleListItemButton, onClick: () => {
                            toggleColorMode();
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon }, theme.palette.mode === "dark" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Brightness4__WEBPACK_IMPORTED_MODULE_36__["default"], null)) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Brightness7__WEBPACK_IMPORTED_MODULE_37__["default"], null))),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Dark Mode", sx: styleListItemText }),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_33__["default"], { edge: "end", checked: theme.palette.mode === "dark", sx: styleSwitch, inputProps: {
                                "aria-labelledby": "switch-list-label-dark-mode",
                            } }))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_16__["default"], null),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_18__["default"], { key: "Feedback", disablePadding: true, sx: styleListItem, title: "Send Feedback" },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_19__["default"], { target: "_blank", href: "https://github.com/optuna/optuna-dashboard/discussions/new/choose", sx: styleListItemButton },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_21__["default"], { sx: styleListItemIcon },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_GitHub__WEBPACK_IMPORTED_MODULE_38__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_24__["default"], { primary: "Send Feedback", sx: styleListItemText }),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_OpenInNew__WEBPACK_IMPORTED_MODULE_39__["default"], { sx: styleSwitch }))))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Box__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "main", sx: mainSx },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(DrawerHeader, null),
            children || null)));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/ArtifactCardMedia.js":
/*!************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/ArtifactCardMedia.js ***!
  \************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ArtifactCardMedia: () => (/* binding */ ArtifactCardMedia)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_InsertDriveFile__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/icons-material/InsertDriveFile */ "../tslib/react/node_modules/@mui/icons-material/esm/InsertDriveFile.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardMedia/CardMedia.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ThreejsArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js");
/* harmony import */ var _WaveSurferArtifactViewer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./WaveSurferArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/WaveSurferArtifactViewer.js");





const ArtifactCardMedia = ({ artifact, urlPath, height }) => {
    if ((0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_1__.isThreejsArtifact)(artifact)) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_1__.ThreejsArtifactViewer, { src: urlPath, width: "100%", height: height, hasGizmo: false, filetype: artifact.filename.split(".").pop() }));
    }
    else if (artifact.mimetype.startsWith("video")) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("video", { controls: true, style: {
                width: "100%",
                height: "auto",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("source", { src: urlPath, type: artifact.mimetype })));
    }
    else if (artifact.mimetype.startsWith("audio")) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { component: "div", style: {
                width: "100%",
                height: height,
                display: "flex",
                alignItems: "center",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_WaveSurferArtifactViewer__WEBPACK_IMPORTED_MODULE_2__.WaveSurferArtifactViewer, { height: 100, waveColor: "rgb(200, 0, 200)", progressColor: "rgb(100, 0, 100)", url: urlPath })));
    }
    else if (artifact.mimetype.startsWith("image")) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { component: "img", height: height, image: urlPath, alt: artifact.filename, style: {
                objectFit: "contain",
            } }));
    }
    return react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_InsertDriveFile__WEBPACK_IMPORTED_MODULE_5__["default"], { sx: { fontSize: 80, flexGrow: 1 } });
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/DeleteArtifactDialog.js":
/*!***************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/DeleteArtifactDialog.js ***!
  \***************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useDeleteStudyArtifactDialog: () => (/* binding */ useDeleteStudyArtifactDialog),
/* harmony export */   useDeleteTrialArtifactDialog: () => (/* binding */ useDeleteTrialArtifactDialog)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContentText/DialogContentText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Alert/Alert.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../action */ "../optuna_dashboard/pkg/action.js");



const useDeleteTrialArtifactDialog = () => {
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [openDeleteArtifactDialog, setOpenDeleteArtifactDialog] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [target, setTarget] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([
        -1,
        -1,
        null,
    ]);
    const handleCloseDeleteArtifactDialog = () => {
        setOpenDeleteArtifactDialog(false);
        setTarget([-1, -1, null]);
    };
    const handleDeleteArtifact = () => {
        const [studyId, trialId, artifact] = target;
        if (artifact === null) {
            return;
        }
        action.deleteTrialArtifact(studyId, trialId, artifact.artifact_id);
        setOpenDeleteArtifactDialog(false);
        setTarget([-1, -1, null]);
    };
    const openDialog = (studyId, trialId, artifact) => {
        setTarget([studyId, trialId, artifact]);
        setOpenDeleteArtifactDialog(true);
    };
    const renderDeleteArtifactDialog = () => {
        var _a;
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(DeleteDialog, { openDeleteArtifactDialog: openDeleteArtifactDialog, handleCloseDeleteArtifactDialog: handleCloseDeleteArtifactDialog, filename: (_a = target[2]) === null || _a === void 0 ? void 0 : _a.filename, handleDeleteArtifact: handleDeleteArtifact }));
    };
    return [openDialog, renderDeleteArtifactDialog];
};
const useDeleteStudyArtifactDialog = () => {
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [openDeleteArtifactDialog, setOpenDeleteArtifactDialog] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [target, setTarget] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([-1, null]);
    const handleCloseDeleteArtifactDialog = () => {
        setOpenDeleteArtifactDialog(false);
        setTarget([-1, null]);
    };
    const handleDeleteArtifact = () => {
        const [studyId, artifact] = target;
        if (artifact === null) {
            return;
        }
        action.deleteStudyArtifact(studyId, artifact.artifact_id);
        setOpenDeleteArtifactDialog(false);
        setTarget([-1, null]);
    };
    const openDialog = (studyId, artifact) => {
        setTarget([studyId, artifact]);
        setOpenDeleteArtifactDialog(true);
    };
    const renderDeleteArtifactDialog = () => {
        var _a;
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(DeleteDialog, { openDeleteArtifactDialog: openDeleteArtifactDialog, handleCloseDeleteArtifactDialog: handleCloseDeleteArtifactDialog, filename: (_a = target[1]) === null || _a === void 0 ? void 0 : _a.filename, handleDeleteArtifact: handleDeleteArtifact }));
    };
    return [openDialog, renderDeleteArtifactDialog];
};
const DeleteDialog = ({ openDeleteArtifactDialog, handleCloseDeleteArtifactDialog, filename, handleDeleteArtifact, }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"])();
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { open: openDeleteArtifactDialog, onClose: () => {
            handleCloseDeleteArtifactDialog();
        }, "aria-labelledby": "delete-artifact-dialog-title" },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { id: "delete-artifact-dialog-title" }, "Delete artifact"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: {
                    marginBottom: theme.spacing(2),
                } },
                "Are you sure you want to delete an artifact (\"",
                filename,
                "\")?"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { severity: "warning" }, "If this artifact is linked to another study or trial, it will no longer be accessible from that study or trial as well.")),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { onClick: handleCloseDeleteArtifactDialog, color: "primary" }, "No"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { onClick: handleDeleteArtifact, color: "primary" }, "Yes"))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/StudyArtifactCards.js":
/*!*************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/StudyArtifactCards.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StudyArtifactCards: () => (/* binding */ StudyArtifactCards)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/icons-material/Delete */ "../tslib/react/node_modules/@mui/icons-material/esm/Delete.js");
/* harmony import */ var _mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/icons-material/Download */ "../tslib/react/node_modules/@mui/icons-material/esm/Download.js");
/* harmony import */ var _mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/icons-material/Fullscreen */ "../tslib/react/node_modules/@mui/icons-material/esm/Fullscreen.js");
/* harmony import */ var _mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/icons-material/UploadFile */ "../tslib/react/node_modules/@mui/icons-material/esm/UploadFile.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActionArea/CardActionArea.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ArtifactCardMedia */ "../optuna_dashboard/pkg/components/Artifact/ArtifactCardMedia.js");
/* harmony import */ var _DeleteArtifactDialog__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./DeleteArtifactDialog */ "../optuna_dashboard/pkg/components/Artifact/DeleteArtifactDialog.js");
/* harmony import */ var _TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./TableArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/TableArtifactViewer.js");
/* harmony import */ var _ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ThreejsArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js");











const StudyArtifactCards = ({ study }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const [openDeleteArtifactDialog, renderDeleteArtifactDialog] = (0,_DeleteArtifactDialog__WEBPACK_IMPORTED_MODULE_3__.useDeleteStudyArtifactDialog)();
    const [openThreejsArtifactModal, renderThreejsArtifactModal] = (0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.useThreejsArtifactModal)();
    const [openTableArtifactModal, renderTableArtifactModal] = (0,_TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__.useTableArtifactModal)();
    const width = "200px";
    const height = "150px";
    const artifacts = [...study.artifacts].sort((a, b) => {
        if (a.filename < b.filename) {
            return -1;
        }
        else if (a.filename > b.filename) {
            return 1;
        }
        else {
            return 0;
        }
    });
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { component: "div", sx: { display: "flex", flexWrap: "wrap", p: theme.spacing(1, 0) } },
            artifacts.map((artifact) => {
                const urlPath = `/artifacts/${study.id}/${artifact.artifact_id}`;
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { key: artifact.artifact_id, sx: {
                        marginBottom: theme.spacing(2),
                        width: width,
                        margin: theme.spacing(0, 1, 1, 0),
                        border: `1px solid ${theme.palette.divider}`,
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_2__.ArtifactCardMedia, { artifact: artifact, urlPath: urlPath, height: height }),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
                            display: "flex",
                            flexDirection: "row",
                            padding: `${theme.spacing(1)} !important`,
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { sx: {
                                p: theme.spacing(0.5, 0),
                                flexGrow: 1,
                                wordWrap: "break-word",
                                maxWidth: `calc(100% - ${(0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.isThreejsArtifact)(artifact)
                                    ? theme.spacing(12)
                                    : theme.spacing(8)})`,
                            } }, artifact.filename),
                        (0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.isThreejsArtifact)(artifact) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "show artifact 3d model", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openThreejsArtifactModal(urlPath, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__["default"], null))) : null,
                        (0,_TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__.isTableArtifact)(artifact) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "show artifact table", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openTableArtifactModal(urlPath, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__["default"], null))) : null,
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "delete artifact", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openDeleteArtifactDialog(study.id, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_13__["default"], null)),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "download artifact", size: "small", color: "inherit", download: artifact.filename, sx: { margin: "auto 0" }, href: urlPath },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_14__["default"], null)))));
            }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(StudyArtifactUploader, { study: study, width: width, height: height })),
        renderDeleteArtifactDialog(),
        renderThreejsArtifactModal(),
        renderTableArtifactModal()));
};
const StudyArtifactUploader = ({ study, width, height }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const [dragOver, setDragOver] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const inputRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)(null);
    const handleClick = () => {
        if (!inputRef || !inputRef.current) {
            return;
        }
        inputRef.current.click();
    };
    const handleOnChange = (e) => {
        const files = e.target.files;
        if (files === null) {
            return;
        }
        action.uploadStudyArtifact(study.id, files[0]);
    };
    const handleDragOver = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(true);
    };
    const handleDragLeave = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(false);
    };
    const handleDrop = (e) => {
        e.stopPropagation();
        e.preventDefault();
        const files = e.dataTransfer.files;
        setDragOver(false);
        for (let i = 0; i < files.length; i++) {
            action.uploadStudyArtifact(study.id, files[i]);
        }
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { sx: {
            marginBottom: theme.spacing(2),
            width: width,
            minHeight: height,
            margin: theme.spacing(0, 1, 1, 0),
            border: dragOver
                ? `3px dashed ${theme.palette.mode === "dark" ? "white" : "black"}`
                : `1px solid ${theme.palette.divider}`,
        }, onDragOver: handleDragOver, onDragLeave: handleDragLeave, onDrop: handleDrop },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { onClick: handleClick, sx: {
                height: "100%",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
                    display: "flex",
                    height: "100%",
                    flexDirection: "column",
                    justifyContent: "center",
                    alignItems: "center",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_16__["default"], { sx: { fontSize: 80, marginBottom: theme.spacing(2) } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("input", { type: "file", ref: inputRef, onChange: handleOnChange, style: { display: "none" } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null, "Upload a New File"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { sx: { textAlign: "center", color: theme.palette.grey.A400 } }, "Drag your file here or click to browse.")))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/TableArtifactViewer.js":
/*!**************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/TableArtifactViewer.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TableArtifactViewer: () => (/* binding */ TableArtifactViewer),
/* harmony export */   isTableArtifact: () => (/* binding */ isTableArtifact),
/* harmony export */   useTableArtifactModal: () => (/* binding */ useTableArtifactModal)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/icons-material/Clear */ "../tslib/react/node_modules/@mui/icons-material/esm/Clear.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Modal/Modal.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material_IconButton__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material/IconButton */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var notistack__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! notistack */ "../optuna_dashboard/node_modules/notistack/notistack.esm.js");
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! papaparse */ "../optuna_dashboard/node_modules/papaparse/papaparse.min.js");
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(papaparse__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! axios */ "../optuna_dashboard/node_modules/axios/lib/axios.js");
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};








const isTableArtifact = (artifact) => {
    return (artifact.filename.endsWith(".csv") || artifact.filename.endsWith(".jsonl"));
};
const TableArtifactViewer = (props) => {
    const [data, setData] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)([]);
    const { enqueueSnackbar } = (0,notistack__WEBPACK_IMPORTED_MODULE_1__.useSnackbar)();
    (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(() => {
        const handleFileChange = () => __awaiter(void 0, void 0, void 0, function* () {
            try {
                const loadedData = yield loadData(props);
                setData(loadedData);
            }
            catch (error) {
                enqueueSnackbar(`Failed to load the file. ${error}`, {
                    variant: "error",
                });
            }
        });
        handleFileChange();
    }, [props]);
    const columns = react__WEBPACK_IMPORTED_MODULE_3___default().useMemo(() => {
        const unionSet = new Set();
        data.forEach((d) => {
            Object.keys(d).forEach((key) => {
                unionSet.add(key);
            });
        });
        const keys = Array.from(unionSet);
        return keys.map((key) => ({
            // ``header`` cannot be a falsy value, so replace key with a string looking like an empty string.
            header: key || " ",
            accessorFn: (info) => typeof info[key] === "object" ? JSON.stringify(info[key]) : info[key],
            enableSorting: true,
            enableColumnFilter: false,
        }));
    }, [data]);
    return react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.DataGrid, { data: data, columns: columns, initialRowsPerPage: 10 });
};
const useTableArtifactModal = () => {
    const [open, setOpen] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(false);
    const [target, setTarget] = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(["", null]);
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const openModal = (artifactUrlPath, artifact) => {
        setTarget([artifactUrlPath, artifact]);
        setOpen(true);
    };
    const renderDeleteStudyDialog = () => {
        var _a;
        return (react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { open: open, onClose: () => {
                setOpen(false);
                setTarget(["", null]);
            } },
            react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: {
                    position: "absolute",
                    top: "50%",
                    left: "50%",
                    transform: "translate(-50%, -50%)",
                    bgcolor: "background.paper",
                    borderRadius: "15px",
                    width: "80%",
                    maxHeight: "80%",
                    overflowY: "auto",
                    p: 2,
                } },
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                        position: "absolute",
                        top: theme.spacing(2),
                        right: theme.spacing(2),
                    }, onClick: () => {
                        setOpen(false);
                        setTarget(["", null]);
                    } },
                    react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_8__["default"], null)),
                react__WEBPACK_IMPORTED_MODULE_3___default().createElement(TableArtifactViewer, { src: target[0], filetype: (_a = target[1]) === null || _a === void 0 ? void 0 : _a.filename.split(".").pop() }))));
    };
    return [openModal, renderDeleteStudyDialog];
};
const loadData = (props) => {
    if (props.filetype === "csv") {
        return loadCSV(props);
    }
    else if (props.filetype === "jsonl") {
        return loadJsonl(props);
    }
    else {
        return Promise.reject(new Error("Unsupported file type"));
    }
};
const loadCSV = (props) => {
    return new Promise((resolve, reject) => {
        papaparse__WEBPACK_IMPORTED_MODULE_2___default().parse(props.src, {
            header: true,
            download: true,
            skipEmptyLines: true,
            complete: (results) => {
                resolve(results === null || results === void 0 ? void 0 : results.data);
            },
            error: () => {
                reject(new Error("CSV parse error"));
            },
        });
    });
};
const loadJsonl = (props) => __awaiter(void 0, void 0, void 0, function* () {
    const response = yield axios__WEBPACK_IMPORTED_MODULE_9__["default"].get(props.src, { responseType: "text" });
    const data = response.data;
    try {
        const jsons = data
            .split("\n")
            .filter((line) => line.trim().length > 0)
            .map((line) => {
            return JSON.parse(line);
        })
            .filter(Boolean);
        return jsons;
    }
    catch (error) {
        throw new Error("JSONL parse error");
    }
});


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js":
/*!****************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js ***!
  \****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ThreejsArtifactViewer: () => (/* binding */ ThreejsArtifactViewer),
/* harmony export */   isThreejsArtifact: () => (/* binding */ isThreejsArtifact),
/* harmony export */   useThreejsArtifactModal: () => (/* binding */ useThreejsArtifactModal)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/icons-material/Clear */ "../tslib/react/node_modules/@mui/icons-material/esm/Clear.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Modal/Modal.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material_IconButton__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material/IconButton */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _react_three_drei__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @react-three/drei */ "../optuna_dashboard/node_modules/@react-three/drei/core/GizmoHelper.js");
/* harmony import */ var _react_three_drei__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @react-three/drei */ "../optuna_dashboard/node_modules/@react-three/drei/core/GizmoViewport.js");
/* harmony import */ var _react_three_drei__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @react-three/drei */ "../optuna_dashboard/node_modules/@react-three/drei/core/OrbitControls.js");
/* harmony import */ var _react_three_fiber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @react-three/fiber */ "../optuna_dashboard/node_modules/@react-three/fiber/dist/react-three-fiber.esm.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! three */ "../optuna_dashboard/node_modules/three/build/three.module.js");
/* harmony import */ var three_examples_jsm_loaders_3DMLoader__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! three/examples/jsm/loaders/3DMLoader */ "../optuna_dashboard/node_modules/three/examples/jsm/loaders/3DMLoader.js");
/* harmony import */ var three_examples_jsm_loaders_OBJLoader__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! three/examples/jsm/loaders/OBJLoader */ "../optuna_dashboard/node_modules/three/examples/jsm/loaders/OBJLoader.js");
/* harmony import */ var three_examples_jsm_loaders_STLLoader__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! three/examples/jsm/loaders/STLLoader */ "../optuna_dashboard/node_modules/three/examples/jsm/loaders/STLLoader.js");










const isThreejsArtifact = (artifact) => {
    return (artifact.filename.endsWith(".stl") ||
        artifact.filename.endsWith(".3dm") ||
        artifact.filename.endsWith(".obj"));
};
const CustomGizmoHelper = () => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_react_three_drei__WEBPACK_IMPORTED_MODULE_1__.GizmoHelper, { alignment: "bottom-right", margin: [80, 80] },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_react_three_drei__WEBPACK_IMPORTED_MODULE_2__.GizmoViewport, { axisColors: ["red", "green", "skyblue"], labelColor: "black" })));
};
const computeBoundingBox = (geometries) => {
    const boundingBox = new three__WEBPACK_IMPORTED_MODULE_3__.Box3();
    geometries.forEach((geometry) => {
        const mesh = new three__WEBPACK_IMPORTED_MODULE_3__.Mesh(geometry);
        boundingBox.expandByObject(mesh);
    });
    return boundingBox;
};
const ThreejsArtifactViewer = (props) => {
    const [geometry, setGeometry] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
    const [boundingBox, setBoundingBox] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(new three__WEBPACK_IMPORTED_MODULE_3__.Box3(new three__WEBPACK_IMPORTED_MODULE_3__.Vector3(-10, -10, -10), new three__WEBPACK_IMPORTED_MODULE_3__.Vector3(10, 10, 10)));
    const [cameraSettings, setCameraSettings] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(new three__WEBPACK_IMPORTED_MODULE_3__.PerspectiveCamera());
    const handleLoadedGeometries = (geometries) => {
        setGeometry(geometries);
        const boundingBox = computeBoundingBox(geometries);
        if (boundingBox !== null) {
            setBoundingBox(boundingBox);
        }
        return boundingBox;
    };
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if ("stl" === props.filetype) {
            loadSTL(props, handleLoadedGeometries);
        }
        else if ("3dm" === props.filetype) {
            loadRhino3dm(props, handleLoadedGeometries);
        }
        else if ("obj" === props.filetype) {
            loadOBJ(props, handleLoadedGeometries);
        }
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        const cameraSet = new three__WEBPACK_IMPORTED_MODULE_3__.PerspectiveCamera(50, window.innerWidth / window.innerHeight, 0.1, boundingBox.getSize(new three__WEBPACK_IMPORTED_MODULE_3__.Vector3()).length() * 100);
        const maxPosition = Math.max(boundingBox.max.x, boundingBox.max.y, boundingBox.max.z);
        cameraSet.position.set(maxPosition * 1.5, maxPosition * 1.5, maxPosition * 1.5);
        const center = boundingBox.getCenter(new three__WEBPACK_IMPORTED_MODULE_3__.Vector3());
        cameraSet.lookAt(center.x, center.y, center.z);
        setCameraSettings(cameraSet);
    }, [boundingBox]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_react_three_fiber__WEBPACK_IMPORTED_MODULE_4__.Canvas, { frameloop: "demand", camera: cameraSettings, style: { width: props.width, height: props.height } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("ambientLight", null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_react_three_drei__WEBPACK_IMPORTED_MODULE_5__.OrbitControls, null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("gridHelper", { args: [Math.max(boundingBox.max.x, boundingBox.max.y) * 5] }),
        props.hasGizmo && react__WEBPACK_IMPORTED_MODULE_0___default().createElement(CustomGizmoHelper, null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("axesHelper", null),
        geometry.length > 0 &&
            geometry.map((geo, index) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("mesh", { key: index, geometry: geo },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("meshNormalMaterial", { side: three__WEBPACK_IMPORTED_MODULE_3__.DoubleSide }))))));
};
const useThreejsArtifactModal = () => {
    const [open, setOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [target, setTarget] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(["", null]);
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const openModal = (artifactUrlPath, artifact) => {
        setTarget([artifactUrlPath, artifact]);
        setOpen(true);
    };
    const renderDeleteStudyDialog = () => {
        var _a;
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { open: open, onClose: () => {
                setOpen(false);
                setTarget(["", null]);
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { component: "div", sx: {
                    position: "absolute",
                    top: "50%",
                    left: "50%",
                    transform: "translate(-50%, -50%)",
                    bgcolor: "background.paper",
                    borderRadius: "15px",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
                        position: "absolute",
                        top: theme.spacing(2),
                        right: theme.spacing(2),
                    }, onClick: () => {
                        setOpen(false);
                        setTarget(["", null]);
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_10__["default"], null)),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(ThreejsArtifactViewer, { src: target[0], width: `${innerWidth * 0.8}px`, height: `${innerHeight * 0.8}px`, hasGizmo: true, filetype: (_a = target[1]) === null || _a === void 0 ? void 0 : _a.filename.split(".").pop() }))));
    };
    return [openModal, renderDeleteStudyDialog];
};
function loadSTL(props, handleLoadedGeometries) {
    const stlLoader = new three_examples_jsm_loaders_STLLoader__WEBPACK_IMPORTED_MODULE_11__.STLLoader();
    stlLoader.load(props.src, (stlGeometries) => {
        if (stlGeometries) {
            handleLoadedGeometries([stlGeometries]);
        }
    });
}
function loadRhino3dm(props, handleLoadedGeometries) {
    const rhino3dmLoader = new three_examples_jsm_loaders_3DMLoader__WEBPACK_IMPORTED_MODULE_12__.Rhino3dmLoader();
    rhino3dmLoader.setLibraryPath("https://cdn.jsdelivr.net/npm/rhino3dm@8.4.0/");
    rhino3dmLoader.load(props.src, (object) => {
        const meshes = object.children;
        const rhinoGeometries = meshes.map((mesh) => mesh.geometry);
        three__WEBPACK_IMPORTED_MODULE_3__.Object3D.DEFAULT_UP.set(0, 0, 1);
        if (rhinoGeometries.length > 0) {
            handleLoadedGeometries(rhinoGeometries);
        }
    });
}
function loadOBJ(props, handleLoadedGeometries) {
    const objLoader = new three_examples_jsm_loaders_OBJLoader__WEBPACK_IMPORTED_MODULE_13__.OBJLoader();
    objLoader.load(props.src, (object) => {
        const meshes = object.children;
        const objGeometries = meshes.map((mesh) => mesh.geometry);
        if (objGeometries.length > 0) {
            handleLoadedGeometries(objGeometries);
        }
    });
}


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/TrialArtifactCards.js":
/*!*************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/TrialArtifactCards.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TrialArtifactCards: () => (/* binding */ TrialArtifactCards)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/icons-material/Delete */ "../tslib/react/node_modules/@mui/icons-material/esm/Delete.js");
/* harmony import */ var _mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/icons-material/Download */ "../tslib/react/node_modules/@mui/icons-material/esm/Download.js");
/* harmony import */ var _mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/icons-material/Fullscreen */ "../tslib/react/node_modules/@mui/icons-material/esm/Fullscreen.js");
/* harmony import */ var _mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/icons-material/UploadFile */ "../tslib/react/node_modules/@mui/icons-material/esm/UploadFile.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActionArea/CardActionArea.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ArtifactCardMedia */ "../optuna_dashboard/pkg/components/Artifact/ArtifactCardMedia.js");
/* harmony import */ var _DeleteArtifactDialog__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./DeleteArtifactDialog */ "../optuna_dashboard/pkg/components/Artifact/DeleteArtifactDialog.js");
/* harmony import */ var _TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./TableArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/TableArtifactViewer.js");
/* harmony import */ var _ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ThreejsArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js");











const TrialArtifactCards = ({ trial }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const [openDeleteArtifactDialog, renderDeleteArtifactDialog] = (0,_DeleteArtifactDialog__WEBPACK_IMPORTED_MODULE_3__.useDeleteTrialArtifactDialog)();
    const [openThreejsArtifactModal, renderThreejsArtifactModal] = (0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.useThreejsArtifactModal)();
    const [openTableArtifactModal, renderTableArtifactModal] = (0,_TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__.useTableArtifactModal)();
    const isArtifactModifiable = (trial) => {
        return trial.state === "Running" || trial.state === "Waiting";
    };
    const width = "200px";
    const height = "150px";
    const artifacts = [...trial.artifacts].sort((a, b) => {
        if (a.filename < b.filename) {
            return -1;
        }
        else if (a.filename > b.filename) {
            return 1;
        }
        else {
            return 0;
        }
    });
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { variant: "h5", sx: { fontWeight: theme.typography.fontWeightBold } }, "Artifacts"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { component: "div", sx: { display: "flex", flexWrap: "wrap", p: theme.spacing(1, 0) } },
            artifacts.map((artifact) => {
                const urlPath = `/artifacts/${trial.study_id}/${trial.trial_id}/${artifact.artifact_id}`;
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: artifact.artifact_id, sx: {
                        marginBottom: theme.spacing(2),
                        width: width,
                        margin: theme.spacing(0, 1, 1, 0),
                        display: "flex",
                        flexDirection: "column",
                        alignItems: "center",
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_2__.ArtifactCardMedia, { artifact: artifact, urlPath: urlPath, height: height }),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { sx: {
                            display: "flex",
                            flexDirection: "row",
                            padding: `${theme.spacing(1)} !important`,
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                                p: theme.spacing(0.5, 0),
                                flexGrow: 1,
                                wordBreak: "break-all",
                                maxWidth: `calc(100% - ${theme.spacing(4 +
                                    ((0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.isThreejsArtifact)(artifact) ? 4 : 0) +
                                    (isArtifactModifiable(trial) ? 4 : 0))})`,
                            } }, artifact.filename),
                        (0,_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_5__.isThreejsArtifact)(artifact) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "show artifact 3d model", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openThreejsArtifactModal(urlPath, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__["default"], null))) : null,
                        (0,_TableArtifactViewer__WEBPACK_IMPORTED_MODULE_4__.isTableArtifact)(artifact) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "show artifact table", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openTableArtifactModal(urlPath, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_12__["default"], null))) : null,
                        isArtifactModifiable(trial) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "delete artifact", size: "small", color: "inherit", sx: { margin: "auto 0" }, onClick: () => {
                                openDeleteArtifactDialog(trial.study_id, trial.trial_id, artifact);
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_13__["default"], null))) : null,
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { "aria-label": "download artifact", size: "small", color: "inherit", download: artifact.filename, sx: { margin: "auto 0" }, href: urlPath },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_14__["default"], null)))));
            }),
            isArtifactModifiable(trial) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(TrialArtifactUploader, { trial: trial, width: width, height: height })) : null),
        renderDeleteArtifactDialog(),
        renderThreejsArtifactModal(),
        renderTableArtifactModal()));
};
const TrialArtifactUploader = ({ trial, width, height }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [dragOver, setDragOver] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const inputRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)(null);
    const handleClick = () => {
        if (!inputRef || !inputRef.current) {
            return;
        }
        inputRef.current.click();
    };
    const handleOnChange = (e) => {
        const files = e.target.files;
        if (files === null) {
            return;
        }
        action.uploadTrialArtifact(trial.study_id, trial.trial_id, files[0]);
    };
    const handleDrop = (e) => {
        e.stopPropagation();
        e.preventDefault();
        const files = e.dataTransfer.files;
        setDragOver(false);
        for (let i = 0; i < files.length; i++) {
            action.uploadTrialArtifact(trial.study_id, trial.trial_id, files[i]);
        }
    };
    const handleDragOver = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(true);
    };
    const handleDragLeave = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(false);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
            marginBottom: theme.spacing(2),
            width: width,
            minHeight: height,
            margin: theme.spacing(0, 1, 1, 0),
            border: dragOver
                ? `3px dashed ${theme.palette.mode === "dark" ? "white" : "black"}`
                : `1px solid ${theme.palette.divider}`,
        }, onDragOver: handleDragOver, onDragLeave: handleDragLeave, onDrop: handleDrop },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { onClick: handleClick, sx: {
                height: "100%",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { sx: {
                    display: "flex",
                    height: "100%",
                    flexDirection: "column",
                    justifyContent: "center",
                    alignItems: "center",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_16__["default"], { sx: { fontSize: 80, marginBottom: theme.spacing(2) } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("input", { type: "file", ref: inputRef, onChange: handleOnChange, style: { display: "none" } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], null, "Upload a New File"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: { textAlign: "center", color: theme.palette.grey.A400 } }, "Drag your file here or click to browse.")))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Artifact/WaveSurferArtifactViewer.js":
/*!*******************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Artifact/WaveSurferArtifactViewer.js ***!
  \*******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   WaveSurferArtifactViewer: () => (/* binding */ WaveSurferArtifactViewer)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var wavesurfer_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! wavesurfer.js */ "../optuna_dashboard/node_modules/wavesurfer.js/dist/wavesurfer.esm.js");



const useWavesurfer = (containerRef, options) => {
    const [wavesurfer, setWavesurfer] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(null);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (!containerRef.current)
            return;
        const ws = wavesurfer_js__WEBPACK_IMPORTED_MODULE_1__["default"].create(Object.assign(Object.assign({}, options), { container: containerRef.current }));
        setWavesurfer(ws);
        return () => {
            ws.destroy();
        };
    }, [containerRef]);
    return wavesurfer;
};
// Create a React component of wavesurfer.
const WaveSurferArtifactViewer = (props) => {
    const containerRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)(null);
    const [isPlaying, setIsPlaying] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const wavesurfer = useWavesurfer(containerRef, props);
    const onPlayClick = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        if (!wavesurfer)
            return;
        wavesurfer.isPlaying() ? wavesurfer.pause() : wavesurfer.play();
    }, [wavesurfer]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (!wavesurfer)
            return;
        setIsPlaying(false);
        const subscriptions = [
            wavesurfer.on("play", () => setIsPlaying(true)),
            wavesurfer.on("pause", () => setIsPlaying(false)),
        ];
        return () => {
            subscriptions.forEach((unsub) => unsub());
        };
    }, [wavesurfer]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { component: "div", style: { width: "100%", display: "flex", flexDirection: "column" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { ref: containerRef, style: { minHeight: "120px", width: "100%" } }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { onClick: onPlayClick, style: { marginTop: "1em" } }, isPlaying ? "Pause" : "Play")));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/BestTrialsCard.js":
/*!************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/BestTrialsCard.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BestTrialsCard: () => (/* binding */ BestTrialsCard)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Link__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/icons-material/Link */ "../tslib/react/node_modules/@mui/icons-material/esm/Link.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Divider/Divider.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/List/List.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ListItem/ListItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ListItemButton/ListItemButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ListItemText/ListItemText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");





const useBestTrials = (studyDetail) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.best_trials) || [], [studyDetail]);
};
const BestTrialsCard = ({ studyDetail }) => {
    var _a;
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_1__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"])();
    const bestTrials = useBestTrials(studyDetail);
    let header = "Best Trials";
    let content = null;
    if (bestTrials.length === 1) {
        const bestTrial = bestTrials[0];
        header = `Best Trial (number=${bestTrial.number})`;
        content = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            !(studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.is_preferential) &&
                (bestTrial.values === undefined || bestTrial.values.length === 1 ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { variant: "h3", sx: {
                        fontWeight: theme.typography.fontWeightBold,
                        marginBottom: theme.spacing(2),
                    }, color: "secondary" }, bestTrial.values)) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], null,
                    "Objective Values = [", (_a = bestTrial.values) === null || _a === void 0 ? void 0 :
                    _a.join(", "),
                    "]"))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], null,
                "Params = [",
                bestTrial.params
                    .map((p) => `${p.name}: ${p.param_external_value}`)
                    .join(", "),
                "]"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Link__WEBPACK_IMPORTED_MODULE_5__["default"], null), component: react_router_dom__WEBPACK_IMPORTED_MODULE_6__.Link, to: `${url_prefix}/studies/${bestTrial.study_id}/trials?numbers=${bestTrial.number}`, sx: { margin: theme.spacing(1) } }, "Details")));
    }
    else if (bestTrials.length > 1) {
        content = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: { paddingBottom: theme.spacing(1) }, orientation: "horizontal" }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { component: "div", sx: {
                    overflow: "auto",
                    height: "450px",
                    width: "100%",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], null, bestTrials.map((trial) => {
                    var _a;
                    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { key: trial.number, disablePadding: true },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_6__.Link, to: url_prefix +
                                `/studies/${trial.study_id}/trials?numbers=${trial.number}`, sx: { flexDirection: "column", alignItems: "flex-start" } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { primary: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { variant: "h5" },
                                    "Trial ",
                                    trial.number) }),
                            (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.is_preferential) ? null : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], null,
                                "Objective Values = [", (_a = trial.values) === null || _a === void 0 ? void 0 :
                                _a.join(", "),
                                "]")),
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], null,
                                "Params = [",
                                trial.params
                                    .map((p) => `${p.name}: ${p.param_external_value}`)
                                    .join(", "),
                                "]"))));
                })))));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { sx: {
                display: "inline-content",
                flexDirection: "column",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold } }, header),
            content)));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/CompareStudies.js":
/*!************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/CompareStudies.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CompareStudies: () => (/* binding */ CompareStudies)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/icons-material/ChevronRight */ "../tslib/react/node_modules/@mui/icons-material/esm/ChevronRight.js");
/* harmony import */ var _mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/icons-material/Home */ "../tslib/react/node_modules/@mui/icons-material/esm/Home.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material_Chip__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material/Chip */ "../tslib/react/node_modules/@mui/material/Chip/Chip.js");
/* harmony import */ var _mui_material_Divider__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material/Divider */ "../tslib/react/node_modules/@mui/material/Divider/Divider.js");
/* harmony import */ var _mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/material/FormControlLabel */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material_Grid__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/material/Grid */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material_List__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material/List */ "../tslib/react/node_modules/@mui/material/List/List.js");
/* harmony import */ var _mui_material_ListItem__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material/ListItem */ "../tslib/react/node_modules/@mui/material/ListItem/ListItem.js");
/* harmony import */ var _mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/material/ListItemButton */ "../tslib/react/node_modules/@mui/material/ListItemButton/ListItemButton.js");
/* harmony import */ var _mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/material/ListItemText */ "../tslib/react/node_modules/@mui/material/ListItemText/ListItemText.js");
/* harmony import */ var _mui_material_ListSubheader__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material/ListSubheader */ "../tslib/react/node_modules/@mui/material/ListSubheader/ListSubheader.js");
/* harmony import */ var notistack__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! notistack */ "../optuna_dashboard/node_modules/notistack/notistack.esm.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _urlQuery__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../urlQuery */ "../optuna_dashboard/pkg/urlQuery.js");
/* harmony import */ var _AppDrawer__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./AppDrawer */ "../optuna_dashboard/pkg/components/AppDrawer.js");
/* harmony import */ var _GraphEdf__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./GraphEdf */ "../optuna_dashboard/pkg/components/GraphEdf.js");
/* harmony import */ var _GraphHistory__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./GraphHistory */ "../optuna_dashboard/pkg/components/GraphHistory.js");
























const useQueriedStudies = (studies, query) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => {
        const queried = query.get("ids");
        if (queried === null) {
            return [];
        }
        const ids = queried
            .split(",")
            .map((s) => parseInt(s))
            .filter((n) => !isNaN(n));
        return studies.filter((t) => ids.findIndex((n) => n === t.study_id) !== -1);
    }, [studies, query]);
};
const getStudyListLink = (ids, url_prefix) => {
    const base = url_prefix + "/compare-studies";
    if (ids.length > 0) {
        return base + "?ids=" + ids.map((n) => n.toString()).join(",");
    }
    return base;
};
const isEqualDirections = (array1, array2) => {
    let i = array1.length;
    if (i !== array2.length)
        return false;
    while (i--) {
        if (array1[i] !== array2[i])
            return false;
    }
    return true;
};
const CompareStudies = ({ toggleColorMode }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_4__.useConstants)();
    const { enqueueSnackbar } = (0,notistack__WEBPACK_IMPORTED_MODULE_0__.useSnackbar)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"])();
    const query = (0,_urlQuery__WEBPACK_IMPORTED_MODULE_6__.useQuery)();
    const navigate = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_11__.useNavigate)();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_3__.actionCreator)();
    const studies = (0,recoil__WEBPACK_IMPORTED_MODULE_2__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_5__.studySummariesState);
    const queried = useQueriedStudies(studies, query);
    const selected = (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => {
        return queried.length > 0 ? queried : studies.length > 0 ? [studies[0]] : [];
    }, [studies, query]);
    const studyListWidth = 200;
    const title = "Compare Studies (Experimental)";
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        action.updateStudySummaries();
    }, []);
    const toolbar = (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_13__.Link, to: url_prefix + "/", sx: { marginRight: theme.spacing(1) }, color: "inherit", title: "Return to the top page" },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_14__["default"], null)),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_15__["default"], { sx: { marginRight: theme.spacing(1) } }),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { noWrap: true, component: "div", sx: { fontWeight: theme.typography.fontWeightBold } }, title)));
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: { display: "flex" } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_AppDrawer__WEBPACK_IMPORTED_MODULE_7__.AppDrawer, { toggleColorMode: toggleColorMode, toolbar: toolbar },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", width: "100%" } },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: {
                        minWidth: studyListWidth,
                        overflow: "auto",
                        height: `calc(100vh - ${theme.spacing(8)})`,
                    } },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_List__WEBPACK_IMPORTED_MODULE_18__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_ListSubheader__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: { display: "flex", flexDirection: "row" } },
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { sx: { p: theme.spacing(1, 0) } }, "Compare studies with Shift+Click"),
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: { flexGrow: 1 } })),
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_20__["default"], null),
                        studies.map((study) => {
                            return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_21__["default"], { key: study.study_id, disablePadding: true },
                                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_22__["default"], { onClick: (e) => {
                                        if (e.shiftKey) {
                                            let next;
                                            const selectedIds = selected.map((s) => s.study_id);
                                            const alreadySelected = selectedIds.findIndex((n) => n === study.study_id) >= 0;
                                            if (alreadySelected) {
                                                next = selectedIds.filter((n) => n !== study.study_id);
                                            }
                                            else {
                                                if (selected.length > 0 &&
                                                    selected[0].directions.length !==
                                                        study.directions.length) {
                                                    enqueueSnackbar("You can only compare studies that has the same number of objectives.", {
                                                        variant: "info",
                                                    });
                                                    next = selectedIds;
                                                }
                                                else if (selected.length > 0 &&
                                                    !isEqualDirections(selected[0].directions, study.directions)) {
                                                    enqueueSnackbar("You can only compare studies that has the same directions.", {
                                                        variant: "info",
                                                    });
                                                    next = selectedIds;
                                                }
                                                else {
                                                    next = [...selectedIds, study.study_id];
                                                }
                                            }
                                            navigate(getStudyListLink(next, url_prefix));
                                        }
                                        else {
                                            navigate(getStudyListLink([study.study_id], url_prefix));
                                        }
                                    }, selected: selected.findIndex((s) => s.study_id === study.study_id) !== -1, sx: {
                                        display: "flex",
                                        flexDirection: "column",
                                        alignItems: "flex-start",
                                    } },
                                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_23__["default"], { primary: `${study.study_id}. ${study.study_name}` }),
                                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: {
                                            display: "flex",
                                            flexDirection: "row",
                                            width: "100%",
                                        } },
                                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_24__["default"], { color: "primary", label: study.directions.length === 1
                                                ? `${study.directions.length} objective`
                                                : `${study.directions.length} objectives`, size: "small", variant: "outlined" }),
                                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement("span", { style: { margin: theme.spacing(0.5) } }),
                                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_24__["default"], { color: "secondary", label: study.directions
                                                .map((d) => (d === "maximize" ? "max" : "min"))
                                                .join(", "), size: "small", variant: "outlined" })))));
                        }))),
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_20__["default"], { orientation: "vertical", flexItem: true }),
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: {
                        flexGrow: 1,
                        overflow: "auto",
                        height: `calc(100vh - ${theme.spacing(8)})`,
                    } },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", width: "100%" } },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(StudiesGraph, { studies: selected })))))));
};
const StudiesGraph = ({ studies }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_3__.actionCreator)();
    const studyDetails = (0,recoil__WEBPACK_IMPORTED_MODULE_2__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_5__.studyDetailsState);
    const [logScale, setLogScale] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
    const [includePruned, setIncludePruned] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(true);
    const handleLogScaleChange = () => {
        setLogScale(!logScale);
    };
    const handleIncludePrunedChange = () => {
        setIncludePruned(!includePruned);
    };
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        studies.forEach((study) => {
            action.updateStudyDetail(study.study_id);
        });
    }, [studies]);
    const showStudyDetails = studies.map((study) => studyDetails[study.study_id]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { component: "div", sx: { display: "flex", width: "100%", flexDirection: "column" } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], { component: "fieldset", sx: {
                display: "flex",
                flexDirection: "row",
                justifyContent: "flex-end",
                padding: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_26__["default"], { control: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_27__["default"], { checked: logScale, onChange: handleLogScaleChange, value: "enable" }), label: "Log y scale" }),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_26__["default"], { control: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_27__["default"], { checked: includePruned, onChange: handleIncludePrunedChange, value: "enable" }), label: "Include PRUNED trials" })),
        showStudyDetails !== null &&
            showStudyDetails.length > 0 &&
            showStudyDetails.every((s) => s) ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_28__["default"], { sx: {
                margin: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_29__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphHistory__WEBPACK_IMPORTED_MODULE_9__.GraphHistory, { studies: showStudyDetails, includePruned: includePruned, logScale: logScale })))) : null,
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_30__["default"], { container: true, spacing: 2, sx: { padding: theme.spacing(0, 2) } }, showStudyDetails !== null &&
            showStudyDetails.length > 0 &&
            showStudyDetails.every((s) => s)
            ? showStudyDetails[0].directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_30__["default"], { item: true, xs: 6, key: i },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_28__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_29__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphEdf__WEBPACK_IMPORTED_MODULE_8__.GraphEdf, { studies: showStudyDetails, objectiveId: i }))))))
            : null)));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/CreateStudyDialog.js":
/*!***************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/CreateStudyDialog.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useCreateStudyDialog: () => (/* binding */ useCreateStudyDialog)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Add__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/icons-material/Add */ "../tslib/react/node_modules/@mui/icons-material/esm/Add.js");
/* harmony import */ var _mui_icons_material_Remove__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/icons-material/Remove */ "../tslib/react/node_modules/@mui/icons-material/esm/Remove.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContentText/DialogContentText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _Debounce__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./Debounce */ "../optuna_dashboard/pkg/components/Debounce.js");








const useCreateStudyDialog = () => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const [newStudyName, setNewStudyName] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const [openNewStudyDialog, setOpenNewStudyDialog] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [directions, setDirections] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([
        "minimize",
    ]);
    const studies = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_3__.studySummariesState);
    const newStudyNameAlreadyUsed = studies.some((v) => v.study_name === newStudyName);
    const handleCloseNewStudyDialog = () => {
        setOpenNewStudyDialog(false);
        setNewStudyName("");
        setDirections(["minimize"]);
    };
    const handleCreateNewStudy = () => {
        action.createNewStudy(newStudyName, directions);
        setOpenNewStudyDialog(false);
        setNewStudyName("");
        setDirections(["minimize"]);
    };
    const openDialog = () => {
        setOpenNewStudyDialog(true);
    };
    const renderCreateNewStudyDialog = () => {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { open: openNewStudyDialog, onClose: () => {
                handleCloseNewStudyDialog();
            }, "aria-labelledby": "create-study-dialog-title" },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { id: "create-study-dialog-title" }, "New Study"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], null, "Please enter the study name and directions here."),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Debounce__WEBPACK_IMPORTED_MODULE_4__.DebouncedInputTextField, { onChange: (s) => {
                        setNewStudyName(s);
                    }, delay: 500, textFieldProps: {
                        autoFocus: true,
                        fullWidth: true,
                        error: newStudyNameAlreadyUsed,
                        helperText: newStudyNameAlreadyUsed
                            ? `"${newStudyName}" is already used`
                            : "",
                        label: "Study name",
                        type: "text",
                    } })),
            directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { key: i },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", fullWidth: true },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend" },
                        "Objective ",
                        i,
                        ":"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: directions[i], onChange: (e) => {
                            const newVal = [...directions];
                            newVal[i] = e.target.value;
                            setDirections(newVal);
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: "minimize" }, "Minimize"),
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: "maximize" }, "Maximize")))))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Add__WEBPACK_IMPORTED_MODULE_15__["default"], null), sx: { marginRight: theme.spacing(1) }, onClick: () => {
                        const newVal = [
                            ...directions,
                            "minimize",
                        ];
                        setDirections(newVal);
                    } }, "Add"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Remove__WEBPACK_IMPORTED_MODULE_16__["default"], null), sx: { marginRight: theme.spacing(1) }, disabled: directions.length <= 1, onClick: () => {
                        const newVal = [...directions];
                        newVal.pop();
                        setDirections(newVal);
                    } }, "Remove")),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { onClick: handleCloseNewStudyDialog, color: "primary" }, "Cancel"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { onClick: handleCreateNewStudy, color: "primary", disabled: newStudyName === "" ||
                        newStudyNameAlreadyUsed ||
                        directions.length === 0 }, "Create"))));
    };
    return [openDialog, renderCreateNewStudyDialog];
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Debounce.js":
/*!******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Debounce.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DebouncedInputTextField: () => (/* binding */ DebouncedInputTextField)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


// TODO(c-bata): Remove this and use `useDeferredValue` instead.
const DebouncedInputTextField = ({ onChange, delay, textFieldProps }) => {
    const [text, setText] = react__WEBPACK_IMPORTED_MODULE_0___default().useState("");
    const [valid, setValidity] = react__WEBPACK_IMPORTED_MODULE_0___default().useState(true);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        const timer = setTimeout(() => {
            onChange(text, valid);
        }, delay);
        return () => {
            clearTimeout(timer);
        };
    }, [text, delay]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"], Object.assign({ onChange: (e) => {
            setText(e.target.value);
            setValidity(e.target.validity.valid);
        } }, textFieldProps)));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/DeleteStudyDialog.js":
/*!***************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/DeleteStudyDialog.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useDeleteStudyDialog: () => (/* binding */ useDeleteStudyDialog)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContentText/DialogContentText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Checkbox/Checkbox.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Alert/Alert.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");





const useDeleteStudyDialog = () => {
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const artifactIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_3__.artifactIsAvailable);
    const [openDeleteStudyDialog, setOpenDeleteStudyDialog] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [deleteStudyID, setDeleteStudyID] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(-1);
    const [removeAssociatedArtifacts, setRemoveAssociatedArtifacts] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const handleCloseDeleteStudyDialog = () => {
        setOpenDeleteStudyDialog(false);
        setDeleteStudyID(-1);
        setRemoveAssociatedArtifacts(false);
    };
    const handleDeleteStudy = () => {
        action.deleteStudy(deleteStudyID, removeAssociatedArtifacts);
        handleCloseDeleteStudyDialog();
    };
    const openDialog = (studyId) => {
        setDeleteStudyID(studyId);
        setOpenDeleteStudyDialog(true);
    };
    const renderDeleteStudyDialog = () => {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { open: openDeleteStudyDialog, onClose: () => {
                handleCloseDeleteStudyDialog();
            }, "aria-labelledby": "delete-study-dialog-title", fullWidth: true, maxWidth: "xs" },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { id: "delete-study-dialog-title" }, "Delete study"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], null,
                    "Are you sure you want to delete a study (id=",
                    deleteStudyID,
                    ")?"),
                artifactIsAvailable && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { label: "Remove associated trial/study artifacts.", control: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { checked: removeAssociatedArtifacts, onChange: () => setRemoveAssociatedArtifacts((cur) => !cur) }) }),
                    removeAssociatedArtifacts && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { severity: "warning" }, "If artifacts are linked to another study or trial, they will no longer be accessible from that study or trial as well."))))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { onClick: handleCloseDeleteStudyDialog, color: "primary" }, "No"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { onClick: handleDeleteStudy, color: "primary" }, "Yes"))));
    };
    return [openDialog, renderDeleteStudyDialog];
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphContour.js":
/*!**********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphContour.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Contour: () => (/* binding */ Contour)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Stack/Stack.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Link/Link.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material_colors_blue__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material/colors/blue */ "../tslib/react/node_modules/@mui/material/colors/blue.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _graphUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../graphUtil */ "../optuna_dashboard/pkg/graphUtil.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");










const plotDomId = "graph-contour";
const CONTOUR_DISABLED_THRESHOLD = 100;
const Contour = ({ study = null }) => {
    const isBackendRender = (0,_state__WEBPACK_IMPORTED_MODULE_6__.useBackendRender)();
    const [loadAnyway, setLoadAnyway] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(false);
    const shouldContourDisabled = (0,react__WEBPACK_IMPORTED_MODULE_2__.useMemo)(() => { var _a; return ((_a = study === null || study === void 0 ? void 0 : study.trials.length) !== null && _a !== void 0 ? _a : 0) > CONTOUR_DISABLED_THRESHOLD; }, [study]);
    if (shouldContourDisabled && !loadAnyway) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(DisabledContour, { onLoadAnywayClicked: () => setLoadAnyway(true) });
    }
    if (isBackendRender) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(ContourBackend, { study: study });
    }
    return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(ContourFrontend, { study: study });
};
const DisabledContour = ({ onLoadAnywayClicked }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { component: "div", id: plotDomId },
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold } }, "Contour"),
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { direction: "column", spacing: 1, alignItems: "center", sx: {
                margin: "1em 0",
            } },
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "body1", color: theme.palette.grey[700] }, "High number of trials makes processing this plot slow; disabled by default."),
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "button", sx: { fontWeight: theme.typography.fontWeightBold }, onClick: onLoadAnywayClicked }, "Load plot anyway"))));
};
const ContourBackend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.Contour,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (data && layout && graphComponentState !== "componentWillMount") {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, data, layout).then(notifyGraphDidRender);
        }
    }, [data, layout, graphComponentState]);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }));
};
const ContourFrontend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_6__.usePlotlyColorTheme)(theme.palette.mode);
    const [objectiveId, setObjectiveId] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(0);
    const searchSpace = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useMergedUnionSearchSpace)(study === null || study === void 0 ? void 0 : study.union_search_space);
    const [xParam, setXParam] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(null);
    const [yParam, setYParam] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(null);
    const metricNames = (study === null || study === void 0 ? void 0 : study.metric_names) || [];
    if (xParam === null && searchSpace.length > 0) {
        setXParam(searchSpace[0]);
    }
    if (yParam === null && searchSpace.length > 1) {
        setYParam(searchSpace[1]);
    }
    const handleObjectiveChange = (event) => {
        setObjectiveId(event.target.value);
    };
    const handleXParamChange = (event) => {
        const param = searchSpace.find((s) => s.name === event.target.value);
        setXParam(param || null);
    };
    const handleYParamChange = (event) => {
        const param = searchSpace.find((s) => s.name === event.target.value);
        setYParam(param || null);
    };
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        var _a;
        if (study != null && graphComponentState !== "componentWillMount") {
            (_a = plotContour(study, objectiveId, xParam, yParam, colorTheme)) === null || _a === void 0 ? void 0 : _a.then(notifyGraphDidRender);
        }
    }, [study, objectiveId, xParam, yParam, colorTheme, graphComponentState]);
    const space = study ? study.union_search_space : [];
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { container: true, direction: "row" },
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { item: true, xs: 3, container: true, direction: "column", sx: { paddingRight: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold } }, "Contour"),
            study !== null && study.directions.length !== 1 ? (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: "fieldset" },
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "legend" }, "Objective:"),
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: objectiveId, onChange: handleObjectiveChange }, study.directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { value: i, key: i }, metricNames.length === (study === null || study === void 0 ? void 0 : study.directions.length)
                    ? metricNames[i]
                    : `${i}`)))))) : null,
            study !== null && space.length > 0 ? (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { container: true, direction: "column", gap: 1 },
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: "fieldset", fullWidth: true },
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "legend" }, "x:"),
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: (xParam === null || xParam === void 0 ? void 0 : xParam.name) || "", onChange: handleXParamChange }, space.map((d) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { value: d.name, key: d.name }, d.name))))),
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: "fieldset", fullWidth: true },
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "legend" }, "y:"),
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: (yParam === null || yParam === void 0 ? void 0 : yParam.name) || "", onChange: handleYParamChange }, space.map((d) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { value: d.name, key: d.name }, d.name))))))) : null),
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { item: true, xs: 9 },
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }))));
};
const filterFunc = (trial) => {
    return trial.state === "Complete" && trial.values !== undefined;
};
const plotContour = (study, objectiveId, xParam, yParam, colorTheme) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    const trials = study ? study.trials : [];
    const filteredTrials = trials.filter((t) => filterFunc(t));
    if (filteredTrials.length < 2 || xParam === null || yParam === null) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], {
            template: colorTheme,
        });
    }
    const xAxis = (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.getAxisInfo)(trials, xParam);
    const yAxis = (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.getAxisInfo)(trials, yParam);
    const xIndices = xAxis.indices;
    const yIndices = yAxis.indices;
    const layout = {
        xaxis: {
            title: xParam.name,
            type: xAxis.isCat ? "category" : xAxis.isLog ? "log" : "linear",
        },
        yaxis: {
            title: yParam.name,
            type: yAxis.isCat ? "category" : yAxis.isLog ? "log" : "linear",
        },
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 50,
        },
        uirevision: "true",
        template: colorTheme,
    };
    // TODO(c-bata): Support parameters that only have the single value
    if (xIndices.length <= 1 || yIndices.length <= 1) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], layout);
    }
    const xValues = [];
    const yValues = [];
    const zValues = new Array(yIndices.length);
    const feasibleXY = new Set();
    for (let j = 0; j < yIndices.length; j++) {
        zValues[j] = new Array(xIndices.length).fill(null);
    }
    filteredTrials.forEach((trial, i) => {
        if (xAxis.values[i] && yAxis.values[i] && trial.values) {
            if (trial.constraints.every((c) => c <= 0)) {
                feasibleXY.add(xValues.length);
            }
            const xValue = xAxis.values[i];
            const yValue = yAxis.values[i];
            xValues.push(xValue);
            yValues.push(yValue);
            const xi = xIndices.indexOf(xValue);
            const yi = yIndices.indexOf(yValue);
            const zValue = trial.values[objectiveId];
            zValues[yi][xi] = zValue;
        }
    });
    if (!study.is_preferential) {
        const plotData = [
            {
                type: "contour",
                x: xIndices,
                y: yIndices,
                z: zValues,
                colorscale: "Blues",
                connectgaps: true,
                hoverinfo: "none",
                line: {
                    smoothing: 1.3,
                },
                reversescale: study.directions[objectiveId] !== "minimize",
                // https://github.com/plotly/react-plotly.js/issues/251
                // @ts-ignore
                contours: {
                    coloring: "heatmap",
                },
            },
            {
                type: "scatter",
                x: xValues.filter((_, i) => feasibleXY.has(i)),
                y: yValues.filter((_, i) => feasibleXY.has(i)),
                marker: { line: { width: 2.0, color: "Grey" }, color: "black" },
                mode: "markers",
                showlegend: false,
            },
            {
                type: "scatter",
                x: xValues.filter((_, i) => !feasibleXY.has(i)),
                y: yValues.filter((_, i) => !feasibleXY.has(i)),
                marker: { line: { width: 2.0, color: "Grey" }, color: "#cccccc" },
                mode: "markers",
                showlegend: false,
            },
        ];
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
    }
    layout.legend = {
        y: 0.8,
    };
    const bestTrialIndices = study.best_trials.map((trial) => trial.number);
    const plotData = [
        {
            type: "scatter",
            x: xValues.filter((_, i) => bestTrialIndices.includes(i)),
            y: yValues.filter((_, i) => bestTrialIndices.includes(i)),
            marker: {
                line: { width: 2.0, color: "Grey" },
                color: _mui_material_colors_blue__WEBPACK_IMPORTED_MODULE_17__["default"][200],
            },
            name: "best trials",
            mode: "markers",
        },
        {
            type: "scatter",
            x: xValues.filter((_, i) => !bestTrialIndices.includes(i)),
            y: yValues.filter((_, i) => !bestTrialIndices.includes(i)),
            marker: { line: { width: 2.0, color: "Grey" }, color: "black" },
            name: "others",
            mode: "markers",
        },
    ];
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphEdf.js":
/*!******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphEdf.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphEdf: () => (/* binding */ GraphEdf)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _apiClientProvider__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../apiClientProvider */ "../optuna_dashboard/pkg/apiClientProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");







const GraphEdf = ({ studies, objectiveId }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_5__.usePlotlyColorTheme)(theme.palette.mode);
    if ((0,_state__WEBPACK_IMPORTED_MODULE_5__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphEdfBackend, { studies: studies });
    }
    else {
        return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotEdf, { studies: studies, objectiveId: objectiveId, colorTheme: colorTheme }));
    }
};
const domId = "graph-edf";
const GraphEdfBackend = ({ studies }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_5__.usePlotlyColorTheme)(theme.palette.mode);
    const { apiClient } = (0,_apiClientProvider__WEBPACK_IMPORTED_MODULE_4__.useAPIClient)();
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const studyIds = studies.map((s) => s.id);
    const numCompletedTrials = studies.reduce((acc, study) => acc + (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length), 0);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (studyIds.length === 0) {
            return;
        }
        if (graphComponentState !== "componentWillMount") {
            apiClient
                .getCompareStudiesPlot(studyIds, _apiClient__WEBPACK_IMPORTED_MODULE_3__.CompareStudiesPlotType.EDF)
                .then(({ data, layout }) => {
                plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, data, Object.assign(Object.assign({}, layout), { template: colorTheme }))
                    .then(notifyGraphDidRender);
            })
                .catch((err) => {
                console.error(err);
            });
        }
    }, [studyIds, numCompletedTrials, graphComponentState]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: domId, graphComponentState: graphComponentState }));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphHistory.js":
/*!**********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphHistory.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphHistory: () => (/* binding */ GraphHistory)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");






const GraphHistory = ({ studies, logScale, includePruned }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_2__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_3__.usePlotlyColorTheme)(theme.palette.mode);
    const linkURL = (studyId, trialNumber) => {
        return url_prefix + `/studies/${studyId}/trials?numbers=${trialNumber}`;
    };
    const navigate = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_5__.useNavigate)();
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotHistory, { studies: studies, logScale: logScale, includePruned: includePruned, colorTheme: colorTheme, linkURL: linkURL, router: navigate }));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphHyperparameterImportances.js":
/*!****************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphHyperparameterImportances.js ***!
  \****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphHyperparameterImportance: () => (/* binding */ GraphHyperparameterImportance)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _hooks_useParamImportance__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../hooks/useParamImportance */ "../optuna_dashboard/pkg/hooks/useParamImportance.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");








const plotDomId = "graph-hyperparameter-importances";
const GraphHyperparameterImportance = ({ studyId, study = null, graphHeight }) => {
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { importances } = (0,_hooks_useParamImportance__WEBPACK_IMPORTED_MODULE_4__.useParamImportance)({
        numCompletedTrials,
        studyId,
    });
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_6__.usePlotlyColorTheme)(theme.palette.mode);
    if ((0,_state__WEBPACK_IMPORTED_MODULE_6__.useBackendRender)()) {
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(GraphHyperparameterImportanceBackend, { studyId: studyId, study: study, graphHeight: graphHeight }));
    }
    else {
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_2__.PlotImportance, { study: study, importance: importances, graphHeight: graphHeight, colorTheme: colorTheme }))));
    }
};
const GraphHyperparameterImportanceBackend = ({ studyId, study = null, graphHeight }) => {
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.ParamImportances,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (data && layout) {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__.react(plotDomId, data, layout);
        }
    }, [data, layout]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", id: plotDomId, sx: { height: graphHeight } });
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphIntermediateValues.js":
/*!*********************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphIntermediateValues.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphIntermediateValues: () => (/* binding */ GraphIntermediateValues)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");




const GraphIntermediateValues = ({ trials, includePruned, logScale }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_2__.usePlotlyColorTheme)(theme.palette.mode);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], null,
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotIntermediateValues, { trials: trials, includePruned: includePruned, logScale: logScale, colorTheme: colorTheme }))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphParallelCoordinate.js":
/*!*********************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphParallelCoordinate.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphParallelCoordinate: () => (/* binding */ GraphParallelCoordinate)
/* harmony export */ });
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");






const plotDomId = "graph-parallel-coordinate";
const GraphParallelCoordinate = ({ study = null }) => {
    if ((0,_state__WEBPACK_IMPORTED_MODULE_5__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphParallelCoordinateBackend, { study: study });
    }
    else {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotParallelCoordinate, { study: study });
    }
};
const GraphParallelCoordinateBackend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_4__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.ParallelCoordinate,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (data && layout && graphComponentState !== "componentWillMount") {
            try {
                plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, data, layout).then(notifyGraphDidRender);
            }
            catch (err) {
                console.error(err);
            }
        }
    }, [data, layout, graphComponentState]);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphParetoFront.js":
/*!**************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphParetoFront.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphParetoFront: () => (/* binding */ GraphParetoFront)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _graphUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../graphUtil */ "../optuna_dashboard/pkg/graphUtil.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");










const plotDomId = "graph-pareto-front";
const GraphParetoFront = ({ study = null }) => {
    if ((0,_state__WEBPACK_IMPORTED_MODULE_6__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(GraphParetoFrontBackend, { study: study });
    }
    else {
        return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(GraphParetoFrontFrontend, { study: study });
    }
};
const GraphParetoFrontBackend = ({ study = null }) => {
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_2__.PlotType.ParetoFront,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (data && layout) {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__.react(plotDomId, data, layout);
        }
    }, [data, layout]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { component: "div", id: plotDomId, sx: { height: "450px" } });
};
const GraphParetoFrontFrontend = ({ study = null }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_3__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_6__.usePlotlyColorTheme)(theme.palette.mode);
    const navigate = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_9__.useNavigate)();
    const [objectiveXId, setObjectiveXId] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(0);
    const [objectiveYId, setObjectiveYId] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(1);
    const metricNames = (study === null || study === void 0 ? void 0 : study.metric_names) || [];
    const handleObjectiveXChange = (event) => {
        setObjectiveXId(event.target.value);
    };
    const handleObjectiveYChange = (event) => {
        setObjectiveYId(event.target.value);
    };
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (study != null) {
            plotParetoFront(study, objectiveXId, objectiveYId, theme.palette.mode, colorTheme);
            const element = document.getElementById(plotDomId);
            if (element != null) {
                // @ts-ignore
                element.on("plotly_click", (data) => {
                    const plotTextInfo = JSON.parse(data.points[0].text.replace(/<br>/g, ""));
                    navigate(url_prefix +
                        `/studies/${study.id}/trials?numbers=${plotTextInfo.number}`);
                });
                return () => {
                    // @ts-ignore
                    element.removeAllListeners("plotly_click");
                };
            }
        }
    }, [study, objectiveXId, objectiveYId, theme.palette.mode, colorTheme]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { container: true, direction: "row" },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { item: true, xs: 3, container: true, direction: "column", sx: { paddingRight: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold } }, "Pareto Front"),
            study !== null && study.directions.length !== 1 ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null,
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "fieldset" },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: "legend" }, "Objective X:"),
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { value: objectiveXId, onChange: handleObjectiveXChange }, study.directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: i, key: i }, metricNames.length === (study === null || study === void 0 ? void 0 : study.directions.length)
                        ? metricNames[i]
                        : `${i}`))))),
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "fieldset" },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: "legend" }, "Objective Y:"),
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { value: objectiveYId, onChange: handleObjectiveYChange }, study.directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: i, key: i }, metricNames.length === (study === null || study === void 0 ? void 0 : study.directions.length)
                        ? metricNames[i]
                        : `${i}`))))))) : null),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { item: true, xs: 9 },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { component: "div", id: plotDomId, sx: {
                    height: "450px",
                } }))));
};
const filterFunc = (trial, directions) => {
    return (trial.state === "Complete" &&
        trial.values !== undefined &&
        trial.values.length === directions.length);
};
const makeScatterObject = (trials, objectiveXId, objectiveYId, hovertemplate, dominated, feasible, mode) => {
    const marker = makeMarker(trials, dominated, feasible, mode);
    return {
        x: trials.map((t) => t.values ? t.values[objectiveXId] : null),
        y: trials.map((t) => t.values ? t.values[objectiveYId] : null),
        text: trials.map((t) => (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.makeHovertext)(t)),
        mode: "markers",
        hovertemplate: hovertemplate,
        marker: marker,
        showlegend: false,
    };
};
const makeMarker = (trials, dominated, feasible, mode) => {
    if (feasible && dominated) {
        return {
            line: { width: 0.5, color: "Grey" },
            // @ts-ignore
            color: trials.map((t) => t.number),
            colorscale: "Blues",
            reversescale: true,
            colorbar: {
                title: "Trial",
            },
        };
    }
    else if (feasible && !dominated) {
        return {
            line: { width: 0.5, color: "Grey" },
            // @ts-ignore
            color: trials.map((t) => t.number),
            colorscale: "Reds",
            colorbar: {
                title: "Best Trial",
                x: 1.1,
                xpad: 80,
            },
        };
    }
    else {
        return {
            // @ts-ignore
            color: mode === "dark" ? "#666666" : "#cccccc",
        };
    }
};
const getIsDominatedND = (normalizedValues) => {
    // Fallback for straight-forward pareto front algorithm (O(N^2) complexity).
    const isDominated = [];
    normalizedValues.forEach((values0) => {
        const dominated = normalizedValues.some((values1) => {
            if (values0.every((value0, k) => values1[k] === value0)) {
                return false;
            }
            return values0.every((value0, k) => values1[k] <= value0);
        });
        isDominated.push(dominated);
    });
    return isDominated;
};
const getIsDominated2D = (normalizedValues) => {
    // Fast pareto front algorithm (O(N log N) complexity).
    const sorted = normalizedValues
        .map((values, i) => [values[0], values[1], i])
        .sort((a, b) => a[0] > b[0]
        ? 1
        : a[0] < b[0]
            ? -1
            : a[1] > b[1]
                ? 1
                : a[1] < b[1]
                    ? -1
                    : 0);
    let maxValueSeen0 = sorted[0][0];
    let minValueSeen1 = sorted[0][1];
    const isDominated = new Array(normalizedValues.length).fill(false);
    sorted.forEach((values) => {
        if (values[1] > minValueSeen1 ||
            (values[1] === minValueSeen1 && values[0] > maxValueSeen0)) {
            isDominated[values[2]] = true;
        }
        else {
            minValueSeen1 = values[1];
        }
        maxValueSeen0 = values[0];
    });
    return isDominated;
};
const getIsDominated1D = (normalizedValues) => {
    const best_value = Math.min(...normalizedValues.map((values) => values[0]));
    return normalizedValues.map((values) => values[0] !== best_value);
};
const getIsDominated = (normalizedValues) => {
    if (normalizedValues.length === 0) {
        return [];
    }
    if (normalizedValues[0].length === 1) {
        return getIsDominated1D(normalizedValues);
    }
    else if (normalizedValues[0].length === 2) {
        return getIsDominated2D(normalizedValues);
    }
    else {
        return getIsDominatedND(normalizedValues);
    }
};
const plotParetoFront = (study, objectiveXId, objectiveYId, mode, colorTheme) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    const layout = {
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 0,
        },
        template: colorTheme,
        uirevision: "true",
    };
    const trials = study ? study.trials : [];
    const filteredTrials = trials.filter((t) => filterFunc(t, study.directions));
    if (filteredTrials.length === 0) {
        plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__.react(plotDomId, [], layout);
        return;
    }
    const feasibleTrials = [];
    const infeasibleTrials = [];
    filteredTrials.forEach((t) => {
        if (t.constraints.every((c) => c <= 0)) {
            feasibleTrials.push(t);
        }
        else {
            infeasibleTrials.push(t);
        }
    });
    const normalizedValues = [];
    feasibleTrials.forEach((t) => {
        if (t.values && t.values.length === study.directions.length) {
            const trialValues = t.values.map((v, i) => {
                return study.directions[i] === "minimize"
                    ? v
                    : -v;
            });
            normalizedValues.push(trialValues);
        }
    });
    const isDominated = getIsDominated(normalizedValues);
    const plotData = [
        makeScatterObject(feasibleTrials.filter((t, i) => isDominated[i]), objectiveXId, objectiveYId, infeasibleTrials.length === 0
            ? "%{text}<extra>Trial</extra>"
            : "%{text}<extra>Feasible Trial</extra>", true, true, mode),
        makeScatterObject(feasibleTrials.filter((t, i) => !isDominated[i]), objectiveXId, objectiveYId, "%{text}<extra>Best Trial</extra>", false, true, mode),
        makeScatterObject(infeasibleTrials, objectiveXId, objectiveYId, "%{text}<extra>Infeasible Trial</extra>", false, false, mode),
    ];
    plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__.react(plotDomId, plotData, layout);
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphRank.js":
/*!*******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphRank.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphRank: () => (/* binding */ GraphRank)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _graphUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../graphUtil */ "../optuna_dashboard/pkg/graphUtil.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");








const plotDomId = "graph-rank";
const GraphRank = ({ study = null }) => {
    if ((0,_state__WEBPACK_IMPORTED_MODULE_6__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphRankBackend, { study: study });
    }
    else {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphRankFrontend, { study: study });
    }
};
const GraphRankBackend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.Rank,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (data && layout && graphComponentState !== "componentWillMount") {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, data, layout).then(notifyGraphDidRender);
        }
    }, [data, layout, graphComponentState]);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }));
};
const GraphRankFrontend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_6__.usePlotlyColorTheme)(theme.palette.mode);
    const [objectiveId, setobjectiveId] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(0);
    const searchSpace = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useMergedUnionSearchSpace)(study === null || study === void 0 ? void 0 : study.union_search_space);
    const [xParam, setXParam] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(null);
    const [yParam, setYParam] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(null);
    const metricNames = (study === null || study === void 0 ? void 0 : study.metric_names) || [];
    if (xParam === null && searchSpace.length > 0) {
        setXParam(searchSpace[0]);
    }
    if (yParam === null && searchSpace.length > 1) {
        setYParam(searchSpace[1]);
    }
    const handleObjectiveChange = (event) => {
        setobjectiveId(Number(event.target.value));
    };
    const handleXParamChange = (event) => {
        const param = searchSpace.find((item) => item.name === event.target.value);
        setXParam(param || null);
    };
    const handleYParamChange = (event) => {
        const param = searchSpace.find((item) => item.name === event.target.value);
        setYParam(param || null);
    };
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        var _a;
        if (study != null && graphComponentState !== "componentWillMount") {
            const rankPlotInfo = getRankPlotInfo(study, objectiveId, xParam, yParam);
            (_a = plotRank(rankPlotInfo, colorTheme)) === null || _a === void 0 ? void 0 : _a.then(notifyGraphDidRender);
        }
    }, [
        study,
        objectiveId,
        xParam,
        yParam,
        theme.palette.mode,
        colorTheme,
        graphComponentState,
    ]);
    const space = study ? study.union_search_space : [];
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { container: true, direction: "row" },
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 3, container: true, direction: "column", sx: { paddingRight: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold } }, "Rank"),
            study !== null && study.directions.length !== 1 ? (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset" },
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend" }, "Objective:"),
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: objectiveId, onChange: handleObjectiveChange }, study.directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: i, key: i }, metricNames.length === (study === null || study === void 0 ? void 0 : study.directions.length)
                    ? metricNames[i]
                    : `${i}`)))))) : null,
            study !== null && space.length > 0 ? (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { container: true, direction: "column", gap: 1 },
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", fullWidth: true },
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend" }, "x:"),
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: (xParam === null || xParam === void 0 ? void 0 : xParam.name) || "", onChange: handleXParamChange }, space.map((d) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: d.name, key: d.name }, d.name))))),
                react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", fullWidth: true },
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend" }, "y:"),
                    react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: (yParam === null || yParam === void 0 ? void 0 : yParam.name) || "", onChange: handleYParamChange }, space.map((d) => (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: d.name, key: d.name }, d.name))))))) : null),
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 9 },
            react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }))));
};
const getRankPlotInfo = (study, objectiveId, xParam, yParam) => {
    if (study === null) {
        return null;
    }
    const trials = study.trials;
    const filteredTrials = trials.filter(filterFunc);
    if (filteredTrials.length < 2 || xParam === null || yParam === null) {
        return null;
    }
    const xAxis = (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.getAxisInfo)(filteredTrials, xParam);
    const yAxis = (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.getAxisInfo)(filteredTrials, yParam);
    let xValues = [];
    let yValues = [];
    const zValues = [];
    const isFeasible = [];
    const hovertext = [];
    filteredTrials.forEach((trial, i) => {
        const xValue = xAxis.values[i];
        const yValue = yAxis.values[i];
        if (xValue && yValue && trial.values) {
            xValues.push(xValue);
            yValues.push(yValue);
            const zValue = trial.values[objectiveId];
            zValues.push(zValue);
            const feasibility = trial.constraints.every((c) => c <= 0);
            isFeasible.push(feasibility);
            hovertext.push((0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.makeHovertext)(trial));
        }
    });
    const colors = getColors(zValues);
    if (xAxis.isCat && !yAxis.isCat) {
        const indices = Array.from(Array(xValues.length).keys()).sort((a, b) => xValues[a]
            .toString()
            .toLowerCase()
            .localeCompare(xValues[b].toString().toLowerCase()));
        xValues = indices.map((i) => xValues[i]);
        yValues = indices.map((i) => yValues[i]);
    }
    else if (!xAxis.isCat && yAxis.isCat) {
        const indices = Array.from(Array(yValues.length).keys()).sort((a, b) => yValues[a]
            .toString()
            .toLowerCase()
            .localeCompare(yValues[b].toString().toLowerCase()));
        xValues = indices.map((i) => xValues[i]);
        yValues = indices.map((i) => yValues[i]);
    }
    else if (xAxis.isCat && yAxis.isCat) {
        const indices = Array.from(Array(xValues.length).keys()).sort((a, b) => {
            const xComp = xValues[a]
                .toString()
                .toLowerCase()
                .localeCompare(xValues[b].toString().toLowerCase());
            if (xComp !== 0) {
                return xComp;
            }
            return yValues[a]
                .toString()
                .toLowerCase()
                .localeCompare(yValues[b].toString().toLowerCase());
        });
        xValues = indices.map((i) => xValues[i]);
        yValues = indices.map((i) => yValues[i]);
    }
    return {
        xtitle: xAxis.name,
        ytitle: yAxis.name,
        xtype: xAxis.isCat ? "category" : xAxis.isLog ? "log" : "linear",
        ytype: yAxis.isCat ? "category" : yAxis.isLog ? "log" : "linear",
        xvalues: xValues,
        yvalues: yValues,
        colors,
        is_feasible: isFeasible,
        hovertext,
    };
};
const filterFunc = (trial) => {
    return trial.state === "Complete" && trial.values !== undefined;
};
const getColors = (values) => {
    const rawRanks = getOrderWithSameOrderAveraging(values);
    let colorIdxs = [];
    if (values.length > 2) {
        colorIdxs = rawRanks.map((rank) => rank / (values.length - 1));
    }
    else {
        colorIdxs = [0.5];
    }
    return colorIdxs;
};
const getOrderWithSameOrderAveraging = (values) => {
    const sortedValues = values.slice().sort((a, b) => a - b);
    const ranks = [];
    values.forEach((value) => {
        const firstIndex = sortedValues.indexOf(value);
        const lastIndex = sortedValues.lastIndexOf(value);
        const sumOfTheValue = ((firstIndex + lastIndex) * (lastIndex - firstIndex + 1)) / 2;
        const rank = sumOfTheValue / (lastIndex - firstIndex + 1);
        ranks.push(rank);
    });
    return ranks;
};
const plotRank = (rankPlotInfo, colorTheme) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    if (rankPlotInfo === null) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], {
            template: colorTheme,
        });
    }
    const layout = {
        xaxis: {
            title: rankPlotInfo.xtitle,
            type: rankPlotInfo.xtype,
        },
        yaxis: {
            title: rankPlotInfo.ytitle,
            type: rankPlotInfo.ytype,
        },
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 50,
        },
        uirevision: "true",
        template: colorTheme,
    };
    const xValues = rankPlotInfo.xvalues;
    const yValues = rankPlotInfo.yvalues;
    const plotData = [
        {
            type: "scatter",
            x: xValues.filter((_, i) => rankPlotInfo.is_feasible[i]),
            y: yValues.filter((_, i) => rankPlotInfo.is_feasible[i]),
            marker: {
                color: rankPlotInfo.colors.filter((_, i) => rankPlotInfo.is_feasible[i]),
                colorscale: "Portland",
                colorbar: {
                    title: "Rank",
                },
                size: 10,
                line: {
                    color: "Grey",
                    width: 0.5,
                },
            },
            mode: "markers",
            showlegend: false,
            hovertemplate: "%{hovertext}<extra></extra>",
            hovertext: rankPlotInfo.hovertext.filter((_, i) => rankPlotInfo.is_feasible[i]),
        },
        {
            type: "scatter",
            x: xValues.filter((_, i) => !rankPlotInfo.is_feasible[i]),
            y: yValues.filter((_, i) => !rankPlotInfo.is_feasible[i]),
            marker: {
                color: "#cccccc",
                size: 10,
                line: {
                    color: "Grey",
                    width: 0.5,
                },
            },
            mode: "markers",
            showlegend: false,
            hovertemplate: "%{hovertext}<extra></extra>",
            hovertext: rankPlotInfo.hovertext.filter((_, i) => !rankPlotInfo.is_feasible[i]),
        },
    ];
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphSlice.js":
/*!********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphSlice.js ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphSlice: () => (/* binding */ GraphSlice)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");







const GraphSlice = ({ study = null }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_5__.usePlotlyColorTheme)(theme.palette.mode);
    if ((0,_state__WEBPACK_IMPORTED_MODULE_5__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphSliceBackend, { study: study });
    }
    else {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotSlice, { study: study, colorTheme: colorTheme });
    }
};
const domId = "graph-slice";
const GraphSliceBackend = ({ study = null }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_optuna_react__WEBPACK_IMPORTED_MODULE_0__.useGraphComponentState)();
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_4__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.Slice,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (data && layout && graphComponentState !== "componentWillMount") {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, data, layout).then(notifyGraphDidRender);
        }
    }, [data, layout, graphComponentState]);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.GraphContainer, { plotDomId: domId, graphComponentState: graphComponentState }));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/GraphTimeline.js":
/*!***********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/GraphTimeline.js ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphTimeline: () => (/* binding */ GraphTimeline)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _graphUtil__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../graphUtil */ "../optuna_dashboard/pkg/graphUtil.js");
/* harmony import */ var _hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../hooks/usePlot */ "../optuna_dashboard/pkg/hooks/usePlot.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");









const plotDomId = "graph-timeline";
const GraphTimeline = ({ study }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_6__.usePlotlyColorTheme)(theme.palette.mode);
    if ((0,_state__WEBPACK_IMPORTED_MODULE_6__.useBackendRender)()) {
        return react__WEBPACK_IMPORTED_MODULE_2___default().createElement(GraphTimelineBackend, { study: study });
    }
    else {
        return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.PlotTimeline, { study: (0,_graphUtil__WEBPACK_IMPORTED_MODULE_4__.studyDetailToStudy)(study), colorTheme: colorTheme }));
    }
};
const GraphTimelineBackend = ({ study }) => {
    const studyId = study === null || study === void 0 ? void 0 : study.id;
    const numCompletedTrials = (study === null || study === void 0 ? void 0 : study.trials.filter((t) => t.state === "Complete").length) || 0;
    const { data, layout, error } = (0,_hooks_usePlot__WEBPACK_IMPORTED_MODULE_5__.usePlot)({
        numCompletedTrials,
        studyId,
        plotType: _apiClient__WEBPACK_IMPORTED_MODULE_3__.PlotType.Timeline,
    });
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (data && layout) {
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, data, layout);
        }
    }, [data, layout]);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (error) {
            console.error(error);
        }
    }, [error]);
    return (react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 9 },
        react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", { id: plotDomId })));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Note.js":
/*!**************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Note.js ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MarkdownRenderer: () => (/* binding */ MarkdownRenderer),
/* harmony export */   StudyNote: () => (/* binding */ StudyNote),
/* harmony export */   TrialNote: () => (/* binding */ TrialNote)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Close__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/icons-material/Close */ "../tslib/react/node_modules/@mui/icons-material/esm/Close.js");
/* harmony import */ var _mui_icons_material_Edit__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! @mui/icons-material/Edit */ "../tslib/react/node_modules/@mui/icons-material/esm/Edit.js");
/* harmony import */ var _mui_icons_material_Html__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/icons-material/Html */ "../tslib/react/node_modules/@mui/icons-material/esm/Html.js");
/* harmony import */ var _mui_icons_material_ModeEdit__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/icons-material/ModeEdit */ "../tslib/react/node_modules/@mui/icons-material/esm/ModeEdit.js");
/* harmony import */ var _mui_icons_material_Save__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/icons-material/Save */ "../tslib/react/node_modules/@mui/icons-material/esm/Save.js");
/* harmony import */ var _mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/icons-material/UploadFile */ "../tslib/react/node_modules/@mui/icons-material/esm/UploadFile.js");
/* harmony import */ var _mui_lab_LoadingButton__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/lab/LoadingButton */ "../tslib/react/node_modules/@mui/lab/LoadingButton/LoadingButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContentText/DialogContentText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardHeader/CardHeader.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ImageList/ImageList.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ImageListItem/ImageListItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ImageListItemBar/ImageListItemBar.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_markdown__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! react-markdown */ "../optuna_dashboard/node_modules/react-markdown/lib/index.js");
/* harmony import */ var react_syntax_highlighter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react-syntax-highlighter */ "../optuna_dashboard/node_modules/react-syntax-highlighter/dist/esm/prism.js");
/* harmony import */ var react_syntax_highlighter_dist_esm_styles_prism__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! react-syntax-highlighter/dist/esm/styles/prism */ "../optuna_dashboard/node_modules/react-syntax-highlighter/dist/esm/styles/prism/darcula.js");
/* harmony import */ var rehype_mathjax__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! rehype-mathjax */ "../optuna_dashboard/node_modules/rehype-mathjax/lib/svg.js");
/* harmony import */ var rehype_raw__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! rehype-raw */ "../optuna_dashboard/node_modules/rehype-raw/lib/index.js");
/* harmony import */ var remark_gfm__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! remark-gfm */ "../optuna_dashboard/node_modules/remark-gfm/lib/index.js");
/* harmony import */ var remark_math__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! remark-math */ "../optuna_dashboard/node_modules/remark-math/lib/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
var __rest = (undefined && undefined.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};












// @ts-ignore







const placeholder = `## What is this feature for?

Here you can freely take a note in *(GitHub flavored) Markdown format*.
In addition, **code blocks with syntax highlights** and **formula** are also supported here, as shown below.

### Code-block with Syntax Highlights

\`\`\`python
def objective(trial):
    x = trial.suggest_float("x", -10, 10)
    y = trial.suggest_float("y", -10, 10)
    return (x - 5) ** 2 + (y + 5) ** 2
\`\`\`

### Formula

$$
L = \\frac{1}{2} \\rho v^2 S C_L
$$
`;
const CodeBlock = (_a) => {
    var { 
    // @ts-ignore
    inline, 
    // @ts-ignore
    className, 
    // @ts-ignore
    children } = _a, props = __rest(_a, ["inline", "className", "children"]);
    const match = /language-(\w+)/.exec(className || "");
    return !inline && match ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(react_syntax_highlighter__WEBPACK_IMPORTED_MODULE_4__["default"], Object.assign({ style: react_syntax_highlighter_dist_esm_styles_prism__WEBPACK_IMPORTED_MODULE_5__["default"], language: match[1], PreTag: "div" }, props), String(children).replace(/\n$/, ""))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("code", Object.assign({ className: className }, props), children));
};
const TrialNote = ({ studyId, trialId, latestNote, cardSx }) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(NoteBase, { studyId: studyId, trialId: trialId, latestNote: latestNote, cardSx: cardSx }));
};
const StudyNote = ({ studyId, latestNote, cardSx }) => {
    return react__WEBPACK_IMPORTED_MODULE_0___default().createElement(NoteBase, { studyId: studyId, latestNote: latestNote, cardSx: cardSx });
};
const useConfirmCloseDialog = (handleClose) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const [open, setOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const zIndex = theme.zIndex.snackbar - 1;
    const openDialog = () => {
        setOpen(true);
    };
    const renderDialog = () => {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { open: open, sx: {
                zIndex: zIndex,
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null, "Unsaved changes"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null, "Do you want to save or discard your changes?")),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { onClick: handleClose, color: "primary" }, "Discard"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { onClick: () => {
                        setOpen(false);
                    }, color: "primary" }, "Stay"))));
    };
    return [openDialog, renderDialog];
};
const MarkdownRenderer = ({ body }) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(react_markdown__WEBPACK_IMPORTED_MODULE_13__.Markdown, { children: body, remarkPlugins: [remark_gfm__WEBPACK_IMPORTED_MODULE_14__["default"], remark_math__WEBPACK_IMPORTED_MODULE_15__["default"]], rehypePlugins: [rehype_mathjax__WEBPACK_IMPORTED_MODULE_16__["default"], rehype_raw__WEBPACK_IMPORTED_MODULE_17__["default"]], components: {
        code: CodeBlock,
        img: (props) => react__WEBPACK_IMPORTED_MODULE_0___default().createElement("img", Object.assign({}, props, { style: { maxWidth: "100%" } })),
    } }));
const MarkdownEditorModal = ({ studyId, trialId, latestNote, setEditorUnmount }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const [openConfirmCloseDialog, renderConfirmCloseDialog] = useConfirmCloseDialog(() => {
        setEditorUnmount();
        window.onbeforeunload = null;
    });
    const [saving, setSaving] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [edited, setEdited] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [curNote, setCurNote] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({ version: 0, body: "" });
    const textAreaRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.createRef)();
    const notLatest = latestNote.version > curNote.version;
    const artifactEnabled = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_3__.artifactIsAvailable);
    const [previewMarkdown, setPreviewMarkdown] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const [preview, setPreview] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        setCurNote(latestNote);
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (edited) {
            window.onbeforeunload = (e) => {
                e.returnValue = "Are you okay to discard your changes?";
            };
        }
        else {
            window.onbeforeunload = null;
        }
    }, [edited]);
    const handleSave = () => {
        const nextVersion = curNote.version + 1;
        const newNote = {
            version: nextVersion,
            body: textAreaRef.current ? textAreaRef.current.value : "",
        };
        setSaving(true);
        let actionResponse;
        if (trialId === undefined) {
            actionResponse = action.saveStudyNote(studyId, newNote);
        }
        else {
            actionResponse = action.saveTrialNote(studyId, trialId, newNote);
        }
        actionResponse
            .then(() => {
            setCurNote(newNote);
            window.onbeforeunload = null;
            setEditorUnmount();
        })
            .finally(() => {
            setSaving(false);
        });
    };
    const handleRefresh = () => {
        if (!textAreaRef.current) {
            console.log("Unexpectedly, textarea is not found.");
            return;
        }
        textAreaRef.current.value = latestNote.body;
        setCurNote(latestNote);
        window.onbeforeunload = null;
    };
    const insertTextFromCursorPoint = (text) => {
        if (textAreaRef.current === null) {
            return;
        }
        const cursorPosition = textAreaRef.current.selectionStart;
        const currentBody = textAreaRef.current.value;
        textAreaRef.current.value =
            currentBody.substring(0, cursorPosition) +
                text +
                currentBody.substring(cursorPosition, currentBody.length);
        setEdited(true);
    };
    // See https://github.com/iamhosseindhv/notistack/issues/231#issuecomment-825924840
    const zIndex = theme.zIndex.snackbar - 2;
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { sx: {
            bottom: 0,
            height: "100%",
            left: 0,
            overflow: "scroll",
            position: "fixed",
            right: 0,
            top: 0,
            zIndex: zIndex,
            p: theme.spacing(2),
            display: "flex",
            flexDirection: "column",
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { action: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_20__["default"], { onClick: () => {
                    setPreview(!preview);
                    setPreviewMarkdown(textAreaRef.current ? textAreaRef.current.value : "");
                } }, preview ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ModeEdit__WEBPACK_IMPORTED_MODULE_21__["default"], { color: "primary" })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Html__WEBPACK_IMPORTED_MODULE_22__["default"], { color: "primary" }))), title: "Markdown Editor" }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: {
                flexGrow: 1,
                padding: theme.spacing(2),
                display: preview ? "default" : "none",
                overflow: "scroll",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(MarkdownRenderer, { body: previewMarkdown })),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: {
                width: "100%",
                flexGrow: 1,
                display: preview ? "none" : "flex",
                flexDirection: "row",
                margin: theme.spacing(1, 0),
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { disabled: saving, multiline: true, placeholder: placeholder, sx: {
                    position: "relative",
                    resize: "none",
                    width: "100%",
                    height: "100%",
                    "& .MuiInputBase-root": {
                        height: "100%",
                        alignItems: "start",
                    },
                }, inputRef: textAreaRef, defaultValue: latestNote.body, onChange: () => {
                    const cur = textAreaRef.current ? textAreaRef.current.value : "";
                    if (edited !== (cur !== curNote.body)) {
                        setEdited(cur !== curNote.body);
                    }
                } }),
            artifactEnabled && trialId !== undefined && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(ArtifactUploader, { studyId: studyId, trialId: trialId, insert: insertTextFromCursorPoint }))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", alignItems: "center" } },
            notLatest && !saving && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], { sx: {
                        color: theme.palette.error.main,
                        fontSize: "0.8rem",
                        display: "inline",
                    } }, "The text you are editing has updated. Do you want to discard your changes and refresh the textarea?"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { variant: "text", onClick: handleRefresh, color: "error", size: "small", sx: { textDecoration: "underline" } }, "Yes"))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: { flexGrow: 1 } }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { variant: "outlined", onClick: () => {
                    if (edited) {
                        openConfirmCloseDialog();
                    }
                    else {
                        setEditorUnmount();
                    }
                }, startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Close__WEBPACK_IMPORTED_MODULE_26__["default"], null) }, "Close"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_lab_LoadingButton__WEBPACK_IMPORTED_MODULE_27__["default"], { onClick: handleSave, loading: saving, loadingPosition: "start", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Save__WEBPACK_IMPORTED_MODULE_28__["default"], null), variant: "contained", disabled: !edited || notLatest, sx: { marginLeft: theme.spacing(1) } }, "Save")),
        renderConfirmCloseDialog()));
};
const ArtifactUploader = ({ studyId, trialId, insert }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const uploading = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_3__.isFileUploading);
    const artifacts = (0,_state__WEBPACK_IMPORTED_MODULE_3__.useArtifacts)(studyId, trialId);
    const [dragOver, setDragOver] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [selectedArtifactId, setSelectedArtifactId] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const inputRef = (0,react__WEBPACK_IMPORTED_MODULE_0__.useRef)(null);
    const handleClick = () => {
        if (!inputRef || !inputRef.current) {
            return;
        }
        inputRef.current.click();
    };
    const handleOnChange = (e) => {
        const files = e.target.files;
        if (files === null) {
            return;
        }
        action.uploadTrialArtifact(studyId, trialId, files[0]);
    };
    const handleDrop = (e) => {
        e.stopPropagation();
        e.preventDefault();
        const file = e.dataTransfer.files[0];
        setDragOver(false);
        action.uploadTrialArtifact(studyId, trialId, file);
    };
    const handleDragOver = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(true);
    };
    const handleDragLeave = (e) => {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
        setDragOver(false);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: {
            width: "300px",
            padding: theme.spacing(0, 1),
            display: "flex",
            flexDirection: "column",
        }, onDragOver: handleDragOver, onDragLeave: handleDragLeave, onDrop: handleDrop },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], { sx: {
                fontWeight: theme.typography.fontWeightBold,
                margin: theme.spacing(1, 0),
            } }, "Image"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_lab_LoadingButton__WEBPACK_IMPORTED_MODULE_27__["default"], { loading: uploading, loadingPosition: "start", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_29__["default"], null), onClick: handleClick, variant: "outlined" }, "Upload"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("input", { type: "file", ref: inputRef, onChange: handleOnChange, style: { display: "none" } }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: {
                border: dragOver
                    ? `3px dashed ${theme.palette.mode === "dark" ? "white" : "black"}`
                    : `1px solid ${theme.palette.divider}`,
                margin: theme.spacing(1, 0),
                borderRadius: "4px",
                flexGrow: 1,
                flexBasis: 0,
                overflow: "scroll",
            } },
            dragOver && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { component: "div", sx: {
                    width: "100%",
                    height: "100%",
                    position: "relative",
                    display: "flex",
                    flexDirection: "column",
                    justifyContent: "center",
                    alignItems: "center",
                    backgroundColor: theme.palette.mode === "dark"
                        ? "rgba(255, 255, 255, 0.3)"
                        : "rgba(0,0,0,0.3)",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_UploadFile__WEBPACK_IMPORTED_MODULE_29__["default"], { sx: { fontSize: 80, marginBottom: theme.spacing(2) } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null, "Upload a New Image"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], { sx: { textAlign: "center", color: theme.palette.grey.A400 } }, "Drag your file here."))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_30__["default"], { cols: 1, sx: { margin: 0 } }, artifacts
                .filter((a) => a.mimetype.startsWith("image"))
                .map((a) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_31__["default"], { key: a.artifact_id, onClick: () => {
                    if (selectedArtifactId === a.artifact_id) {
                        setSelectedArtifactId("");
                    }
                    else {
                        setSelectedArtifactId(a.artifact_id);
                    }
                }, sx: {
                    border: selectedArtifactId === a.artifact_id
                        ? `2px solid ${theme.palette.primary.main}`
                        : "none",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("img", { src: `/artifacts/${studyId}/${trialId}/${a.artifact_id}` }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_32__["default"], { title: a.filename })))))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { variant: "outlined", disabled: selectedArtifactId === "", onClick: () => {
                if (selectedArtifactId === "") {
                    return;
                }
                const artifact = artifacts.find((a) => a.artifact_id === selectedArtifactId);
                if (artifact === undefined) {
                    return;
                }
                insert(`![${artifact.filename}](/artifacts/${studyId}/${trialId}/${artifact.artifact_id})\n`);
                setSelectedArtifactId("");
            } }, "Insert an image")));
};
const NoteBase = ({ studyId, trialId, latestNote, cardSx }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"])();
    const [editorMounted, setEditorMounted] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const defaultBody = "";
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { sx: Object.assign({ overflow: "scroll" }, cardSx) },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_33__["default"], { sx: {
                paddingTop: theme.spacing(1),
                position: "relative",
                minHeight: theme.spacing(7),
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(MarkdownRenderer, { body: latestNote.body || defaultBody }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_20__["default"], { sx: {
                    position: "absolute",
                    top: 0,
                    right: 0,
                    margin: theme.spacing(1),
                }, onClick: () => {
                    setEditorMounted(true);
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Edit__WEBPACK_IMPORTED_MODULE_34__["default"], null))),
        editorMounted && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(MarkdownEditorModal, { studyId: studyId, trialId: trialId, latestNote: latestNote, setEditorUnmount: () => {
                setEditorMounted(false);
            } }))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/PlotlyColorTemplates.js":
/*!******************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/PlotlyColorTemplates.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DarkColorTemplates: () => (/* binding */ DarkColorTemplates),
/* harmony export */   LightColorTemplates: () => (/* binding */ LightColorTemplates)
/* harmony export */ });
// Following template is extracted from the sdist of plotly Python library.
// See https://github.com/plotly/plotly.py/blob/v5.6.0/packages/python/plotly/templategen/__init__.py and
// https://github.com/plotly/plotly.py/blob/v5.6.0/packages/python/plotly/templategen/definitions.py
// @ts-ignore
const plotlyDark = { "layout": { "autotypenumbers": "strict", "colorway": ["#636efa", "#EF553B", "#00cc96", "#ab63fa", "#FFA15A", "#19d3f3", "#FF6692", "#B6E880", "#FF97FF", "#FECB52"], "font": { "color": "#f2f5fa" }, "hovermode": "closest", "hoverlabel": { "align": "left" }, "paper_bgcolor": "rgb(17,17,17)", "plot_bgcolor": "rgb(17,17,17)", "polar": { "bgcolor": "rgb(17,17,17)", "angularaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "radialaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" } }, "ternary": { "bgcolor": "rgb(17,17,17)", "aaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "baxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "caxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" } }, "coloraxis": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "colorscale": { "sequential": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "sequentialminus": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "diverging": [[0, "#8e0152"], [0.1, "#c51b7d"], [0.2, "#de77ae"], [0.3, "#f1b6da"], [0.4, "#fde0ef"], [0.5, "#f7f7f7"], [0.6, "#e6f5d0"], [0.7, "#b8e186"], [0.8, "#7fbc41"], [0.9, "#4d9221"], [1, "#276419"]] }, "xaxis": { "gridcolor": "#283442", "linecolor": "#506784", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#283442", "automargin": true, "zerolinewidth": 2 }, "yaxis": { "gridcolor": "#283442", "linecolor": "#506784", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#283442", "automargin": true, "zerolinewidth": 2 }, "scene": { "xaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3", "gridwidth": 2 }, "yaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3", "gridwidth": 2 }, "zaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3", "gridwidth": 2 } }, "shapedefaults": { "line": { "color": "#f2f5fa" } }, "annotationdefaults": { "arrowcolor": "#f2f5fa", "arrowhead": 0, "arrowwidth": 1 }, "geo": { "bgcolor": "rgb(17,17,17)", "landcolor": "rgb(17,17,17)", "subunitcolor": "#506784", "showland": true, "showlakes": true, "lakecolor": "rgb(17,17,17)" }, "title": { "x": 0.05 }, "updatemenudefaults": { "bgcolor": "#506784", "borderwidth": 0 }, "sliderdefaults": { "bgcolor": "#C8D4E3", "borderwidth": 1, "bordercolor": "rgb(17,17,17)", "tickwidth": 0 }, "mapbox": { "style": "dark" } }, "data": { "histogram2dcontour": [{ "type": "histogram2dcontour", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "choropleth": [{ "type": "choropleth", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "histogram2d": [{ "type": "histogram2d", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "heatmap": [{ "type": "heatmap", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "heatmapgl": [{ "type": "heatmapgl", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "contourcarpet": [{ "type": "contourcarpet", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "contour": [{ "type": "contour", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "surface": [{ "type": "surface", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "mesh3d": [{ "type": "mesh3d", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "scatter": [{ "marker": { "line": { "color": "#283442" } }, "type": "scatter" }], "parcoords": [{ "type": "parcoords", "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterpolargl": [{ "type": "scatterpolargl", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "bar": [{ "error_x": { "color": "#f2f5fa" }, "error_y": { "color": "#f2f5fa" }, "marker": { "line": { "color": "rgb(17,17,17)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "scattergeo": [{ "type": "scattergeo", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterpolar": [{ "type": "scatterpolar", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "histogram": [{ "marker": { "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "histogram" }], "scattergl": [{ "marker": { "line": { "color": "#283442" } }, "type": "scattergl" }], "scatter3d": [{ "type": "scatter3d", "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scattermapbox": [{ "type": "scattermapbox", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterternary": [{ "type": "scatterternary", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scattercarpet": [{ "type": "scattercarpet", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "carpet": [{ "aaxis": { "endlinecolor": "#A2B1C6", "gridcolor": "#506784", "linecolor": "#506784", "minorgridcolor": "#506784", "startlinecolor": "#A2B1C6" }, "baxis": { "endlinecolor": "#A2B1C6", "gridcolor": "#506784", "linecolor": "#506784", "minorgridcolor": "#506784", "startlinecolor": "#A2B1C6" }, "type": "carpet" }], "table": [{ "cells": { "fill": { "color": "#506784" }, "line": { "color": "rgb(17,17,17)" } }, "header": { "fill": { "color": "#2a3f5f" }, "line": { "color": "rgb(17,17,17)" } }, "type": "table" }], "barpolar": [{ "marker": { "line": { "color": "rgb(17,17,17)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const plotlyWhite = { "layout": { "autotypenumbers": "strict", "colorway": ["#636efa", "#EF553B", "#00cc96", "#ab63fa", "#FFA15A", "#19d3f3", "#FF6692", "#B6E880", "#FF97FF", "#FECB52"], "font": { "color": "#2a3f5f" }, "hovermode": "closest", "hoverlabel": { "align": "left" }, "paper_bgcolor": "white", "plot_bgcolor": "white", "polar": { "bgcolor": "white", "angularaxis": { "gridcolor": "#EBF0F8", "linecolor": "#EBF0F8", "ticks": "" }, "radialaxis": { "gridcolor": "#EBF0F8", "linecolor": "#EBF0F8", "ticks": "" } }, "ternary": { "bgcolor": "white", "aaxis": { "gridcolor": "#DFE8F3", "linecolor": "#A2B1C6", "ticks": "" }, "baxis": { "gridcolor": "#DFE8F3", "linecolor": "#A2B1C6", "ticks": "" }, "caxis": { "gridcolor": "#DFE8F3", "linecolor": "#A2B1C6", "ticks": "" } }, "coloraxis": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "colorscale": { "sequential": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "sequentialminus": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "diverging": [[0, "#8e0152"], [0.1, "#c51b7d"], [0.2, "#de77ae"], [0.3, "#f1b6da"], [0.4, "#fde0ef"], [0.5, "#f7f7f7"], [0.6, "#e6f5d0"], [0.7, "#b8e186"], [0.8, "#7fbc41"], [0.9, "#4d9221"], [1, "#276419"]] }, "xaxis": { "gridcolor": "#EBF0F8", "linecolor": "#EBF0F8", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#EBF0F8", "automargin": true, "zerolinewidth": 2 }, "yaxis": { "gridcolor": "#EBF0F8", "linecolor": "#EBF0F8", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#EBF0F8", "automargin": true, "zerolinewidth": 2 }, "scene": { "xaxis": { "backgroundcolor": "white", "gridcolor": "#DFE8F3", "linecolor": "#EBF0F8", "showbackground": true, "ticks": "", "zerolinecolor": "#EBF0F8", "gridwidth": 2 }, "yaxis": { "backgroundcolor": "white", "gridcolor": "#DFE8F3", "linecolor": "#EBF0F8", "showbackground": true, "ticks": "", "zerolinecolor": "#EBF0F8", "gridwidth": 2 }, "zaxis": { "backgroundcolor": "white", "gridcolor": "#DFE8F3", "linecolor": "#EBF0F8", "showbackground": true, "ticks": "", "zerolinecolor": "#EBF0F8", "gridwidth": 2 } }, "shapedefaults": { "line": { "color": "#2a3f5f" } }, "annotationdefaults": { "arrowcolor": "#2a3f5f", "arrowhead": 0, "arrowwidth": 1 }, "geo": { "bgcolor": "white", "landcolor": "white", "subunitcolor": "#C8D4E3", "showland": true, "showlakes": true, "lakecolor": "white" }, "title": { "x": 0.05 }, "mapbox": { "style": "light" } }, "data": { "histogram2dcontour": [{ "type": "histogram2dcontour", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "choropleth": [{ "type": "choropleth", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "histogram2d": [{ "type": "histogram2d", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "heatmap": [{ "type": "heatmap", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "heatmapgl": [{ "type": "heatmapgl", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "contourcarpet": [{ "type": "contourcarpet", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "contour": [{ "type": "contour", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "surface": [{ "type": "surface", "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }], "mesh3d": [{ "type": "mesh3d", "colorbar": { "outlinewidth": 0, "ticks": "" } }], "scatter": [{ "fillpattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 }, "type": "scatter" }], "parcoords": [{ "type": "parcoords", "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterpolargl": [{ "type": "scatterpolargl", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "bar": [{ "error_x": { "color": "#2a3f5f" }, "error_y": { "color": "#2a3f5f" }, "marker": { "line": { "color": "white", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "scattergeo": [{ "type": "scattergeo", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterpolar": [{ "type": "scatterpolar", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "histogram": [{ "marker": { "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "histogram" }], "scattergl": [{ "type": "scattergl", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatter3d": [{ "type": "scatter3d", "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scattermapbox": [{ "type": "scattermapbox", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scatterternary": [{ "type": "scatterternary", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "scattercarpet": [{ "type": "scattercarpet", "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } } }], "carpet": [{ "aaxis": { "endlinecolor": "#2a3f5f", "gridcolor": "#C8D4E3", "linecolor": "#C8D4E3", "minorgridcolor": "#C8D4E3", "startlinecolor": "#2a3f5f" }, "baxis": { "endlinecolor": "#2a3f5f", "gridcolor": "#C8D4E3", "linecolor": "#C8D4E3", "minorgridcolor": "#C8D4E3", "startlinecolor": "#2a3f5f" }, "type": "carpet" }], "table": [{ "cells": { "fill": { "color": "#EBF0F8" }, "line": { "color": "white" } }, "header": { "fill": { "color": "#C8D4E3" }, "line": { "color": "white" } }, "type": "table" }], "barpolar": [{ "marker": { "line": { "color": "white", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const seaborn = { "layout": { "autotypenumbers": "strict", "colorway": ["rgb(76,114,176)", "rgb(221,132,82)", "rgb(85,168,104)", "rgb(196,78,82)", "rgb(129,114,179)", "rgb(147,120,96)", "rgb(218,139,195)", "rgb(140,140,140)", "rgb(204,185,116)", "rgb(100,181,205)"], "font": { "color": "rgb(36,36,36)" }, "hovermode": "closest", "hoverlabel": { "align": "left" }, "paper_bgcolor": "white", "plot_bgcolor": "rgb(234,234,242)", "polar": { "bgcolor": "rgb(234,234,242)", "angularaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "" }, "radialaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "" } }, "ternary": { "bgcolor": "rgb(234,234,242)", "aaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "" }, "baxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "" }, "caxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "" } }, "coloraxis": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } }, "colorscale": { "sequential": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]], "sequentialminus": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }, "xaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "white", "automargin": true }, "yaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "white", "automargin": true }, "scene": { "xaxis": { "backgroundcolor": "rgb(234,234,242)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "ticks": "", "zerolinecolor": "white", "gridwidth": 2 }, "yaxis": { "backgroundcolor": "rgb(234,234,242)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "ticks": "", "zerolinecolor": "white", "gridwidth": 2 }, "zaxis": { "backgroundcolor": "rgb(234,234,242)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "ticks": "", "zerolinecolor": "white", "gridwidth": 2 } }, "shapedefaults": { "fillcolor": "rgb(67,103,167)", "line": { "width": 0 }, "opacity": 0.5 }, "annotationdefaults": { "arrowcolor": "rgb(67,103,167)" }, "geo": { "bgcolor": "white", "landcolor": "rgb(234,234,242)", "subunitcolor": "white", "showland": true, "showlakes": true, "lakecolor": "white" } }, "data": { "histogram2dcontour": [{ "type": "histogram2dcontour", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "choropleth": [{ "type": "choropleth", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } }], "histogram2d": [{ "type": "histogram2d", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "heatmap": [{ "type": "heatmap", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "heatmapgl": [{ "type": "heatmapgl", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "contourcarpet": [{ "type": "contourcarpet", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } }], "contour": [{ "type": "contour", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "surface": [{ "type": "surface", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 }, "colorscale": [[0.0, "rgb(2,4,25)"], [0.06274509803921569, "rgb(24,15,41)"], [0.12549019607843137, "rgb(47,23,57)"], [0.18823529411764706, "rgb(71,28,72)"], [0.25098039215686274, "rgb(97,30,82)"], [0.3137254901960784, "rgb(123,30,89)"], [0.3764705882352941, "rgb(150,27,91)"], [0.4392156862745098, "rgb(177,22,88)"], [0.5019607843137255, "rgb(203,26,79)"], [0.5647058823529412, "rgb(223,47,67)"], [0.6274509803921569, "rgb(236,76,61)"], [0.6901960784313725, "rgb(242,107,73)"], [0.7529411764705882, "rgb(244,135,95)"], [0.8156862745098039, "rgb(245,162,122)"], [0.8784313725490196, "rgb(246,188,153)"], [0.9411764705882353, "rgb(247,212,187)"], [1.0, "rgb(250,234,220)"]] }], "mesh3d": [{ "type": "mesh3d", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } }], "scatter": [{ "fillpattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 }, "type": "scatter" }], "parcoords": [{ "type": "parcoords", "line": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scatterpolargl": [{ "type": "scatterpolargl", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "bar": [{ "error_x": { "color": "rgb(36,36,36)" }, "error_y": { "color": "rgb(36,36,36)" }, "marker": { "line": { "color": "rgb(234,234,242)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "scattergeo": [{ "type": "scattergeo", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scatterpolar": [{ "type": "scatterpolar", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "histogram": [{ "marker": { "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "histogram" }], "scattergl": [{ "type": "scattergl", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scatter3d": [{ "type": "scatter3d", "line": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } }, "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scattermapbox": [{ "type": "scattermapbox", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scatterternary": [{ "type": "scatterternary", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "scattercarpet": [{ "type": "scattercarpet", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(36,36,36)", "ticklen": 8, "ticks": "outside", "tickwidth": 2 } } }], "carpet": [{ "aaxis": { "endlinecolor": "rgb(36,36,36)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(36,36,36)" }, "baxis": { "endlinecolor": "rgb(36,36,36)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(36,36,36)" }, "type": "carpet" }], "table": [{ "cells": { "fill": { "color": "rgb(231,231,240)" }, "line": { "color": "white" } }, "header": { "fill": { "color": "rgb(183,183,191)" }, "line": { "color": "white" } }, "type": "table" }], "barpolar": [{ "marker": { "line": { "color": "rgb(234,234,242)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const ggplot2 = { "layout": { "autotypenumbers": "strict", "colorway": ["#F8766D", "#A3A500", "#00BF7D", "#00B0F6", "#E76BF3"], "font": { "color": "rgb(51,51,51)" }, "hovermode": "closest", "hoverlabel": { "align": "left" }, "paper_bgcolor": "white", "plot_bgcolor": "rgb(237,237,237)", "polar": { "bgcolor": "rgb(237,237,237)", "angularaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside" }, "radialaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside" } }, "ternary": { "bgcolor": "rgb(237,237,237)", "aaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside" }, "baxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside" }, "caxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside" } }, "coloraxis": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } }, "colorscale": { "sequential": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]], "sequentialminus": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }, "xaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside", "title": { "standoff": 15 }, "zerolinecolor": "white", "automargin": true }, "yaxis": { "gridcolor": "white", "linecolor": "white", "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside", "title": { "standoff": 15 }, "zerolinecolor": "white", "automargin": true }, "scene": { "xaxis": { "backgroundcolor": "rgb(237,237,237)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside", "zerolinecolor": "white", "gridwidth": 2 }, "yaxis": { "backgroundcolor": "rgb(237,237,237)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside", "zerolinecolor": "white", "gridwidth": 2 }, "zaxis": { "backgroundcolor": "rgb(237,237,237)", "gridcolor": "white", "linecolor": "white", "showbackground": true, "showgrid": true, "tickcolor": "rgb(51,51,51)", "ticks": "outside", "zerolinecolor": "white", "gridwidth": 2 } }, "shapedefaults": { "fillcolor": "black", "line": { "width": 0 }, "opacity": 0.3 }, "annotationdefaults": { "arrowhead": 0, "arrowwidth": 1 }, "geo": { "bgcolor": "white", "landcolor": "rgb(237,237,237)", "subunitcolor": "white", "showland": true, "showlakes": true, "lakecolor": "white" } }, "data": { "histogram2dcontour": [{ "type": "histogram2dcontour", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "choropleth": [{ "type": "choropleth", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } }], "histogram2d": [{ "type": "histogram2d", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "heatmap": [{ "type": "heatmap", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "heatmapgl": [{ "type": "heatmapgl", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "contourcarpet": [{ "type": "contourcarpet", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } }], "contour": [{ "type": "contour", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "surface": [{ "type": "surface", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" }, "colorscale": [[0, "rgb(20,44,66)"], [1, "rgb(90,179,244)"]] }], "mesh3d": [{ "type": "mesh3d", "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } }], "scatter": [{ "fillpattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 }, "type": "scatter" }], "parcoords": [{ "type": "parcoords", "line": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scatterpolargl": [{ "type": "scatterpolargl", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "bar": [{ "error_x": { "color": "rgb(51,51,51)" }, "error_y": { "color": "rgb(51,51,51)" }, "marker": { "line": { "color": "rgb(237,237,237)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "scattergeo": [{ "type": "scattergeo", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scatterpolar": [{ "type": "scatterpolar", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "histogram": [{ "marker": { "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "histogram" }], "scattergl": [{ "type": "scattergl", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scatter3d": [{ "type": "scatter3d", "line": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } }, "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scattermapbox": [{ "type": "scattermapbox", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scatterternary": [{ "type": "scatterternary", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "scattercarpet": [{ "type": "scattercarpet", "marker": { "colorbar": { "outlinewidth": 0, "tickcolor": "rgb(237,237,237)", "ticklen": 6, "ticks": "inside" } } }], "carpet": [{ "aaxis": { "endlinecolor": "rgb(51,51,51)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(51,51,51)" }, "baxis": { "endlinecolor": "rgb(51,51,51)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(51,51,51)" }, "type": "carpet" }], "table": [{ "cells": { "fill": { "color": "rgb(237,237,237)" }, "line": { "color": "white" } }, "header": { "fill": { "color": "rgb(217,217,217)" }, "line": { "color": "white" } }, "type": "table" }], "barpolar": [{ "marker": { "line": { "color": "rgb(237,237,237)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const gridon = { "layout": { "xaxis": { "showgrid": true, "title": { "standoff": 15 } }, "yaxis": { "showgrid": true, "title": { "standoff": 15 } } }, "data": { "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const presentation = { "layout": { "xaxis": { "title": { "standoff": 15 } }, "yaxis": { "title": { "standoff": 15 } }, "font": { "size": 18 } }, "data": { "scatter": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scatter" }], "scattergl": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scattergl" }], "scatter3d": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scatter3d" }], "scatterpolar": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scatterpolar" }], "scatterpolargl": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scatterpolargl" }], "scatterternary": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scatterternary" }], "scattergeo": [{ "line": { "width": 3 }, "marker": { "size": 9 }, "type": "scattergeo" }], "table": [{ "cells": { "height": 30 }, "header": { "height": 36 }, "type": "table" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const simpleWhite = { "layout": { "autotypenumbers": "strict", "colorway": ["#1F77B4", "#FF7F0E", "#2CA02C", "#D62728", "#9467BD", "#8C564B", "#E377C2", "#7F7F7F", "#BCBD22", "#17BECF"], "font": { "color": "rgb(36,36,36)" }, "hovermode": "closest", "hoverlabel": { "align": "left" }, "paper_bgcolor": "white", "plot_bgcolor": "white", "polar": { "bgcolor": "white", "angularaxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside" }, "radialaxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside" } }, "ternary": { "bgcolor": "white", "aaxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside" }, "baxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside" }, "caxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside" } }, "coloraxis": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } }, "colorscale": { "sequential": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]], "sequentialminus": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]], "diverging": [[0.0, "rgb(103,0,31)"], [0.1, "rgb(178,24,43)"], [0.2, "rgb(214,96,77)"], [0.3, "rgb(244,165,130)"], [0.4, "rgb(253,219,199)"], [0.5, "rgb(247,247,247)"], [0.6, "rgb(209,229,240)"], [0.7, "rgb(146,197,222)"], [0.8, "rgb(67,147,195)"], [0.9, "rgb(33,102,172)"], [1.0, "rgb(5,48,97)"]] }, "xaxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside", "title": { "standoff": 15 }, "zerolinecolor": "rgb(36,36,36)", "automargin": true, "zeroline": false }, "yaxis": { "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showgrid": false, "showline": true, "ticks": "outside", "title": { "standoff": 15 }, "zerolinecolor": "rgb(36,36,36)", "automargin": true, "zeroline": false }, "scene": { "xaxis": { "backgroundcolor": "white", "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showbackground": true, "showgrid": false, "showline": true, "ticks": "outside", "zerolinecolor": "rgb(36,36,36)", "gridwidth": 2, "zeroline": false }, "yaxis": { "backgroundcolor": "white", "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showbackground": true, "showgrid": false, "showline": true, "ticks": "outside", "zerolinecolor": "rgb(36,36,36)", "gridwidth": 2, "zeroline": false }, "zaxis": { "backgroundcolor": "white", "gridcolor": "rgb(232,232,232)", "linecolor": "rgb(36,36,36)", "showbackground": true, "showgrid": false, "showline": true, "ticks": "outside", "zerolinecolor": "rgb(36,36,36)", "gridwidth": 2, "zeroline": false } }, "shapedefaults": { "fillcolor": "black", "line": { "width": 0 }, "opacity": 0.3 }, "annotationdefaults": { "arrowhead": 0, "arrowwidth": 1 }, "geo": { "bgcolor": "white", "landcolor": "white", "subunitcolor": "white", "showland": true, "showlakes": true, "lakecolor": "white" }, "title": { "x": 0.05 }, "mapbox": { "style": "light" } }, "data": { "histogram2dcontour": [{ "type": "histogram2dcontour", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "choropleth": [{ "type": "choropleth", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } }], "histogram2d": [{ "type": "histogram2d", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "heatmap": [{ "type": "heatmap", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "heatmapgl": [{ "type": "heatmapgl", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "contourcarpet": [{ "type": "contourcarpet", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } }], "contour": [{ "type": "contour", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "surface": [{ "type": "surface", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" }, "colorscale": [[0.0, "#440154"], [0.1111111111111111, "#482878"], [0.2222222222222222, "#3e4989"], [0.3333333333333333, "#31688e"], [0.4444444444444444, "#26828e"], [0.5555555555555556, "#1f9e89"], [0.6666666666666666, "#35b779"], [0.7777777777777778, "#6ece58"], [0.8888888888888888, "#b5de2b"], [1.0, "#fde725"]] }], "mesh3d": [{ "type": "mesh3d", "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } }], "scatter": [{ "fillpattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 }, "type": "scatter" }], "parcoords": [{ "type": "parcoords", "line": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scatterpolargl": [{ "type": "scatterpolargl", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "bar": [{ "error_x": { "color": "rgb(36,36,36)" }, "error_y": { "color": "rgb(36,36,36)" }, "marker": { "line": { "color": "white", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "scattergeo": [{ "type": "scattergeo", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scatterpolar": [{ "type": "scatterpolar", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "histogram": [{ "marker": { "line": { "color": "white", "width": 0.6 } }, "type": "histogram" }], "scattergl": [{ "type": "scattergl", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scatter3d": [{ "type": "scatter3d", "line": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } }, "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scattermapbox": [{ "type": "scattermapbox", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scatterternary": [{ "type": "scatterternary", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "scattercarpet": [{ "type": "scattercarpet", "marker": { "colorbar": { "outlinewidth": 1, "tickcolor": "rgb(36,36,36)", "ticks": "outside" } } }], "carpet": [{ "aaxis": { "endlinecolor": "rgb(36,36,36)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(36,36,36)" }, "baxis": { "endlinecolor": "rgb(36,36,36)", "gridcolor": "white", "linecolor": "white", "minorgridcolor": "white", "startlinecolor": "rgb(36,36,36)" }, "type": "carpet" }], "table": [{ "cells": { "fill": { "color": "rgb(237,237,237)" }, "line": { "color": "white" } }, "header": { "fill": { "color": "rgb(217,217,217)" }, "line": { "color": "white" } }, "type": "table" }], "barpolar": [{ "marker": { "line": { "color": "white", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const xgridOff = { "layout": { "xaxis": { "showgrid": false, "title": { "standoff": 15 } }, "yaxis": { "title": { "standoff": 15 } } }, "data": { "pie": [{ "automargin": true, "type": "pie" }] } };
// @ts-ignore
const ygridOff = { "layout": { "yaxis": { "showgrid": false } }, "data": { "pie": [{ "automargin": true, "type": "pie" }] } };
const DarkColorTemplates = {
    default: plotlyDark,
    seaborn: seaborn,
    simpleWhite: simpleWhite,
    presentation: presentation,
    ggplot2: ggplot2,
    gridon: gridon,
    xgridOff: xgridOff,
    ygridOff: ygridOff,
};
const LightColorTemplates = {
    default: plotlyWhite,
    seaborn: seaborn,
    presentation: presentation,
    ggplot2: ggplot2,
    gridon: gridon,
    xgridOff: xgridOff,
    ygridOff: ygridOff,
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Preferential/PreferentialAnalytics.js":
/*!********************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Preferential/PreferentialAnalytics.js ***!
  \********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PreferentialAnalytics: () => (/* binding */ PreferentialAnalytics)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Paper/Paper.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material_Grid__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material/Grid */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _BestTrialsCard__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../BestTrialsCard */ "../optuna_dashboard/pkg/components/BestTrialsCard.js");
/* harmony import */ var _GraphContour__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../GraphContour */ "../optuna_dashboard/pkg/components/GraphContour.js");
/* harmony import */ var _tanstack_react_table__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @tanstack/react-table */ "../tslib/react/node_modules/@tanstack/table-core/build/lib/index.mjs");








const PreferentialAnalytics = ({ studyId }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"])();
    const studySummary = (0,_state__WEBPACK_IMPORTED_MODULE_2__.useStudySummaryValue)(studyId);
    const studyDetail = (0,_state__WEBPACK_IMPORTED_MODULE_2__.useStudyDetailValue)(studyId);
    const userAttrs = (studySummary === null || studySummary === void 0 ? void 0 : studySummary.user_attrs) || (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.user_attrs) || [];
    const columnHelper = (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_6__.createColumnHelper)();
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const columns = [
        columnHelper.accessor("key", {
            header: "Key",
            enableSorting: true,
            enableColumnFilter: false,
        }),
        columnHelper.accessor("value", {
            header: "Value",
            enableSorting: true,
            enableColumnFilter: false,
        }),
    ];
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { component: "div", sx: { display: "flex", width: "100%", flexDirection: "column" } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_8__["default"], { container: true, spacing: 2, sx: { padding: theme.spacing(0, 2) } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 14 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { elevation: 2, sx: { padding: theme.spacing(2) } },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphContour__WEBPACK_IMPORTED_MODULE_4__.Contour, { study: studyDetail }))),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 6, spacing: 2 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_BestTrialsCard__WEBPACK_IMPORTED_MODULE_3__.BestTrialsCard, { studyDetail: studyDetail })),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { sx: {
                            display: "flex",
                            flexDirection: "column",
                        } },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { variant: "h6", sx: {
                                margin: "1em 0",
                                fontWeight: theme.typography.fontWeightBold,
                            } }, "Study User Attributes"),
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.DataGrid, { data: userAttrs, columns: columns })))))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Preferential/PreferentialGraph.js":
/*!****************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Preferential/PreferentialGraph.js ***!
  \****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PreferentialGraph: () => (/* binding */ PreferentialGraph)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Chip/Chip.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var elkjs_lib_elk_bundled_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! elkjs/lib/elk.bundled.js */ "../optuna_dashboard/node_modules/elkjs/lib/elk.bundled.js");
/* harmony import */ var elkjs_lib_elk_bundled_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(elkjs_lib_elk_bundled_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! reactflow */ "../optuna_dashboard/node_modules/@reactflow/core/dist/esm/index.mjs");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! reactflow */ "../optuna_dashboard/node_modules/@reactflow/minimap/dist/esm/index.mjs");
/* harmony import */ var reactflow_dist_style_css__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow/dist/style.css */ "../optuna_dashboard/node_modules/reactflow/dist/style.css");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./PreferentialOutputComponent */ "../optuna_dashboard/pkg/components/Preferential/PreferentialOutputComponent.js");
/* harmony import */ var _PreferentialTrials__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./PreferentialTrials */ "../optuna_dashboard/pkg/components/Preferential/PreferentialTrials.js");









const elk = new (elkjs_lib_elk_bundled_js__WEBPACK_IMPORTED_MODULE_0___default())();
const nodeWidth = 400;
const nodeHeight = 300;
const nodeMargin = 60;
const GraphNode = ({ data, isConnectable }) => {
    var _a;
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const { environment } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_3__.useConstants)();
    const trial = data.trial;
    if (trial === undefined) {
        return null;
    }
    const studyDetail = (0,_state__WEBPACK_IMPORTED_MODULE_4__.useStudyDetailValue)(trial.study_id);
    const componentType = studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.feedback_component_type;
    if (componentType === undefined) {
        return null;
    }
    const artifactId = componentType.output_type === "artifact"
        ? (_a = trial.user_attrs.find((a) => a.key === componentType.artifact_key)) === null || _a === void 0 ? void 0 : _a.value
        : undefined;
    const artifact = trial.artifacts.find((a) => a.artifact_id === artifactId);
    const urlPath = artifactId !== undefined
        ? (0,_PreferentialTrials__WEBPACK_IMPORTED_MODULE_6__.getArtifactUrlPath)(environment, trial.study_id, trial.trial_id, artifactId)
        : "";
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { sx: {
            width: nodeWidth,
            height: nodeHeight,
            overflow: "hidden",
        } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { component: "div", sx: {
                display: "flex",
                displayDirection: "row",
                margin: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { variant: "h5" },
                "Trial ",
                trial.number),
            data.isBest && (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { label: "Best Trial", color: "secondary", variant: "outlined", sx: {
                    marginLeft: "auto",
                } }))),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(reactflow__WEBPACK_IMPORTED_MODULE_12__.Handle, { type: "target", position: reactflow__WEBPACK_IMPORTED_MODULE_12__.Position.Top, style: { background: "#555" }, isConnectable: isConnectable }),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { sx: {
                position: "relative",
                margin: 0,
                padding: theme.spacing(1),
                width: nodeWidth,
                height: nodeHeight - 72,
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_5__.PreferentialOutputComponent, { trial: trial, artifact: artifact, componentType: componentType, urlPath: urlPath })),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(reactflow__WEBPACK_IMPORTED_MODULE_12__.Handle, { type: "source", position: reactflow__WEBPACK_IMPORTED_MODULE_12__.Position.Bottom, style: { background: "#555" }, isConnectable: isConnectable })));
};
const nodeTypes = {
    note: GraphNode,
};
const defaultEdgeOptions = {
    animated: true,
};
const reductionPreference = (input_preferences) => {
    const preferences = [];
    let n = 0;
    for (const [source, target] of input_preferences) {
        if (preferences.find((p) => p[0] === source && p[1] === target) !==
            undefined ||
            input_preferences.find((p) => p[0] === target && p[1] === source) !==
                undefined) {
            continue;
        }
        n = Math.max(n - 1, source, target) + 1;
        preferences.push([source, target]);
    }
    if (n === 0) {
        return [];
    }
    const graph = Array.from({ length: n }, () => []);
    const reverseGraph = Array.from({ length: n }, () => []);
    const degree = Array.from({ length: n }, () => 0);
    for (const [source, target] of preferences) {
        graph[source].push(target);
        reverseGraph[target].push(source);
        degree[target]++;
    }
    const topologicalOrder = [];
    const q = [];
    for (let i = 0; i < n; i++) {
        if (degree[i] === 0) {
            q.push(i);
        }
    }
    while (q.length > 0) {
        const v = q.pop();
        if (v === undefined)
            break;
        topologicalOrder.push(v);
        graph[v].forEach((u) => {
            degree[u]--;
            if (degree[u] === 0) {
                q.push(u);
            }
        });
    }
    if (topologicalOrder.length !== n) {
        console.error("cycle detected");
        return preferences;
    }
    const response = [];
    const descendants = Array.from({ length: n }, () => new Set());
    topologicalOrder.reverse().forEach((v) => {
        const descendant = new Set([v]);
        graph[v].forEach((u) => {
            descendants[u].forEach((d) => descendant.add(d));
        });
        graph[v].forEach((u) => {
            if (reverseGraph[u].filter((d) => descendant.has(d)).length === 1) {
                response.push([v, u]);
            }
        });
        descendants[v] = descendant;
    });
    return response;
};
const PreferentialGraph = ({ studyDetail }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const [nodes, setNodes] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)([]);
    const [edges, setEdges] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)([]);
    const onNodesChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((changes) => setNodes((nds) => (0,reactflow__WEBPACK_IMPORTED_MODULE_12__.applyNodeChanges)(changes, nds)), [setNodes]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        var _a;
        if (studyDetail === null)
            return;
        if (!studyDetail.is_preferential || studyDetail.preferences === undefined)
            return;
        const preferences = reductionPreference(studyDetail.preferences);
        const trialNodes = Array.from(new Set(preferences.flat()));
        const graph = {
            id: "root",
            layoutOptions: {
                "elk.algorithm": "layered",
                "elk.direction": "DOWN",
                "elk.layered.spacing.nodeNodeBetweenLayers": nodeMargin.toString(),
                "elk.spacing.nodeNode": nodeMargin.toString(),
            },
            children: trialNodes.map((trial) => ({
                id: `${trial}`,
                targetPosition: "top",
                sourcePosition: "bottom",
                width: nodeWidth,
                height: nodeHeight,
            })),
            edges: preferences.map(([source, target]) => ({
                id: `e${source}-${target}`,
                sources: [`${source}`],
                targets: [`${target}`],
            })),
        };
        elk
            .layout(graph)
            .then((layoutedGraph) => {
            var _a, _b;
            setNodes((_b = (_a = layoutedGraph.children) === null || _a === void 0 ? void 0 : _a.map((node, index) => {
                var _a, _b;
                const trial = studyDetail.trials[trialNodes[index]];
                return {
                    id: `${trial.number}`,
                    type: "note",
                    data: {
                        label: `Trial ${trial.number}`,
                        trial: trial,
                        isBest: studyDetail.best_trials.find((t) => t.number === trial.number) !== undefined,
                    },
                    position: {
                        x: (_a = node.x) !== null && _a !== void 0 ? _a : 0,
                        y: (_b = node.y) !== null && _b !== void 0 ? _b : 0,
                    },
                    style: {
                        width: nodeWidth,
                        height: nodeHeight,
                        padding: 0,
                    },
                    deletable: false,
                    connectable: false,
                    draggable: false,
                };
            })) !== null && _b !== void 0 ? _b : []);
        })
            .catch(console.error);
        setEdges((_a = preferences.map((p) => {
            return {
                id: `e${p[0]}-${p[1]}`,
                source: `${p[0]}`,
                target: `${p[1]}`,
                style: { stroke: theme.palette.text.primary },
            };
        })) !== null && _a !== void 0 ? _a : []);
    }, [studyDetail, theme.palette.text.primary]);
    if (studyDetail === null || !studyDetail.is_preferential) {
        return null;
    }
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(reactflow__WEBPACK_IMPORTED_MODULE_12__.ReactFlow, { nodes: nodes, edges: edges, onNodesChange: onNodesChange, defaultEdgeOptions: defaultEdgeOptions, nodeTypes: nodeTypes, zoomOnScroll: false, panOnScroll: true, minZoom: 0.1, defaultViewport: {
            x: 0,
            y: 0,
            zoom: 0.5,
        } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(reactflow__WEBPACK_IMPORTED_MODULE_14__.MiniMap, { nodeStrokeWidth: 1, zoomable: true, pannable: true })));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Preferential/PreferentialHistory.js":
/*!******************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Preferential/PreferentialHistory.js ***!
  \******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PreferentialHistory: () => (/* binding */ PreferentialHistory)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/icons-material/Clear */ "../tslib/react/node_modules/@mui/icons-material/esm/Clear.js");
/* harmony import */ var _mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/icons-material/Delete */ "../tslib/react/node_modules/@mui/icons-material/esm/Delete.js");
/* harmony import */ var _mui_icons_material_OpenInFull__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/icons-material/OpenInFull */ "../tslib/react/node_modules/@mui/icons-material/esm/OpenInFull.js");
/* harmony import */ var _mui_icons_material_RestoreFromTrash__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/icons-material/RestoreFromTrash */ "../tslib/react/node_modules/@mui/icons-material/esm/RestoreFromTrash.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActions/CardActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material/IconButton */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material_Modal__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material/Modal */ "../tslib/react/node_modules/@mui/material/Modal/Modal.js");
/* harmony import */ var _mui_material_colors__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material/colors */ "../tslib/react/node_modules/@mui/material/colors/red.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _dateUtil__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../dateUtil */ "../optuna_dashboard/pkg/dateUtil.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _TrialList__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../TrialList */ "../optuna_dashboard/pkg/components/TrialList.js");
/* harmony import */ var _PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./PreferentialOutputComponent */ "../optuna_dashboard/pkg/components/Preferential/PreferentialOutputComponent.js");
/* harmony import */ var _PreferentialTrials__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./PreferentialTrials */ "../optuna_dashboard/pkg/components/Preferential/PreferentialTrials.js");
















const CandidateTrial = ({ trial, type }) => {
    var _a;
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])();
    const { environment } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_2__.useConstants)();
    const trialWidth = 300;
    const trialHeight = 300;
    const studyDetail = (0,_state__WEBPACK_IMPORTED_MODULE_4__.useStudyDetailValue)(trial.study_id);
    const [detailShown, setDetailShown] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    if (studyDetail === null) {
        return null;
    }
    const componentType = studyDetail.feedback_component_type;
    const artifactId = componentType.output_type === "artifact"
        ? (_a = trial.user_attrs.find((a) => a.key === componentType.artifact_key)) === null || _a === void 0 ? void 0 : _a.value
        : undefined;
    const artifact = trial.artifacts.find((a) => a.artifact_id === artifactId);
    const urlPath = artifactId !== undefined
        ? (0,_PreferentialTrials__WEBPACK_IMPORTED_MODULE_7__.getArtifactUrlPath)(environment, trial.study_id, trial.trial_id, artifactId)
        : "";
    const cardComponentSx = {
        padding: 0,
        position: "relative",
        overflow: "hidden",
        "::before": {},
    };
    if (type !== "none") {
        cardComponentSx["::before"] = {
            content: '""',
            position: "absolute",
            top: 0,
            left: 0,
            width: "100%",
            height: "100%",
            backgroundColor: theme.palette.mode === "dark" ? "white" : "black",
            opacity: 0.2,
            zIndex: 1,
            transition: "opacity 0.3s ease-out",
        };
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { sx: {
            width: trialWidth,
            minHeight: trialHeight,
            margin: theme.spacing(2),
            padding: 0,
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h5" },
                "Trial ",
                trial.number),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { sx: {
                    marginLeft: "auto",
                }, onClick: () => setDetailShown(true), "aria-label": "show detail" },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_OpenInFull__WEBPACK_IMPORTED_MODULE_13__["default"], null))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { "aria-label": "trial", sx: cardComponentSx },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                    padding: theme.spacing(2),
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_6__.PreferentialOutputComponent, { trial: trial, artifact: artifact, componentType: componentType, urlPath: urlPath })),
            type === "worst" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_16__["default"], { sx: {
                    position: "absolute",
                    width: "100%",
                    height: "100%",
                    top: 0,
                    left: 0,
                    color: _mui_material_colors__WEBPACK_IMPORTED_MODULE_17__["default"][600],
                    zIndex: 1,
                    opacity: 0.3,
                    filter: theme.palette.mode === "dark"
                        ? "brightness(1.1)"
                        : "brightness(1.7)",
                } })) : null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Modal__WEBPACK_IMPORTED_MODULE_18__["default"], { open: detailShown, onClose: () => setDetailShown(false) },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                    position: "absolute",
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0,
                    width: "80%",
                    maxHeight: "90%",
                    margin: "auto",
                    overflow: "hidden",
                    backgroundColor: theme.palette.mode === "dark" ? "black" : "white",
                    borderRadius: theme.spacing(3),
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                        width: "100%",
                        height: "100%",
                        overflow: "auto",
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { sx: {
                            position: "absolute",
                            top: theme.spacing(2),
                            right: theme.spacing(2),
                        }, onClick: () => setDetailShown(false) },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_16__["default"], null)),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_TrialList__WEBPACK_IMPORTED_MODULE_5__.TrialListDetail, { trial: trial, isBestTrial: () => false, directions: [], metricNames: [] }))))));
};
const ChoiceTrials = ({ choice, trials, studyId }) => {
    const [isRemoved, setRemoved] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(choice.is_removed);
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])();
    const worst_trials = new Set([choice.clicked]);
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
            marginBottom: theme.spacing(4),
            position: "relative",
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                display: "flex",
                flexDirection: "row",
                flexWrap: "wrap",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h6", sx: {
                    fontWeight: theme.typography.fontWeightLight,
                    margin: "auto 0",
                } }, (0,_dateUtil__WEBPACK_IMPORTED_MODULE_3__.formatDate)(choice.timestamp)),
            choice.is_removed ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { disabled: !isRemoved, onClick: () => {
                    setRemoved(false);
                    action.restorePreferentialHistory(studyId, choice.id);
                }, sx: {
                    margin: `auto ${theme.spacing(2)}`,
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_RestoreFromTrash__WEBPACK_IMPORTED_MODULE_19__["default"], null))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_12__["default"], { disabled: isRemoved, onClick: () => {
                    setRemoved(true);
                    action.removePreferentialHistory(studyId, choice.id);
                }, sx: {
                    margin: `auto ${theme.spacing(2)}`,
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Delete__WEBPACK_IMPORTED_MODULE_20__["default"], null)))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", sx: {
                display: "flex",
                flexDirection: "row",
                flexWrap: "wrap",
                filter: choice.is_removed ? "brightness(0.4)" : undefined,
                backgroundColor: theme.palette.background.paper,
            } }, choice.candidates.map((trial_num, index) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(CandidateTrial, { key: index, trial: trials[trial_num], type: worst_trials.has(trial_num) ? "worst" : "none" }))))));
};
const PreferentialHistory = ({ studyDetail, }) => {
    if (studyDetail === null ||
        !studyDetail.is_preferential ||
        studyDetail.preference_history === undefined) {
        return null;
    }
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])();
    const preference_histories = [...studyDetail.preference_history];
    if (preference_histories.length === 0) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h5", sx: {
                margin: theme.spacing(4),
                fontWeight: theme.typography.fontWeightBold,
            } }, "No feedback history"));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "div", padding: theme.spacing(2), sx: { display: "flex", flexDirection: "column" } }, preference_histories.reverse().map((choice) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(ChoiceTrials, { key: choice.id, choice: choice, trials: studyDetail.trials, studyId: studyDetail.id })))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Preferential/PreferentialOutputComponent.js":
/*!**************************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Preferential/PreferentialOutputComponent.js ***!
  \**************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PreferentialOutputComponent: () => (/* binding */ PreferentialOutputComponent)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Artifact_ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../Artifact/ArtifactCardMedia */ "../optuna_dashboard/pkg/components/Artifact/ArtifactCardMedia.js");
/* harmony import */ var _Note__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../Note */ "../optuna_dashboard/pkg/components/Note.js");



const PreferentialOutputComponent = ({ trial, artifact, componentType, urlPath }) => {
    const note = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        return react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Note__WEBPACK_IMPORTED_MODULE_2__.MarkdownRenderer, { body: trial.note.body });
    }, [trial.note.body]);
    if (componentType === undefined || componentType.output_type === "note") {
        return note;
    }
    if (componentType.output_type === "artifact") {
        if (artifact === undefined) {
            return null;
        }
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Artifact_ArtifactCardMedia__WEBPACK_IMPORTED_MODULE_1__.ArtifactCardMedia, { artifact: artifact, urlPath: urlPath, height: "100%" }));
    }
    return null;
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Preferential/PreferentialTrials.js":
/*!*****************************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Preferential/PreferentialTrials.js ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PreferentialTrials: () => (/* binding */ PreferentialTrials),
/* harmony export */   getArtifactUrlPath: () => (/* binding */ getArtifactUrlPath)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/icons-material/Clear */ "../tslib/react/node_modules/@mui/icons-material/esm/Clear.js");
/* harmony import */ var _mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/icons-material/Fullscreen */ "../tslib/react/node_modules/@mui/icons-material/esm/Fullscreen.js");
/* harmony import */ var _mui_icons_material_OpenInFull__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/icons-material/OpenInFull */ "../tslib/react/node_modules/@mui/icons-material/esm/OpenInFull.js");
/* harmony import */ var _mui_icons_material_Replay__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/icons-material/Replay */ "../tslib/react/node_modules/@mui/icons-material/esm/Replay.js");
/* harmony import */ var _mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/icons-material/Settings */ "../tslib/react/node_modules/@mui/icons-material/esm/Settings.js");
/* harmony import */ var _mui_icons_material_Undo__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/icons-material/Undo */ "../tslib/react/node_modules/@mui/icons-material/esm/Undo.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActions/CardActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CircularProgress/CircularProgress.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Modal/Modal.js");
/* harmony import */ var _mui_material_IconButton__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material/IconButton */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material_colors__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/material/colors */ "../tslib/react/node_modules/@mui/material/colors/red.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _Artifact_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../Artifact/ThreejsArtifactViewer */ "../optuna_dashboard/pkg/components/Artifact/ThreejsArtifactViewer.js");
/* harmony import */ var _TrialList__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../TrialList */ "../optuna_dashboard/pkg/components/TrialList.js");
/* harmony import */ var _PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./PreferentialOutputComponent */ "../optuna_dashboard/pkg/components/Preferential/PreferentialOutputComponent.js");















const SettingsPage = ({ studyDetail, settingShown, setSettingShown }) => {
    const actions = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [outputComponentType, setOutputComponentType] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(studyDetail.feedback_component_type.output_type);
    const [artifactKey, setArtifactKey] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(studyDetail.feedback_component_type.output_type === "artifact"
        ? studyDetail.feedback_component_type.artifact_key
        : undefined);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        setOutputComponentType(studyDetail.feedback_component_type.output_type);
    }, [studyDetail.feedback_component_type.output_type]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (studyDetail.feedback_component_type.output_type === "artifact") {
            setArtifactKey(studyDetail.feedback_component_type.artifact_key);
        }
    }, [
        studyDetail.feedback_component_type.output_type === "artifact"
            ? studyDetail.feedback_component_type.artifact_key
            : undefined,
    ]);
    const onClose = () => {
        setSettingShown(false);
    };
    const onApply = () => {
        setSettingShown(false);
        const outputComponent = outputComponentType === "note"
            ? { output_type: "note" }
            : {
                output_type: "artifact",
                artifact_key: artifactKey,
            };
        actions.updateFeedbackComponent(studyDetail.id, outputComponent);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { open: settingShown, onClose: onClose, maxWidth: "sm", fullWidth: true },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], null, "Settings"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { sx: {
                display: "flex",
                flexDirection: "column",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { component: "fieldset" },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "legend" }, "Output Component:"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { value: outputComponentType, onChange: (e) => {
                        setOutputComponentType(e.target.value);
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: "note" }, "Note"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: "artifact" }, "Artifact"))),
            outputComponentType === "artifact" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { component: "fieldset", disabled: studyDetail.union_user_attrs.length === 0 },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "legend" }, "User Attribute Key Corresponding to Output Artifact Id:"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { value: studyDetail.union_user_attrs.length !== 0
                        ? artifactKey !== null && artifactKey !== void 0 ? artifactKey : ""
                        : "error", onChange: (e) => {
                        setArtifactKey(e.target.value);
                    } },
                    studyDetail.union_user_attrs.length === 0 ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: "error" }, "No user attributes")) : null,
                    studyDetail.union_user_attrs.map((attr, index) => {
                        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { key: index, value: attr.key }, attr.key));
                    })))) : null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { onClick: onClose, color: "primary" }, "Cancel"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { onClick: onApply, color: "primary", disabled: outputComponentType === "artifact" && artifactKey === undefined }, "Apply"))));
};
const isComparisonReady = (trial, componentType) => {
    var _a;
    if (componentType === undefined || componentType.output_type === "note") {
        return trial.note.body !== "";
    }
    if (componentType.output_type === "artifact") {
        const artifactId = (_a = trial === null || trial === void 0 ? void 0 : trial.user_attrs.find((a) => a.key === componentType.artifact_key)) === null || _a === void 0 ? void 0 : _a.value;
        const artifact = trial === null || trial === void 0 ? void 0 : trial.artifacts.find((a) => a.artifact_id === artifactId);
        return artifact !== undefined;
    }
    return false;
};
const getArtifactUrlPath = (environment, studyId, trialId, artifactId) => {
    const apiNamespace = environment === "jupyterlab" ? "/jupyterlab-optuna" : "";
    return `${apiNamespace}/artifacts/${studyId}/${trialId}/${artifactId}`;
};
const PreferentialTrial = ({ trial, studyDetail, candidates, hideTrial, openDetailTrial, openThreejsArtifactModal, }) => {
    var _a;
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"])();
    const { environment } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_2__.useConstants)();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [buttonHover, setButtonHover] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const trialWidth = 400;
    const trialHeight = 300;
    const componentType = studyDetail.feedback_component_type;
    const artifactId = componentType.output_type === "artifact"
        ? (_a = trial === null || trial === void 0 ? void 0 : trial.user_attrs.find((a) => a.key === componentType.artifact_key)) === null || _a === void 0 ? void 0 : _a.value
        : undefined;
    const artifact = trial === null || trial === void 0 ? void 0 : trial.artifacts.find((a) => a.artifact_id === artifactId);
    const urlPath = trial !== undefined && artifactId !== undefined
        ? getArtifactUrlPath(environment, studyDetail.id, trial === null || trial === void 0 ? void 0 : trial.trial_id, artifactId)
        : "";
    const is3dModel = componentType.output_type === "artifact" &&
        artifact !== undefined &&
        (0,_Artifact_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_3__.isThreejsArtifact)(artifact);
    if (trial === undefined) {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: {
                width: trialWidth,
                minHeight: trialHeight,
                margin: theme.spacing(2),
            } }));
    }
    const onFeedback = () => {
        hideTrial();
        action.updatePreference(trial.study_id, candidates, trial.number);
    };
    const isReady = isComparisonReady(trial, componentType);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { sx: {
            width: trialWidth,
            minHeight: trialHeight,
            margin: theme.spacing(2),
            padding: 0,
            display: "flex",
            flexDirection: "column",
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: {
                    margin: theme.spacing(0, 2),
                    maxWidth: `calc(${trialWidth}px - ${is3dModel ? theme.spacing(8) : theme.spacing(4)})`,
                    overflow: "hidden",
                    display: "flex",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { variant: "h5" },
                    "Trial ",
                    trial.number),
                componentType.output_type === "artifact" &&
                    artifact !== undefined ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { variant: "h6", sx: {
                        margin: theme.spacing(0, 2),
                    } }, `(${artifact.filename})`)) : null),
            is3dModel ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_20__["default"], { "aria-label": "show artifact 3d model", size: "small", color: "inherit", sx: { marginLeft: "auto" }, onClick: () => {
                    openThreejsArtifactModal(urlPath, artifact);
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Fullscreen__WEBPACK_IMPORTED_MODULE_21__["default"], null))) : null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_20__["default"], { sx: {
                    marginLeft: "auto",
                }, onClick: () => {
                    hideTrial();
                    action.skipPreferentialTrial(trial.study_id, trial.trial_id);
                }, "aria-label": "skip trial" },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Replay__WEBPACK_IMPORTED_MODULE_22__["default"], null)),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_20__["default"], { sx: {
                    marginLeft: "auto",
                }, onClick: openDetailTrial, "aria-label": "show detail" },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_OpenInFull__WEBPACK_IMPORTED_MODULE_23__["default"], null))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { "aria-label": "trial-button", onClick: (e) => {
                if (e.shiftKey)
                    onFeedback();
            }, sx: {
                position: "relative",
                padding: theme.spacing(2),
                overflow: "hidden",
                minHeight: theme.spacing(20),
            } }, isReady ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_PreferentialOutputComponent__WEBPACK_IMPORTED_MODULE_5__.PreferentialOutputComponent, { trial: trial, artifact: artifact, componentType: componentType, urlPath: urlPath }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: {
                    position: "absolute",
                    top: 0,
                    left: 0,
                    width: "100%",
                    height: "100%",
                    backgroundColor: theme.palette.mode === "dark" ? "white" : "black",
                    opacity: buttonHover ? 0.2 : 0,
                    zIndex: 1,
                    transition: "opacity 0.3s ease-out",
                    pointerEvents: "none",
                } }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_25__["default"], { sx: {
                    position: "absolute",
                    top: 0,
                    left: 0,
                    width: "100%",
                    height: "100%",
                    color: _mui_material_colors__WEBPACK_IMPORTED_MODULE_26__["default"][600],
                    opacity: buttonHover ? 0.3 : 0,
                    transition: "opacity 0.3s ease-out",
                    zIndex: 1,
                    filter: buttonHover
                        ? theme.palette.mode === "dark"
                            ? "brightness(1.1)"
                            : "brightness(1.7)"
                        : "none",
                    pointerEvents: "none",
                } }))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_27__["default"], { sx: {
                position: "absolute",
                top: 0,
                left: 0,
                right: 0,
                bottom: 0,
                margin: "auto",
            } }))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { variant: "outlined", onClick: onFeedback, onMouseEnter: () => {
                setButtonHover(true);
            }, onMouseLeave: () => {
                setButtonHover(false);
            }, color: "error", disabled: !isReady && candidates.length > 0, sx: {
                marginTop: "auto",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_25__["default"], null),
            "Worst")));
};
const PreferentialTrials = ({ studyDetail, }) => {
    var _a, _b, _c, _d, _e;
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const [undoHistoryFlag, setUndoHistoryFlag] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [openThreejsArtifactModal, renderThreejsArtifactModal] = (0,_Artifact_ThreejsArtifactViewer__WEBPACK_IMPORTED_MODULE_3__.useThreejsArtifactModal)();
    const [displayTrials, setDisplayTrials] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({
        display: [],
        clicked: [],
    });
    const [settingShown, setSettingShown] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [detailTrial, setDetailTrial] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(null);
    if (studyDetail === null || !studyDetail.is_preferential) {
        return null;
    }
    const hiddenTrials = new Set((_b = (_a = studyDetail.preference_history) === null || _a === void 0 ? void 0 : _a.filter((h) => !h.is_removed).map((p) => p.clicked).concat(studyDetail.skipped_trial_numbers)) !== null && _b !== void 0 ? _b : []);
    const activeTrials = studyDetail.trials.filter((t) => (t.state === "Running" || t.state === "Complete") &&
        !hiddenTrials.has(t.number));
    const newTrials = activeTrials.filter((t) => !displayTrials.display.includes(t.number) &&
        !displayTrials.clicked.includes(t.number));
    const deleteTrials = displayTrials.display.filter((t) => t !== -1 && !activeTrials.map((t) => t.number).includes(t));
    if (newTrials.length > 0 || deleteTrials.length > 0) {
        setDisplayTrials((prev) => {
            const display = [...prev.display].map((t) => deleteTrials.includes(t) ? -1 : t);
            const clicked = [...prev.clicked];
            newTrials.map((t) => {
                const index = display.findIndex((n) => n === -1);
                if (index === -1) {
                    display.push(t.number);
                    clicked.push(-1);
                }
                else {
                    display[index] = t.number;
                }
            });
            return {
                display: display,
                clicked: clicked,
            };
        });
    }
    const hideTrial = (num) => {
        setDisplayTrials((prev) => {
            const index = prev.display.findIndex((n) => n === num);
            if (index === -1) {
                return prev;
            }
            const display = [...prev.display];
            const clicked = [...prev.clicked];
            display[index] = -1;
            clicked[index] = num;
            return {
                display: display,
                clicked: clicked,
            };
        });
    };
    const visibleTrial = (num) => {
        setDisplayTrials((prev) => {
            const index = prev.clicked.findIndex((n) => n === num);
            if (index === -1) {
                return prev;
            }
            const clicked = [...prev.clicked];
            clicked[index] = -1;
            return {
                display: prev.display,
                clicked: clicked,
            };
        });
    };
    const latestHistoryId = (_e = (_d = (_c = studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.preference_history) === null || _c === void 0 ? void 0 : _c.filter((h) => !h.is_removed).pop()) === null || _d === void 0 ? void 0 : _d.id) !== null && _e !== void 0 ? _e : null;
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", padding: theme.spacing(2) },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", display: "flex" },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { variant: "h4", sx: {
                    fontWeight: theme.typography.fontWeightBold,
                } }, "Which trial is the worst?"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", display: "flex", sx: {
                    marginLeft: "auto",
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { variant: "outlined", disabled: latestHistoryId === null || undoHistoryFlag, sx: {
                        marginRight: theme.spacing(2),
                    }, startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Undo__WEBPACK_IMPORTED_MODULE_28__["default"], null), onClick: () => {
                        var _a, _b, _c;
                        if (latestHistoryId === null) {
                            return;
                        }
                        setUndoHistoryFlag(true);
                        const clicked = (_c = (_b = (_a = studyDetail.preference_history) === null || _a === void 0 ? void 0 : _a.filter((h) => h.id === latestHistoryId)) === null || _b === void 0 ? void 0 : _b.pop()) === null || _c === void 0 ? void 0 : _c.clicked;
                        if (clicked !== undefined)
                            visibleTrial(clicked);
                        action.removePreferentialHistory(studyDetail.id, latestHistoryId);
                        setUndoHistoryFlag(false);
                    } }, "Undo"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { variant: "outlined", sx: {
                        marginRight: theme.spacing(2),
                    }, startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Settings__WEBPACK_IMPORTED_MODULE_29__["default"], null), onClick: () => setSettingShown(true) }, "Settings"))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", flexWrap: "wrap" } }, displayTrials.display.map((t, index) => {
            const trial = activeTrials.find((trial) => trial.number === t);
            const candidates = displayTrials.display.filter((n) => n !== -1 &&
                isComparisonReady(studyDetail.trials[n], studyDetail.feedback_component_type));
            return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(PreferentialTrial, { key: t === -1 ? -index - 1 : t, trial: trial, studyDetail: studyDetail, candidates: candidates, hideTrial: () => hideTrial(t), openDetailTrial: () => setDetailTrial(t), openThreejsArtifactModal: openThreejsArtifactModal }));
        })),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(SettingsPage, { settingShown: settingShown, setSettingShown: setSettingShown, studyDetail: studyDetail }),
        detailTrial !== null && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_30__["default"], { open: true, onClose: () => setDetailTrial(null) },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: {
                    position: "absolute",
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0,
                    width: "80%",
                    maxHeight: "90%",
                    margin: "auto",
                    overflow: "hidden",
                    backgroundColor: theme.palette.background.default,
                    borderRadius: theme.spacing(3),
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { component: "div", sx: {
                        width: "100%",
                        height: "100%",
                        overflow: "auto",
                        position: "relative",
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_IconButton__WEBPACK_IMPORTED_MODULE_20__["default"], { sx: {
                            position: "absolute",
                            top: theme.spacing(2),
                            right: theme.spacing(2),
                        }, onClick: () => setDetailTrial(null) },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_25__["default"], null)),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_TrialList__WEBPACK_IMPORTED_MODULE_4__.TrialListDetail, { trial: studyDetail.trials[detailTrial], isBestTrial: (trialId) => {
                            var _a, _b;
                            return (_b = ((_a = studyDetail.trials.find((t) => t.trial_id === trialId)) === null || _a === void 0 ? void 0 : _a.state) === "Complete") !== null && _b !== void 0 ? _b : false;
                        }, directions: [], metricNames: [] }))))),
        renderThreejsArtifactModal()));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/RenameStudyDialog.js":
/*!***************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/RenameStudyDialog.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useRenameStudyDialog: () => (/* binding */ useRenameStudyDialog)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Dialog/Dialog.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogTitle/DialogTitle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContent/DialogContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogContentText/DialogContentText.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/DialogActions/DialogActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _Debounce__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./Debounce */ "../optuna_dashboard/pkg/components/Debounce.js");




const useRenameStudyDialog = (studies) => {
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"])();
    const [openRenameStudyDialog, setOpenRenameStudyDialog] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [renameStudyID, setRenameStudyID] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(-1);
    const [prevStudyName, setPrevStudyName] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const [newStudyName, setNewStudyName] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const newStudyNameAlreadyUsed = studies.some((v) => v.study_name === newStudyName);
    const handleCloseRenameStudyDialog = () => {
        setOpenRenameStudyDialog(false);
        setRenameStudyID(-1);
        setPrevStudyName("");
    };
    const handleRenameStudy = () => {
        action.renameStudy(renameStudyID, newStudyName);
        setOpenRenameStudyDialog(false);
        setRenameStudyID(-1);
        setPrevStudyName("");
    };
    const openDialog = (studyId, prevStudyName) => {
        setRenameStudyID(studyId);
        setPrevStudyName(prevStudyName);
        setOpenRenameStudyDialog(true);
    };
    const renderRenameStudyDialog = () => {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { open: openRenameStudyDialog, onClose: () => {
                handleCloseRenameStudyDialog();
            }, "aria-labelledby": "rename-study-dialog-title" },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { id: "rename-study-dialog-title" },
                "Rename \"",
                prevStudyName,
                "\""),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                        fontWeight: theme.typography.fontWeightBold,
                        marginBottom: theme.spacing(1),
                    } }, "Please note that the study_id will be changed because this function internally creates a new study and copies all trials to it."),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], null, "Please enter the new study name."),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Debounce__WEBPACK_IMPORTED_MODULE_2__.DebouncedInputTextField, { onChange: (s) => {
                        setNewStudyName(s);
                    }, delay: 500, textFieldProps: {
                        autoFocus: true,
                        fullWidth: true,
                        error: newStudyNameAlreadyUsed,
                        helperText: newStudyNameAlreadyUsed
                            ? `"${newStudyName}" is already used`
                            : "",
                        label: "Study name",
                        type: "text",
                    } })),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { onClick: handleCloseRenameStudyDialog, color: "primary" }, "Cancel"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { onClick: handleRenameStudy, color: "primary" }, "Rename"))));
    };
    return [openDialog, renderRenameStudyDialog];
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/Settings.js":
/*!******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/Settings.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Settings: () => (/* binding */ Settings)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/icons-material/Clear */ "../tslib/react/node_modules/@mui/icons-material/esm/Clear.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Stack/Stack.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Link/Link.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");





const Settings = ({ handleClose }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"])();
    const [plotlyColorTheme, setPlotlyColorTheme] = (0,_state__WEBPACK_IMPORTED_MODULE_2__.usePlotlyColorThemeState)();
    const [plotBackendRendering, setPlotBackendRendering] = (0,_state__WEBPACK_IMPORTED_MODULE_2__.usePlotBackendRendering)();
    const plotlypyIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_2__.plotlypyIsAvailableState);
    const handleDarkModeColorChange = (event) => {
        const dark = event.target.value;
        setPlotlyColorTheme((cur) => (Object.assign(Object.assign({}, cur), { dark })));
    };
    const handleLightModeColorChange = (event) => {
        const light = event.target.value;
        setPlotlyColorTheme((cur) => (Object.assign(Object.assign({}, cur), { light })));
    };
    const togglePlotBackendRendering = () => {
        setPlotBackendRendering((cur) => !cur);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"], { component: "div", sx: { position: "relative" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { spacing: 4, sx: {
                p: "2rem",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { variant: "h4", sx: { fontWeight: theme.typography.fontWeightBold } }, "Settings"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { spacing: 2 },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { variant: "h5", sx: { fontWeight: theme.typography.fontWeightBold } }, "Plotly Color Scales"),
                theme.palette.mode === "dark" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { variant: "h6" }, "Dark Mode"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { color: "textSecondary" }, "Only the \"Default\" color scale is supported in dark mode"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { disabled: true, value: plotlyColorTheme.dark, onChange: handleDarkModeColorChange }, [{ value: "default", label: "Default" }].map((v) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { key: v.value, value: v.value }, v.label)))))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { variant: "h6" }, "Light Mode"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { value: plotlyColorTheme.light, onChange: handleLightModeColorChange }, [
                        { value: "default", label: "Default" },
                        { value: "seaborn", label: "Seaborn" },
                        { value: "presentation", label: "Presentation" },
                        { value: "ggplot2", label: "GGPlot2" },
                    ].map((v) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { key: v.value, value: v.value }, v.label))))))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { variant: "h5", sx: { fontWeight: theme.typography.fontWeightBold } }, "Use Plotly Python library"),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { color: "textSecondary" },
                    "If enabled, the plots will be rendered using the ",
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { href: "https://optuna.readthedocs.io/en/stable/reference/visualization/index.html" }, "optuna.visualization module"),
                    "."),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { checked: plotBackendRendering, onChange: togglePlotBackendRendering, value: "enable", disabled: !plotlypyIsAvailable }))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { sx: {
                position: "absolute",
                top: "1rem",
                right: "1rem",
                width: "2rem",
                height: "2rem",
            }, onClick: handleClose },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Clear__WEBPACK_IMPORTED_MODULE_12__["default"], null))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/StudyDetail.js":
/*!*********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/StudyDetail.js ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StudyDetail: () => (/* binding */ StudyDetail),
/* harmony export */   useURLVars: () => (/* binding */ useURLVars)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! @mui/icons-material/ChevronRight */ "../tslib/react/node_modules/@mui/icons-material/esm/ChevronRight.js");
/* harmony import */ var _mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/icons-material/Download */ "../tslib/react/node_modules/@mui/icons-material/esm/Download.js");
/* harmony import */ var _mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! @mui/icons-material/Home */ "../tslib/react/node_modules/@mui/icons-material/esm/Home.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material_Grid__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/material/Grid */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _graphUtil__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../graphUtil */ "../optuna_dashboard/pkg/graphUtil.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _AppDrawer__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./AppDrawer */ "../optuna_dashboard/pkg/components/AppDrawer.js");
/* harmony import */ var _GraphContour__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./GraphContour */ "../optuna_dashboard/pkg/components/GraphContour.js");
/* harmony import */ var _GraphEdf__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./GraphEdf */ "../optuna_dashboard/pkg/components/GraphEdf.js");
/* harmony import */ var _GraphParallelCoordinate__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./GraphParallelCoordinate */ "../optuna_dashboard/pkg/components/GraphParallelCoordinate.js");
/* harmony import */ var _GraphRank__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./GraphRank */ "../optuna_dashboard/pkg/components/GraphRank.js");
/* harmony import */ var _GraphSlice__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./GraphSlice */ "../optuna_dashboard/pkg/components/GraphSlice.js");
/* harmony import */ var _Note__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./Note */ "../optuna_dashboard/pkg/components/Note.js");
/* harmony import */ var _Preferential_PreferentialAnalytics__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./Preferential/PreferentialAnalytics */ "../optuna_dashboard/pkg/components/Preferential/PreferentialAnalytics.js");
/* harmony import */ var _Preferential_PreferentialGraph__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./Preferential/PreferentialGraph */ "../optuna_dashboard/pkg/components/Preferential/PreferentialGraph.js");
/* harmony import */ var _Preferential_PreferentialHistory__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./Preferential/PreferentialHistory */ "../optuna_dashboard/pkg/components/Preferential/PreferentialHistory.js");
/* harmony import */ var _Preferential_PreferentialTrials__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./Preferential/PreferentialTrials */ "../optuna_dashboard/pkg/components/Preferential/PreferentialTrials.js");
/* harmony import */ var _StudyHistory__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./StudyHistory */ "../optuna_dashboard/pkg/components/StudyHistory.js");
/* harmony import */ var _TrialList__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./TrialList */ "../optuna_dashboard/pkg/components/TrialList.js");


























const useURLVars = () => {
    const { studyId } = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_20__.useParams)();
    if (studyId === undefined) {
        throw new Error("studyId is not defined");
    }
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => parseInt(studyId, 10), [studyId]);
};
const StudyDetail = ({ toggleColorMode, page }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_4__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_3__.actionCreator)();
    const studyId = useURLVars();
    const studyDetail = (0,_state__WEBPACK_IMPORTED_MODULE_6__.useStudyDetailValue)(studyId);
    const reloadInterval = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_6__.reloadIntervalState);
    const studyName = (0,_state__WEBPACK_IMPORTED_MODULE_6__.useStudyName)(studyId);
    const isPreferential = (0,_state__WEBPACK_IMPORTED_MODULE_6__.useStudyIsPreferential)(studyId);
    const study = (0,_graphUtil__WEBPACK_IMPORTED_MODULE_5__.studyDetailToStudy)(studyDetail);
    const title = studyName !== null ? `${studyName} (id=${studyId})` : `Study #${studyId}`;
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        action.updateStudyDetail(studyId);
        action.updateAPIMeta();
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        if (reloadInterval < 0) {
            return;
        }
        const nTrials = studyDetail ? studyDetail.trials.length : 0;
        let interval = reloadInterval * 1000;
        // For Human-in-the-loop Optimization, the interval is set to 2 seconds
        // when the number of trials is small, and the page is "trialList" or top page of preferential.
        if ((!isPreferential && page === "trialList") ||
            (isPreferential && page === "top")) {
            if (nTrials < 100) {
                interval = 2000;
            }
            else if (nTrials < 500) {
                interval = 5000;
            }
        }
        const intervalId = setInterval(() => {
            action.updateStudyDetail(studyId);
        }, interval);
        return () => clearInterval(intervalId);
    }, [reloadInterval, studyDetail, page]);
    let content = null;
    if (page === "top") {
        content = isPreferential ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Preferential_PreferentialTrials__WEBPACK_IMPORTED_MODULE_17__.PreferentialTrials, { studyDetail: studyDetail })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_StudyHistory__WEBPACK_IMPORTED_MODULE_18__.StudyHistory, { studyId: studyId }));
    }
    else if (page === "analytics") {
        content = isPreferential ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Preferential_PreferentialAnalytics__WEBPACK_IMPORTED_MODULE_14__.PreferentialAnalytics, { studyId: studyId })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { component: "div", sx: { display: "flex", width: "100%", flexDirection: "column" } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { variant: "h5", sx: {
                    margin: theme.spacing(2),
                    marginTop: theme.spacing(4),
                    fontWeight: theme.typography.fontWeightBold,
                } }, "Hyperparameter Relationships"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { sx: { margin: theme.spacing(2) } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_GraphSlice__WEBPACK_IMPORTED_MODULE_12__.GraphSlice, { study: studyDetail }))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { sx: { margin: theme.spacing(2) } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_GraphParallelCoordinate__WEBPACK_IMPORTED_MODULE_10__.GraphParallelCoordinate, { study: studyDetail }))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { sx: { margin: theme.spacing(2) } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_GraphContour__WEBPACK_IMPORTED_MODULE_8__.Contour, { study: studyDetail }))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { sx: { margin: theme.spacing(2) } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_GraphRank__WEBPACK_IMPORTED_MODULE_11__.GraphRank, { study: studyDetail }))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { variant: "h5", sx: {
                    margin: theme.spacing(2),
                    marginTop: theme.spacing(4),
                    fontWeight: theme.typography.fontWeightBold,
                } }, "Empirical Distribution of the Objective Value"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_26__["default"], { container: true, spacing: 2, sx: { padding: theme.spacing(2) } }, studyDetail !== null
                ? studyDetail.directions.map((d, i) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_26__["default"], { item: true, xs: 6, key: i },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_GraphEdf__WEBPACK_IMPORTED_MODULE_9__.GraphEdf, { studies: [studyDetail], objectiveId: i }))))))
                : null)));
    }
    else if (page === "trialList") {
        content = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_TrialList__WEBPACK_IMPORTED_MODULE_19__.TrialList, { studyDetail: studyDetail });
    }
    else if (page === "trialTable" && study !== null) {
        const linkURL = (studyId, trialNumber) => {
            return url_prefix + `/studies/${studyId}/trials?numbers=${trialNumber}`;
        };
        content = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { component: "div", sx: { display: "flex", width: "100%", flexDirection: "column" } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { sx: { margin: theme.spacing(2) } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_2__.TrialTable, { study: study, linkComponent: react_router_dom__WEBPACK_IMPORTED_MODULE_27__.Link, linkURL: linkURL }),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_28__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Download__WEBPACK_IMPORTED_MODULE_29__["default"], null), download: true, href: `/csv/${studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.id}`, sx: { marginRight: theme.spacing(2), minWidth: "120px" } }, "Download CSV File")))));
    }
    else if (page === "note" && studyDetail !== null) {
        content = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { component: "div", sx: {
                height: `calc(100vh - ${theme.spacing(8)})`,
                display: "flex",
                flexDirection: "column",
                padding: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { variant: "h5", sx: {
                    fontWeight: theme.typography.fontWeightBold,
                    margin: theme.spacing(2, 0),
                } }, "Note"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Note__WEBPACK_IMPORTED_MODULE_13__.StudyNote, { studyId: studyId, latestNote: studyDetail.note, cardSx: { flexGrow: 1 } })));
    }
    else if (page === "graph") {
        content = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { component: "div", sx: {
                height: `calc(100vh - ${theme.spacing(8)})`,
                padding: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Preferential_PreferentialGraph__WEBPACK_IMPORTED_MODULE_15__.PreferentialGraph, { studyDetail: studyDetail })));
    }
    else if (page === "preferenceHistory") {
        content = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Preferential_PreferentialHistory__WEBPACK_IMPORTED_MODULE_16__.PreferentialHistory, { studyDetail: studyDetail });
    }
    const toolbar = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_30__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_27__.Link, to: url_prefix + "/", sx: { marginRight: theme.spacing(1) }, color: "inherit", title: "Return to the top page" },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_31__["default"], null)),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_ChevronRight__WEBPACK_IMPORTED_MODULE_32__["default"], { sx: { marginRight: theme.spacing(1) } }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], { noWrap: true, component: "div", sx: { fontWeight: theme.typography.fontWeightBold } }, title)));
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { component: "div", sx: { display: "flex" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_AppDrawer__WEBPACK_IMPORTED_MODULE_7__.AppDrawer, { studyId: studyId, page: page, toggleColorMode: toggleColorMode, toolbar: toolbar }, content)));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/StudyHistory.js":
/*!**********************************************************!*\
  !*** ../optuna_dashboard/pkg/components/StudyHistory.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StudyHistory: () => (/* binding */ StudyHistory)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material/FormControlLabel */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material/Grid */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _optuna_react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @optuna/react */ "../tslib/react/pkg/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _Artifact_StudyArtifactCards__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./Artifact/StudyArtifactCards */ "../optuna_dashboard/pkg/components/Artifact/StudyArtifactCards.js");
/* harmony import */ var _BestTrialsCard__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./BestTrialsCard */ "../optuna_dashboard/pkg/components/BestTrialsCard.js");
/* harmony import */ var _GraphHistory__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./GraphHistory */ "../optuna_dashboard/pkg/components/GraphHistory.js");
/* harmony import */ var _GraphHyperparameterImportances__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./GraphHyperparameterImportances */ "../optuna_dashboard/pkg/components/GraphHyperparameterImportances.js");
/* harmony import */ var _GraphIntermediateValues__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./GraphIntermediateValues */ "../optuna_dashboard/pkg/components/GraphIntermediateValues.js");
/* harmony import */ var _GraphParetoFront__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./GraphParetoFront */ "../optuna_dashboard/pkg/components/GraphParetoFront.js");
/* harmony import */ var _GraphTimeline__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./GraphTimeline */ "../optuna_dashboard/pkg/components/GraphTimeline.js");
/* harmony import */ var _UserDefinedPlot__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./UserDefinedPlot */ "../optuna_dashboard/pkg/components/UserDefinedPlot.js");
/* harmony import */ var _tanstack_react_table__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @tanstack/react-table */ "../tslib/react/node_modules/@tanstack/table-core/build/lib/index.mjs");

















const StudyHistory = ({ studyId }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"])();
    const directions = (0,_state__WEBPACK_IMPORTED_MODULE_3__.useStudyDirections)(studyId);
    const studySummary = (0,_state__WEBPACK_IMPORTED_MODULE_3__.useStudySummaryValue)(studyId);
    const studyDetail = (0,_state__WEBPACK_IMPORTED_MODULE_3__.useStudyDetailValue)(studyId);
    const [logScale, setLogScale] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
    const [includePruned, setIncludePruned] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(true);
    const artifactEnabled = (0,recoil__WEBPACK_IMPORTED_MODULE_2__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_3__.artifactIsAvailable);
    const handleLogScaleChange = () => {
        setLogScale(!logScale);
    };
    const handleIncludePrunedChange = () => {
        setIncludePruned(!includePruned);
    };
    const userAttrs = (studySummary === null || studySummary === void 0 ? void 0 : studySummary.user_attrs) || (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.user_attrs) || [];
    const columnHelper = (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_13__.createColumnHelper)();
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const columns = [
        columnHelper.accessor("key", {
            header: "Key",
            enableSorting: true,
            enableColumnFilter: false,
        }),
        columnHelper.accessor("value", {
            header: "Value",
            enableSorting: true,
            enableColumnFilter: false,
        }),
    ];
    const trials = (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.trials) || [];
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { display: "flex", width: "100%", flexDirection: "column" } },
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { component: "fieldset", sx: {
                display: "flex",
                flexDirection: "row",
                justifyContent: "flex-end",
                padding: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_16__["default"], { control: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { checked: logScale, onChange: handleLogScaleChange, value: "enable" }), label: "Log y scale" }),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_FormControlLabel__WEBPACK_IMPORTED_MODULE_16__["default"], { control: react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { checked: studyDetail
                        ? studyDetail.has_intermediate_values && includePruned
                        : false, onChange: handleIncludePrunedChange, disabled: !(studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.has_intermediate_values), value: "enable" }), label: "Include PRUNED trials" })),
        directions !== null && directions.length > 1 ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { sx: { margin: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphParetoFront__WEBPACK_IMPORTED_MODULE_9__.GraphParetoFront, { study: studyDetail })))) : null,
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { sx: {
                margin: theme.spacing(2),
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], null,
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphHistory__WEBPACK_IMPORTED_MODULE_6__.GraphHistory, { studies: studyDetail !== null ? [studyDetail] : [], includePruned: includePruned, logScale: logScale }))),
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { container: true, spacing: 2, sx: { padding: theme.spacing(0, 2) } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphHyperparameterImportances__WEBPACK_IMPORTED_MODULE_7__.GraphHyperparameterImportance, { studyId: studyId, study: studyDetail, graphHeight: "450px" })),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphTimeline__WEBPACK_IMPORTED_MODULE_10__.GraphTimeline, { study: studyDetail })),
            studyDetail !== null &&
                studyDetail.plotly_graph_objects.map((go) => (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { xs: 6, key: go.id },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], null,
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_UserDefinedPlot__WEBPACK_IMPORTED_MODULE_11__.UserDefinedPlot, { graphObject: go })))))),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_BestTrialsCard__WEBPACK_IMPORTED_MODULE_5__.BestTrialsCard, { studyDetail: studyDetail })),
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: {
                            display: "flex",
                            flexDirection: "column",
                        } },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"], { variant: "h6", sx: {
                                margin: "1em 0",
                                fontWeight: theme.typography.fontWeightBold,
                            } }, "Study User Attributes"),
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_optuna_react__WEBPACK_IMPORTED_MODULE_0__.DataGrid, { data: userAttrs, columns: columns })))),
            studyDetail !== null &&
                studyDetail.directions.length === 1 &&
                studyDetail.has_intermediate_values ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_GraphIntermediateValues__WEBPACK_IMPORTED_MODULE_8__.GraphIntermediateValues, { trials: trials, includePruned: includePruned, logScale: logScale }))) : null),
        artifactEnabled && studyDetail !== null && (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { container: true, spacing: 2, sx: { padding: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material_Grid__WEBPACK_IMPORTED_MODULE_20__["default"], { item: true, xs: 6 },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { sx: {
                            display: "flex",
                            flexDirection: "column",
                        } },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"], { variant: "h6", sx: {
                                margin: "1em 0",
                                fontWeight: theme.typography.fontWeightBold,
                            } }, "Study Artifacts"),
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_Artifact_StudyArtifactCards__WEBPACK_IMPORTED_MODULE_4__.StudyArtifactCards, { study: studyDetail }))))))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/StudyList.js":
/*!*******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/StudyList.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StudyList: () => (/* binding */ StudyList)
/* harmony export */ });
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/HourglassTop.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/Delete.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/Search.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/Refresh.js");
/* harmony import */ var _mui_icons_material_AddBox__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! @mui/icons-material/AddBox */ "../tslib/react/node_modules/@mui/icons-material/esm/AddBox.js");
/* harmony import */ var _mui_icons_material_Compare__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! @mui/icons-material/Compare */ "../tslib/react/node_modules/@mui/icons-material/esm/Compare.js");
/* harmony import */ var _mui_icons_material_DriveFileRenameOutline__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/icons-material/DriveFileRenameOutline */ "../tslib/react/node_modules/@mui/icons-material/esm/DriveFileRenameOutline.js");
/* harmony import */ var _mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/icons-material/Home */ "../tslib/react/node_modules/@mui/icons-material/esm/Home.js");
/* harmony import */ var _mui_icons_material_Sort__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/icons-material/Sort */ "../tslib/react/node_modules/@mui/icons-material/esm/Sort.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/SvgIcon/SvgIcon.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActionArea/CardActionArea.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardActions/CardActions.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Container/Container.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/InputAdornment/InputAdornment.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router-dom/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _mui_system__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/system */ "../tslib/react/node_modules/@mui/system/styled/styled.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _urlQuery__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../urlQuery */ "../optuna_dashboard/pkg/urlQuery.js");
/* harmony import */ var _AppDrawer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./AppDrawer */ "../optuna_dashboard/pkg/components/AppDrawer.js");
/* harmony import */ var _CreateStudyDialog__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./CreateStudyDialog */ "../optuna_dashboard/pkg/components/CreateStudyDialog.js");
/* harmony import */ var _DeleteStudyDialog__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./DeleteStudyDialog */ "../optuna_dashboard/pkg/components/DeleteStudyDialog.js");
/* harmony import */ var _RenameStudyDialog__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./RenameStudyDialog */ "../optuna_dashboard/pkg/components/RenameStudyDialog.js");




















const StudyList = ({ toggleColorMode }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_3__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const [_studyFilterText, setStudyFilterText] = react__WEBPACK_IMPORTED_MODULE_0___default().useState("");
    const studyFilterText = (0,react__WEBPACK_IMPORTED_MODULE_0__.useDeferredValue)(_studyFilterText);
    const studyFilter = (row) => {
        const keywords = studyFilterText.split(" ");
        return !keywords.every((k) => {
            if (k === "") {
                return true;
            }
            return row.study_name.indexOf(k) >= 0;
        });
    };
    const studies = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_4__.studySummariesState);
    const [openCreateStudyDialog, renderCreateStudyDialog] = (0,_CreateStudyDialog__WEBPACK_IMPORTED_MODULE_7__.useCreateStudyDialog)();
    const [openDeleteStudyDialog, renderDeleteStudyDialog] = (0,_DeleteStudyDialog__WEBPACK_IMPORTED_MODULE_8__.useDeleteStudyDialog)();
    const [openRenameStudyDialog, renderRenameStudyDialog] = (0,_RenameStudyDialog__WEBPACK_IMPORTED_MODULE_9__.useRenameStudyDialog)(studies);
    const isLoading = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_4__.studySummariesLoadingState);
    const navigate = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_11__.useNavigate)();
    const query = (0,_urlQuery__WEBPACK_IMPORTED_MODULE_5__.useQuery)();
    const initialSortBy = query.get("studies_order_by") === "asc" ? "asc" : "desc";
    const [sortBy, setSortBy] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(initialSortBy);
    const filteredStudies = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        let filteredStudies = studies.filter((s) => !studyFilter(s));
        if (sortBy === "desc") {
            filteredStudies = filteredStudies.reverse();
        }
        return filteredStudies;
    }, [studyFilterText, studies, sortBy]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        action.updateStudySummaries();
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        query.set("studies_order_by", sortBy);
        navigate(`${location.pathname}?${query.toString()}`, {
            replace: true,
        });
    }, [sortBy]);
    const Select = (0,_mui_system__WEBPACK_IMPORTED_MODULE_12__["default"])(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"])(({ theme }) => ({
        "& .MuiInputBase-input": {
            // vertical padding + font size from searchIcon
            paddingLeft: `calc(1em + ${theme.spacing(4)})`,
        },
    }));
    const sortBySelect = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: {
            position: "relative",
            borderRadius: theme.shape.borderRadius,
            margin: theme.spacing(0, 2),
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: {
                padding: theme.spacing(0, 2),
                height: "100%",
                position: "absolute",
                pointerEvents: "none",
                display: "flex",
                alignItems: "center",
                justifyContent: "center",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Sort__WEBPACK_IMPORTED_MODULE_15__["default"], null)),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(Select, { select: true, value: sortBy, onChange: (e) => {
                setSortBy(e.target.value);
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { value: "asc" }, "Sort ascending"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { value: "desc" }, "Sort descending"))));
    const toolbar = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Home__WEBPACK_IMPORTED_MODULE_17__["default"], { sx: { margin: theme.spacing(0, 1) } });
    let studyListContent;
    if (isLoading) {
        studyListContent = (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { margin: theme.spacing(2) } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { fontSize: "small", color: "action" },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material__WEBPACK_IMPORTED_MODULE_19__["default"], null)),
            "Loading studies..."));
    }
    else {
        studyListContent = filteredStudies.map((study) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_20__["default"], { key: study.study_id, sx: { margin: theme.spacing(2), width: "500px" } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"], { component: react_router_dom__WEBPACK_IMPORTED_MODULE_22__.Link, to: `${url_prefix}/studies/${study.study_id}` },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { variant: "h5", sx: { wordBreak: "break-all" } },
                        study.study_id,
                        ". ",
                        study.study_name),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_24__["default"], { variant: "subtitle1", color: "text.secondary", component: "div" }, study.is_preferential
                        ? "Preferential Optimization"
                        : "Direction: " +
                            study.directions
                                .map((d) => d.toString().toUpperCase())
                                .join(", ")))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_25__["default"], { disableSpacing: true, sx: { paddingTop: 0 } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { flexGrow: 1 } }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_26__["default"], { "aria-label": "rename study", size: "small", color: "inherit", onClick: () => {
                        openRenameStudyDialog(study.study_id, study.study_name);
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_DriveFileRenameOutline__WEBPACK_IMPORTED_MODULE_27__["default"], null)),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_26__["default"], { "aria-label": "delete study", size: "small", color: "inherit", onClick: () => {
                        openDeleteStudyDialog(study.study_id);
                    } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material__WEBPACK_IMPORTED_MODULE_28__["default"], null))))));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { display: "flex" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_AppDrawer__WEBPACK_IMPORTED_MODULE_6__.AppDrawer, { toggleColorMode: toggleColorMode, toolbar: toolbar },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_29__["default"], { sx: {
                    ["@media (min-width: 1280px)"]: {
                        maxWidth: "100%",
                    },
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_20__["default"], { sx: { margin: theme.spacing(2) } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_23__["default"], null,
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { display: "flex" } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { onChange: (e) => {
                                    setStudyFilterText(e.target.value);
                                }, id: "search-study", variant: "outlined", placeholder: "Search study", fullWidth: true, sx: { maxWidth: 500 }, InputProps: {
                                    startAdornment: (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_30__["default"], { position: "start" },
                                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { fontSize: "small", color: "action" },
                                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material__WEBPACK_IMPORTED_MODULE_31__["default"], null)))),
                                } }),
                            sortBySelect,
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { flexGrow: 1 } }),
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_32__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material__WEBPACK_IMPORTED_MODULE_33__["default"], null), onClick: () => {
                                    action.updateStudySummaries("Success to reload");
                                }, sx: { marginRight: theme.spacing(2), minWidth: "120px" } }, "Reload"),
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_32__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_AddBox__WEBPACK_IMPORTED_MODULE_34__["default"], null), onClick: () => {
                                    openCreateStudyDialog();
                                }, sx: { marginRight: theme.spacing(2), minWidth: "120px" } }, "Create"),
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_32__["default"], { variant: "outlined", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_Compare__WEBPACK_IMPORTED_MODULE_35__["default"], null), component: react_router_dom__WEBPACK_IMPORTED_MODULE_22__.Link, to: `${url_prefix}/compare-studies`, sx: { marginRight: theme.spacing(2), minWidth: "120px" } }, "Compare")))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { component: "div", sx: { display: "flex", flexWrap: "wrap" } }, studyListContent))),
        renderCreateStudyDialog(),
        renderDeleteStudyDialog(),
        renderRenameStudyDialog()));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/TrialFormWidgets.js":
/*!**************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/TrialFormWidgets.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TrialFormWidgets: () => (/* binding */ TrialFormWidgets),
/* harmony export */   useChoiceWidget: () => (/* binding */ useChoiceWidget),
/* harmony export */   useSliderWidget: () => (/* binding */ useSliderWidget),
/* harmony export */   useTextInputWidget: () => (/* binding */ useTextInputWidget),
/* harmony export */   useUserAttrRefWidget: () => (/* binding */ useUserAttrRefWidget)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/RadioGroup/RadioGroup.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Radio/Radio.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Slider/Slider.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _Debounce__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./Debounce */ "../optuna_dashboard/pkg/components/Debounce.js");





const TrialFormWidgets = ({ trial, metricNames, directions, formWidgets }) => {
    if (formWidgets === undefined ||
        trial.state === "Pruned" ||
        trial.state === "Fail") {
        return null;
    }
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const trialNowUpdating = (0,_state__WEBPACK_IMPORTED_MODULE_2__.useTrialUpdatingValue)(trial.trial_id);
    const headerText = formWidgets.output_type === "user_attr"
        ? "Set User Attributes Form"
        : directions.length > 1
            ? "Set Objective Values Form"
            : "Set Objective Value Form";
    const widgetNames = formWidgets.widgets.map((widget, i) => {
        if (formWidgets.output_type === "objective") {
            if (metricNames.at(i) !== undefined) {
                return metricNames[i];
            }
            return directions.length === 1 ? "Objective" : `Objective ${i}`;
        }
        else if (formWidgets.output_type === "user_attr") {
            if (widget.type !== "user_attr" && widget.user_attr_key !== undefined) {
                return widget.user_attr_key;
            }
        }
        console.error("Must not reach here");
        return "Unknown";
    });
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { variant: "h5", sx: { fontWeight: theme.typography.fontWeightBold } }, headerText),
        trial.state === "Running" && !trialNowUpdating ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(UpdatableFormWidgets, { trial: trial, widgetNames: widgetNames, formWidgets: formWidgets })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(ReadonlyFormWidgets, { trial: trial, widgetNames: widgetNames, formWidgets: formWidgets }))));
};
const UpdatableFormWidgets = ({ trial, widgetNames, formWidgets }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_1__.actionCreator)();
    const widgetStates = formWidgets.widgets
        .map((w, i) => {
        const key = `${formWidgets.output_type}-${i}`;
        const outputType = formWidgets.output_type;
        if (w.type === "text") {
            return useTextInputWidget(key, outputType, w, widgetNames[i]);
        }
        else if (w.type === "choice") {
            return useChoiceWidget(key, outputType, w, widgetNames[i]);
        }
        else if (w.type === "slider") {
            return useSliderWidget(key, outputType, w, widgetNames[i]);
        }
        else if (w.type === "user_attr") {
            return useUserAttrRefWidget(key, w, widgetNames[i], trial);
        }
        console.error("Must not reach here");
        return undefined;
    })
        .filter((w) => w !== undefined);
    const disableSubmit = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => !widgetStates.every((ws) => ws.isValid), [widgetStates]);
    const handleSubmit = (e) => {
        e.preventDefault();
        const values = widgetStates.map((ws) => ws.value);
        if (formWidgets.output_type === "objective") {
            const filtered = values.filter((v) => v !== null);
            if (filtered.length !== formWidgets.widgets.length) {
                return;
            }
            action.makeTrialComplete(trial.study_id, trial.trial_id, filtered);
        }
        else if (formWidgets.output_type === "user_attr") {
            const user_attrs = Object.fromEntries(formWidgets.widgets.map((widget, i) => [
                widget.user_attr_key,
                values[i] !== null ? values[i] : "",
            ]));
            action.saveTrialUserAttrs(trial.study_id, trial.trial_id, user_attrs);
        }
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: { p: theme.spacing(1, 0) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                display: "flex",
                flexDirection: "column",
                marginBottom: theme.spacing(2),
                margin: theme.spacing(0, 1, 1, 0),
                p: theme.spacing(1),
                maxWidth: "1000px",
            } },
            widgetStates.map((ws) => ws.render()),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: {
                    display: "flex",
                    flexDirection: "row",
                    margin: theme.spacing(1, 2),
                } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { variant: "contained", type: "submit", sx: { marginRight: theme.spacing(1) }, disabled: disableSubmit, onClick: handleSubmit }, "Submit")))));
};
const useTextInputWidget = (key, widgetType, widget, metricName) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const [value, setValue] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    const isValid = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => widgetType === "user_attr"
        ? value !== "" || widget.optional
        : value !== "" && !isNaN(Number(value)), [widget, value]);
    const inputProps = widgetType === "objective"
        ? {
            pattern: "[-+]?[0-9]*.?[0-9]+([eE][-+]?[0-9]+)?",
        }
        : undefined;
    const helperText = !widget.optional && value === "" ? `Please input the float number.` : "";
    const render = () => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
            metricName,
            " - ",
            widget.description),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Debounce__WEBPACK_IMPORTED_MODULE_3__.DebouncedInputTextField, { onChange: (s, valid) => {
                if (widgetType === "user_attr") {
                    setValue(s);
                    return;
                }
                const n = Number(s);
                if (s.length > 0 && valid && !isNaN(n)) {
                    setValue(n);
                }
                else {
                    setValue("");
                }
            }, delay: 500, textFieldProps: {
                type: "text",
                autoFocus: true,
                fullWidth: true,
                required: !widget.optional,
                helperText,
                inputProps,
            } })));
    return { isValid, value, render };
};
const useChoiceWidget = (key, widgetType, widget, metricName) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const [value, setValue] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(widget.values[0]);
    const render = () => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
            metricName,
            " - ",
            widget.description),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { row: true, defaultValue: widget.values.at(0) }, widget.choices.map((c, j) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { key: c, control: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { checked: value === widget.values.at(j), onChange: (e) => {
                    const selected = widget.values.at(j);
                    if (selected === undefined) {
                        console.error("Must not reach here.");
                        return;
                    }
                    if (e.target.checked) {
                        setValue(selected);
                    }
                } }), label: c }))))));
    return { isValid: true, value, render };
};
const useSliderWidget = (key, widgetType, widget, metricName) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const [value, setValue] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(widget.min);
    const defaultStep = 0.01;
    const render = () => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
            metricName,
            " - ",
            widget.description),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: { padding: theme.spacing(0, 2) } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { onChange: (e) => {
                    // @ts-ignore
                    setValue(e.target.value);
                }, defaultValue: widget.min, min: widget.min, max: widget.max, step: widget.step || defaultStep, marks: widget.labels === null ? undefined : widget.labels, valueLabelDisplay: "auto" }))));
    return { isValid: true, value, render };
};
const useUserAttrRefWidget = (key, widget, metricName, trial) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const value = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const attr = trial.user_attrs.find((attr) => attr.key === widget.key);
        if (attr === undefined) {
            return null;
        }
        const n = Number(attr.value);
        if (isNaN(n)) {
            return null;
        }
        return n;
    }, [trial.user_attrs]);
    const render = () => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null, metricName),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { inputProps: { readOnly: true }, value: value || "", error: value === null, helperText: value === null
                ? `This objective value is referred from trial.user_attrs[${widget.key}].`
                : "" })));
    return {
        isValid: value !== null,
        value: value !== null ? value : "",
        render,
    };
};
const ReadonlyFormWidgets = ({ trial, widgetNames, formWidgets }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const getValue = (i) => {
        var _a, _b;
        if (formWidgets.output_type === "user_attr") {
            const widget = formWidgets.widgets[i];
            return (((_a = trial.user_attrs.find((attr) => attr.key === widget.user_attr_key)) === null || _a === void 0 ? void 0 : _a.value) || "");
        }
        const value = (_b = trial.values) === null || _b === void 0 ? void 0 : _b.at(i);
        if (value === undefined) {
            console.error("Must not reach here.");
            return 0;
        }
        return value;
    };
    if (trial.state !== "Complete") {
        return null;
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: { p: theme.spacing(1, 0) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                display: "flex",
                flexDirection: "column",
                marginBottom: theme.spacing(2),
                margin: theme.spacing(0, 1, 1, 0),
                p: theme.spacing(1),
                maxWidth: "1000px",
            } }, formWidgets.widgets.map((widget, i) => {
            var _a, _b, _c;
            const key = `objective-${i}`;
            const widgetName = widgetNames[i];
            if (widget.type === "text") {
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
                        widgetName,
                        " - ",
                        widget.description),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { inputProps: { readOnly: true }, value: getValue(i) })));
            }
            else if (widget.type === "choice") {
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
                        widgetName,
                        " - ",
                        widget.description),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { row: true, defaultValue: (_a = trial.values) === null || _a === void 0 ? void 0 : _a.at(i) }, widget.choices.map((c, j) => {
                        var _a;
                        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { key: c, control: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { checked: ((_a = trial.values) === null || _a === void 0 ? void 0 : _a.at(i)) === widget.values.at(j) }), label: c, disabled: true }));
                    }))));
            }
            else if (widget.type === "slider") {
                const value = (_b = trial.values) === null || _b === void 0 ? void 0 : _b.at(i);
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null,
                        widgetName,
                        " - ",
                        widget.description),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { component: "div", sx: { padding: theme.spacing(0, 2) } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { defaultValue: value, min: widget.min, max: widget.max, step: widget.step, marks: widget.labels === null || widget.labels.length === 0
                                ? true
                                : widget.labels, valueLabelDisplay: "auto", disabled: true }))));
            }
            else if (widget.type === "user_attr") {
                return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { key: key, sx: { margin: theme.spacing(1, 2) } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], null, widgetName),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { inputProps: { readOnly: true }, value: (_c = trial.values) === null || _c === void 0 ? void 0 : _c.at(i), disabled: true })));
            }
            return null;
        }))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/TrialList.js":
/*!*******************************************************!*\
  !*** ../optuna_dashboard/pkg/components/TrialList.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TrialList: () => (/* binding */ TrialList),
/* harmony export */   TrialListDetail: () => (/* binding */ TrialListDetail)
/* harmony export */ });
/* harmony import */ var _mui_icons_material_CheckBox__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/icons-material/CheckBox */ "../tslib/react/node_modules/@mui/icons-material/esm/CheckBox.js");
/* harmony import */ var _mui_icons_material_CheckBoxOutlineBlank__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/icons-material/CheckBoxOutlineBlank */ "../tslib/react/node_modules/@mui/icons-material/esm/CheckBoxOutlineBlank.js");
/* harmony import */ var _mui_icons_material_FilterList__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/icons-material/FilterList */ "../tslib/react/node_modules/@mui/icons-material/esm/FilterList.js");
/* harmony import */ var _mui_icons_material_StopCircle__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/icons-material/StopCircle */ "../tslib/react/node_modules/@mui/icons-material/esm/StopCircle.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Button/Button.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Menu/Menu.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material_Chip__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material/Chip */ "../tslib/react/node_modules/@mui/material/Chip/Chip.js");
/* harmony import */ var _mui_material_Divider__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/material/Divider */ "../tslib/react/node_modules/@mui/material/Divider/Divider.js");
/* harmony import */ var _mui_material_List__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material/List */ "../tslib/react/node_modules/@mui/material/List/List.js");
/* harmony import */ var _mui_material_ListItem__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/material/ListItem */ "../tslib/react/node_modules/@mui/material/ListItem/ListItem.js");
/* harmony import */ var _mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! @mui/material/ListItemButton */ "../tslib/react/node_modules/@mui/material/ListItemButton/ListItemButton.js");
/* harmony import */ var _mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! @mui/material/ListItemText */ "../tslib/react/node_modules/@mui/material/ListItemText/ListItemText.js");
/* harmony import */ var _mui_material_ListSubheader__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material/ListSubheader */ "../tslib/react/node_modules/@mui/material/ListSubheader/ListSubheader.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/material/ListItemIcon */ "../tslib/react/node_modules/@mui/material/ListItemIcon/ListItemIcon.js");
/* harmony import */ var _tanstack_react_virtual__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @tanstack/react-virtual */ "../optuna_dashboard/node_modules/@tanstack/react-virtual/dist/esm/index.js");
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var _action__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../action */ "../optuna_dashboard/pkg/action.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");
/* harmony import */ var _urlQuery__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../urlQuery */ "../optuna_dashboard/pkg/urlQuery.js");
/* harmony import */ var _Artifact_TrialArtifactCards__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./Artifact/TrialArtifactCards */ "../optuna_dashboard/pkg/components/Artifact/TrialArtifactCards.js");
/* harmony import */ var _Note__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./Note */ "../optuna_dashboard/pkg/components/Note.js");
/* harmony import */ var _TrialFormWidgets__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./TrialFormWidgets */ "../optuna_dashboard/pkg/components/TrialFormWidgets.js");
























const states = [
    "Complete",
    "Pruned",
    "Fail",
    "Running",
    "Waiting",
];
const getChipColor = (state) => {
    if (state === "Complete") {
        return "primary";
    }
    else if (state === "Running") {
        return "default";
    }
    else if (state === "Waiting") {
        return "default";
    }
    else if (state === "Pruned") {
        return "warning";
    }
    else if (state === "Fail") {
        return "error";
    }
    return "default";
};
const useExcludedStates = (query) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const exclude = query.get("exclude");
        if (exclude === null) {
            return [];
        }
        const excluded = exclude
            .split(",")
            .map((s) => {
            return states.find((state) => state.toUpperCase() === s.toUpperCase());
        })
            .filter((s) => s !== undefined);
        return excluded;
    }, [query]);
};
const useTrials = (studyDetail, excludedStates) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        let result = studyDetail !== null ? studyDetail.trials : [];
        if (excludedStates.length === 0) {
            return result;
        }
        excludedStates.forEach((s) => {
            result = result.filter((t) => t.state !== s);
        });
        return result;
    }, [studyDetail, excludedStates]);
};
const useQueriedTrials = (trials, query) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const queried = query.get("numbers");
        if (queried === null) {
            return [];
        }
        const numbers = queried
            .split(",")
            .map((s) => parseInt(s))
            .filter((n) => !isNaN(n));
        return trials.filter((t) => numbers.findIndex((n) => n === t.number) !== -1);
    }, [trials, query]);
};
const useIsBestTrial = (studyDetail) => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const bestTrialIDs = (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.best_trials.map((t) => t.trial_id)) || [];
        return (trialId) => bestTrialIDs.findIndex((a) => a === trialId) !== -1;
    }, [studyDetail]);
};
const TrialListDetail = ({ trial, isBestTrial, directions, metricNames, formWidgets }) => {
    var _a, _b, _c;
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"])();
    const action = (0,_action__WEBPACK_IMPORTED_MODULE_2__.actionCreator)();
    const artifactEnabled = (0,recoil__WEBPACK_IMPORTED_MODULE_1__.useRecoilValue)(_state__WEBPACK_IMPORTED_MODULE_4__.artifactIsAvailable);
    const startMs = (_a = trial.datetime_start) === null || _a === void 0 ? void 0 : _a.getTime();
    const completeMs = (_b = trial.datetime_complete) === null || _b === void 0 ? void 0 : _b.getTime();
    const params = trial.state === "Waiting" ? trial.fixed_params : trial.params;
    const info = [
        ["Value", ((_c = trial.values) === null || _c === void 0 ? void 0 : _c.map((v) => v.toString()).join(", ")) || "None"],
        [
            "Intermediate Values",
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div" }, trial.intermediate_values.map((v) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { key: v.step },
                v.step,
                " ",
                v.value)))),
        ],
        [
            "Parameter",
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div" }, params.map((p) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { key: p.name },
                p.name,
                " ",
                p.param_external_value)))),
        ],
        [
            "Started At",
            (trial === null || trial === void 0 ? void 0 : trial.datetime_start) ? trial === null || trial === void 0 ? void 0 : trial.datetime_start.toString() : null,
        ],
        [
            "Completed At",
            (trial === null || trial === void 0 ? void 0 : trial.datetime_complete) ? trial === null || trial === void 0 ? void 0 : trial.datetime_complete.toString() : null,
        ],
        [
            "Duration (ms)",
            startMs !== undefined && completeMs !== undefined
                ? (completeMs - startMs).toString()
                : null,
        ],
        [
            "User Attributes",
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div" }, trial.user_attrs.map((t) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { key: t.key },
                t.key,
                " ",
                t.value)))),
        ],
    ];
    const renderInfo = (key, value) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", key: key, sx: {
            display: "flex",
            flexDirection: "row",
            marginBottom: theme.spacing(0.5),
        } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { sx: { p: theme.spacing(1) }, color: "text.secondary", minWidth: "200px", fontWeight: theme.typography.fontWeightLight, fontSize: theme.typography.fontSize }, key),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                bgcolor: theme.palette.mode === "dark"
                    ? "rgba(255, 255, 255, 0.05)"
                    : "rgba(0, 0, 0, 0.05)",
                width: "100%",
                maxHeight: "150px",
                overflow: "auto",
                p: theme.spacing(0.5, 1),
                borderRadius: theme.shape.borderRadius * 0.2,
                display: "flex",
                whiteSpace: "nowrap",
            } }, value)));
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { width: "100%", padding: theme.spacing(2, 2, 0, 2) } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h4", sx: {
                marginBottom: theme.spacing(2),
                fontWeight: theme.typography.fontWeightBold,
            } },
            "Trial ",
            trial.number,
            " (trial_id=",
            trial.trial_id,
            ")"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                marginBottom: theme.spacing(1),
                display: "flex",
                flexDirection: "row",
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_12__["default"], { color: getChipColor(trial.state), label: trial.state, sx: { marginRight: theme.spacing(1) }, variant: "outlined" }),
            isBestTrial(trial.trial_id) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_12__["default"], { label: "Best Trial", color: "secondary", variant: "outlined" })) : null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { flexGrow: 1 } }),
            trial.state === "Running" ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { variant: "outlined", size: "small", color: "error", startIcon: react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_StopCircle__WEBPACK_IMPORTED_MODULE_14__["default"], null), onClick: () => {
                    action.makeTrialFail(trial.study_id, trial.trial_id);
                } }, "Fail Trial")) : null),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { variant: "h5", sx: {
                fontWeight: theme.typography.fontWeightBold,
                marginBottom: theme.spacing(1),
            } }, "Note"),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Note__WEBPACK_IMPORTED_MODULE_7__.TrialNote, { studyId: trial.study_id, trialId: trial.trial_id, latestNote: trial.note, cardSx: { marginBottom: theme.spacing(2) } }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_TrialFormWidgets__WEBPACK_IMPORTED_MODULE_8__.TrialFormWidgets, { trial: trial, directions: directions, metricNames: metricNames, formWidgets: formWidgets }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                marginBottom: theme.spacing(2),
                display: "flex",
                flexDirection: "column",
            } }, info.map(([key, value]) => value !== null ? renderInfo(key, value) : null)),
        artifactEnabled && react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_Artifact_TrialArtifactCards__WEBPACK_IMPORTED_MODULE_6__.TrialArtifactCards, { trial: trial })));
};
const getTrialListLink = (studyId, exclude, numbers, URL_PREFIX) => {
    const base = URL_PREFIX + `/studies/${studyId}/trials`;
    if (exclude.length > 0 && numbers.length > 0) {
        return (base +
            `?exclude=${exclude.join(",")}&numbers=${numbers
                .map((n) => n.toString())
                .join(",")}`);
    }
    else if (exclude.length > 0) {
        return base + "?exclude=" + exclude.join(",");
    }
    else if (numbers.length > 0) {
        return base + "?numbers=" + numbers.map((n) => n.toString()).join(",");
    }
    return base;
};
const TrialList = ({ studyDetail, }) => {
    const { url_prefix } = (0,_constantsProvider__WEBPACK_IMPORTED_MODULE_3__.useConstants)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"])();
    const query = (0,_urlQuery__WEBPACK_IMPORTED_MODULE_5__.useQuery)();
    const navigate = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_15__.useNavigate)();
    const excludedStates = useExcludedStates(query);
    const trials = useTrials(studyDetail, excludedStates);
    const isBestTrial = useIsBestTrial(studyDetail);
    const queried = useQueriedTrials(trials, query);
    const [filterMenuAnchorEl, setFilterMenuAnchorEl] = react__WEBPACK_IMPORTED_MODULE_0___default().useState(null);
    const openFilterMenu = Boolean(filterMenuAnchorEl);
    const trialCounts = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const allTrials = (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.trials) || [];
        return states.map((state) => allTrials.filter((t) => t.state === state).length);
    }, [studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.trials]);
    const listParentRef = react__WEBPACK_IMPORTED_MODULE_0___default().useRef(null);
    const rowVirtualizer = (0,_tanstack_react_virtual__WEBPACK_IMPORTED_MODULE_16__.useVirtualizer)({
        count: trials.length,
        getScrollElement: () => listParentRef.current,
        estimateSize: () => 73.31,
        overscan: 10,
    });
    const trialListWidth = 200;
    const selected = queried.length > 0 ? queried : trials.length > 0 ? [trials[0]] : [];
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", width: "100%" } },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", ref: listParentRef, sx: {
                minWidth: trialListWidth,
                overflow: "auto",
                height: `calc(100vh - ${theme.spacing(8)})`,
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_List__WEBPACK_IMPORTED_MODULE_17__["default"], { sx: { position: "relative" } },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListSubheader__WEBPACK_IMPORTED_MODULE_18__["default"], { sx: { display: "flex", flexDirection: "row" } },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { sx: { p: theme.spacing(1, 0) } },
                        trials.length,
                        " Trials"),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { flexGrow: 1 } }),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { "aria-label": "Filter", "aria-controls": openFilterMenu ? "filter-trials" : undefined, "aria-haspopup": "true", "aria-expanded": openFilterMenu ? "true" : undefined, onClick: (e) => {
                            setFilterMenuAnchorEl(e.currentTarget);
                        } },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_FilterList__WEBPACK_IMPORTED_MODULE_20__["default"], { fontSize: "small" })),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"], { anchorEl: filterMenuAnchorEl, id: "filter-trials", open: openFilterMenu, onClose: () => {
                            setFilterMenuAnchorEl(null);
                        } }, states.map((state, i) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"], { key: state, onClick: () => {
                            if (studyDetail === null) {
                                return;
                            }
                            const index = excludedStates.findIndex((s) => s === state);
                            if (index === -1) {
                                excludedStates.push(state);
                            }
                            else {
                                excludedStates.splice(index, 1);
                            }
                            const numbers = selected.map((t) => t.number);
                            navigate(getTrialListLink(studyDetail.id, excludedStates, numbers, url_prefix));
                        }, disabled: trialCounts[i] === 0 },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemIcon__WEBPACK_IMPORTED_MODULE_23__["default"], null, excludedStates.find((s) => s === state) !== undefined ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_CheckBoxOutlineBlank__WEBPACK_IMPORTED_MODULE_24__["default"], { color: "primary" })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_icons_material_CheckBox__WEBPACK_IMPORTED_MODULE_25__["default"], { color: "primary" }))),
                        state,
                        " (",
                        trialCounts[i],
                        ")"))))),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_26__["default"], null),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                        width: "100%",
                        height: `${rowVirtualizer.getTotalSize()}px`,
                        position: "relative",
                    } }, rowVirtualizer.getVirtualItems().map((virtualItem) => {
                    const trial = trials[virtualItem.index];
                    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItem__WEBPACK_IMPORTED_MODULE_27__["default"], { key: trial.trial_id, sx: {
                            display: "flex",
                            flexDirection: "column",
                            alignItems: "flex-start",
                            position: "absolute",
                            top: 0,
                            left: 0,
                            transform: `translateY(${virtualItem.start}px)`,
                        }, disablePadding: true },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemButton__WEBPACK_IMPORTED_MODULE_28__["default"], { onClick: (e) => {
                                if (e.shiftKey) {
                                    let next;
                                    const selectedNumbers = selected.map((t) => t.number);
                                    const alreadySelected = selectedNumbers.findIndex((n) => n === trial.number) >= 0;
                                    if (alreadySelected) {
                                        next = selectedNumbers.filter((n) => n !== trial.number);
                                    }
                                    else {
                                        next = [...selectedNumbers, trial.number];
                                    }
                                    navigate(getTrialListLink(trial.study_id, excludedStates, next, url_prefix));
                                }
                                else {
                                    navigate(getTrialListLink(trial.study_id, excludedStates, [trial.number], url_prefix));
                                }
                            }, selected: selected.findIndex((t) => t.number === trial.number) !==
                                -1, sx: {
                                width: "100%",
                                display: "flex",
                                flexDirection: "column",
                                alignItems: "flex-start",
                            } },
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_ListItemText__WEBPACK_IMPORTED_MODULE_29__["default"], { primary: `Trial ${trial.number}` }),
                            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div" },
                                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_12__["default"], { color: getChipColor(trial.state), label: trial.state, sx: { margin: theme.spacing(0) }, size: "small", variant: "outlined" }),
                                isBestTrial(trial.trial_id) ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Chip__WEBPACK_IMPORTED_MODULE_12__["default"], { label: "Best Trial", color: "secondary", sx: { marginLeft: theme.spacing(1) }, size: "small", variant: "outlined" })) : null))));
                })))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material_Divider__WEBPACK_IMPORTED_MODULE_26__["default"], { orientation: "vertical", flexItem: true }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: {
                flexGrow: 1,
                overflow: "auto",
                height: `calc(100vh - ${theme.spacing(8)})`,
            } },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "div", sx: { display: "flex", flexDirection: "row", width: "100%" } }, selected.length === 0
                ? null
                : selected.map((t) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(TrialListDetail, { key: t.trial_id, trial: t, isBestTrial: isBestTrial, directions: (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.directions) || [], metricNames: (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.metric_names) || [], formWidgets: studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.form_widgets })))))));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/components/UserDefinedPlot.js":
/*!*************************************************************!*\
  !*** ../optuna_dashboard/pkg/components/UserDefinedPlot.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   UserDefinedPlot: () => (/* binding */ UserDefinedPlot)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! plotly.js-dist-min */ "../optuna_dashboard/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);



const UserDefinedPlot = ({ graphObject }) => {
    const plotDomId = `user-defined-plot:${graphObject.id}`;
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        try {
            const parsed = JSON.parse(graphObject.graph_object);
            plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_0__.react(plotDomId, parsed.data, parsed.layout);
        }
        catch (e) {
            // Avoid to crash the whole page when given invalid grpah objects.
            console.error(e);
        }
    }, [graphObject]);
    return react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { component: "div", id: plotDomId, sx: { height: "450px" } });
};


/***/ }),

/***/ "../optuna_dashboard/pkg/constantsProvider.js":
/*!****************************************************!*\
  !*** ../optuna_dashboard/pkg/constantsProvider.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ConstantsContext: () => (/* binding */ ConstantsContext),
/* harmony export */   useConstants: () => (/* binding */ useConstants)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const ConstantsContext = react__WEBPACK_IMPORTED_MODULE_0___default().createContext({
    environment: "optuna-dashboard",
    url_prefix: "",
});
const useConstants = () => {
    return react__WEBPACK_IMPORTED_MODULE_0___default().useContext(ConstantsContext);
};


/***/ }),

/***/ "../optuna_dashboard/pkg/dateUtil.js":
/*!*******************************************!*\
  !*** ../optuna_dashboard/pkg/dateUtil.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   formatDate: () => (/* binding */ formatDate)
/* harmony export */ });
const formatDate = (date) => {
    const options = {
        year: "numeric",
        month: "numeric",
        day: "numeric",
        hour: "numeric",
        minute: "numeric",
        second: "numeric",
    };
    return new Intl.DateTimeFormat("ja-JP", options).format(date);
};


/***/ }),

/***/ "../optuna_dashboard/pkg/dominatedTrials.js":
/*!**************************************************!*\
  !*** ../optuna_dashboard/pkg/dominatedTrials.js ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getDominatedTrials: () => (/* binding */ getDominatedTrials)
/* harmony export */ });
const filterFunc = (trial, directions) => {
    return (trial.state === "Complete" &&
        trial.values !== undefined &&
        trial.values.length === directions.length);
};
const getDominatedTrials = (trials, directions) => {
    // TODO(c-bata): Use log-linear algorithm like Optuna.
    // TODO(c-bata): Use this function at GraphParetoFront.
    const filteredTrials = trials.filter((t) => filterFunc(t, directions));
    const normalizedValues = [];
    filteredTrials.forEach((t) => {
        if (t.values && t.values.length === directions.length) {
            const trialValues = t.values.map((v, i) => {
                return directions[i] === "minimize" ? v : -v;
            });
            normalizedValues.push(trialValues);
        }
    });
    const dominatedTrials = [];
    normalizedValues.forEach((values0, i) => {
        const dominated = normalizedValues.some((values1, j) => {
            if (i === j || values0.every((v, i) => v === values1[i])) {
                return false;
            }
            return values0.every((value0, k) => {
                return values1[k] <= value0;
            });
        });
        dominatedTrials.push(dominated);
    });
    return filteredTrials.filter((_, i) => !dominatedTrials.at(i));
};


/***/ }),

/***/ "../optuna_dashboard/pkg/graphUtil.js":
/*!********************************************!*\
  !*** ../optuna_dashboard/pkg/graphUtil.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getAxisInfo: () => (/* binding */ getAxisInfo),
/* harmony export */   makeHovertext: () => (/* binding */ makeHovertext),
/* harmony export */   studyDetailToStudy: () => (/* binding */ studyDetailToStudy)
/* harmony export */ });
const PADDING_RATIO = 0.05;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const unique = (array) => {
    const knownElements = new Map();
    array.forEach((elem) => knownElements.set(elem, true));
    return Array.from(knownElements.keys());
};
const getAxisInfo = (trials, param) => {
    if (param.distribution.type === "CategoricalDistribution") {
        return getAxisInfoForCategoricalParams(trials, param.name, param.distribution);
    }
    else {
        return getAxisInfoForNumericalParams(trials, param.name, param.distribution);
    }
};
const getAxisInfoForCategoricalParams = (trials, paramName, distribution) => {
    const values = trials.map((trial) => {
        var _a;
        return ((_a = trial.params.find((p) => p.name === paramName)) === null || _a === void 0 ? void 0 : _a.param_external_value) ||
            null;
    });
    const indices = distribution.choices
        .map((c) => { var _a; return (_a = c === null || c === void 0 ? void 0 : c.value) !== null && _a !== void 0 ? _a : "null"; })
        .sort((a, b) => a.toLowerCase() < b.toLowerCase()
        ? -1
        : a.toLowerCase() > b.toLowerCase()
            ? 1
            : 0);
    return {
        name: paramName,
        isLog: false,
        isCat: true,
        indices,
        values,
    };
};
const getAxisInfoForNumericalParams = (trials, paramName, distribution) => {
    let min = 0;
    let max = 0;
    if (distribution.log) {
        const padding = (Math.log10(distribution.high) - Math.log10(distribution.low)) *
            PADDING_RATIO;
        min = Math.pow(10, Math.log10(distribution.low) - padding);
        max = Math.pow(10, Math.log10(distribution.high) + padding);
    }
    else {
        const padding = (distribution.high - distribution.low) * PADDING_RATIO;
        min = distribution.low - padding;
        max = distribution.high + padding;
    }
    const values = trials.map((trial) => {
        var _a;
        return ((_a = trial.params.find((p) => p.name === paramName)) === null || _a === void 0 ? void 0 : _a.param_internal_value) ||
            null;
    });
    const indices = unique(values)
        .filter((v) => v !== null)
        .sort((a, b) => a - b);
    if (indices.length >= 2) {
        indices.unshift(min);
        indices.push(max);
    }
    return {
        name: paramName,
        isLog: distribution.log,
        isCat: false,
        indices,
        values,
    };
};
const makeHovertext = (trial) => {
    return JSON.stringify({
        number: trial.number,
        values: trial.values,
        params: trial.params
            .map((p) => [p.name, p.param_external_value])
            .reduce((obj, [key, value]) => (Object.assign(Object.assign({}, obj), { [key]: value })), {}),
    }, undefined, "  ").replace(/\n/g, "<br>");
};
const studyDetailToStudy = (studyDetail) => {
    const study = studyDetail
        ? {
            id: studyDetail.id,
            name: studyDetail.name,
            directions: studyDetail.directions,
            union_search_space: studyDetail.union_search_space,
            intersection_search_space: studyDetail.intersection_search_space,
            union_user_attrs: studyDetail.union_user_attrs,
            datetime_start: studyDetail.datetime_start,
            trials: studyDetail.trials,
            metric_names: studyDetail.metric_names,
        }
        : null;
    return study;
};


/***/ }),

/***/ "../optuna_dashboard/pkg/hooks/useParamImportance.js":
/*!***********************************************************!*\
  !*** ../optuna_dashboard/pkg/hooks/useParamImportance.js ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useParamImportance: () => (/* binding */ useParamImportance)
/* harmony export */ });
/* harmony import */ var _tanstack_react_query__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @tanstack/react-query */ "../optuna_dashboard/node_modules/@tanstack/react-query/build/modern/useQuery.js");
/* harmony import */ var notistack__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! notistack */ "../optuna_dashboard/node_modules/notistack/notistack.esm.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _apiClientProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../apiClientProvider */ "../optuna_dashboard/pkg/apiClientProvider.js");




const useParamImportance = ({ numCompletedTrials, studyId, }) => {
    const { apiClient } = (0,_apiClientProvider__WEBPACK_IMPORTED_MODULE_2__.useAPIClient)();
    const { enqueueSnackbar } = (0,notistack__WEBPACK_IMPORTED_MODULE_0__.useSnackbar)();
    const { data, isLoading, error } = (0,_tanstack_react_query__WEBPACK_IMPORTED_MODULE_3__.useQuery)({
        queryKey: ["paramImportance", studyId, numCompletedTrials],
        queryFn: () => apiClient.getParamImportances(studyId),
        staleTime: Infinity,
        gcTime: 30 * 60 * 1000, // 30 minutes
    });
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        var _a;
        if (error) {
            const reason = (_a = error.response) === null || _a === void 0 ? void 0 : _a.data.reason;
            enqueueSnackbar(`Failed to load hyperparameter importance (reason=${reason})`, {
                variant: "error",
            });
        }
    }, [error]);
    return {
        importances: data,
        isLoading,
        error,
    };
};


/***/ }),

/***/ "../optuna_dashboard/pkg/hooks/usePlot.js":
/*!************************************************!*\
  !*** ../optuna_dashboard/pkg/hooks/usePlot.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   usePlot: () => (/* binding */ usePlot)
/* harmony export */ });
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _tanstack_react_query__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @tanstack/react-query */ "../optuna_dashboard/node_modules/@tanstack/react-query/build/modern/useQuery.js");
/* harmony import */ var _apiClientProvider__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../apiClientProvider */ "../optuna_dashboard/pkg/apiClientProvider.js");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../state */ "../optuna_dashboard/pkg/state.js");




const usePlot = ({ numCompletedTrials, studyId, plotType, }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"])();
    const colorTheme = (0,_state__WEBPACK_IMPORTED_MODULE_1__.usePlotlyColorTheme)(theme.palette.mode);
    const { apiClient } = (0,_apiClientProvider__WEBPACK_IMPORTED_MODULE_0__.useAPIClient)();
    const { data, isLoading, error } = (0,_tanstack_react_query__WEBPACK_IMPORTED_MODULE_3__.useQuery)({
        enabled: studyId !== undefined,
        queryKey: ["plot", studyId, numCompletedTrials, plotType],
        queryFn: () => {
            if (studyId === undefined) {
                return Promise.reject(new Error("Invalid studyId"));
            }
            return apiClient.getPlot(studyId, plotType);
        },
        staleTime: Infinity,
        gcTime: 30 * 60 * 1000, // 30 minutes
    });
    return {
        data: data === null || data === void 0 ? void 0 : data.data,
        layout: Object.assign(Object.assign({}, data === null || data === void 0 ? void 0 : data.layout), { template: colorTheme }),
        isLoading,
        error,
    };
};


/***/ }),

/***/ "../optuna_dashboard/pkg/pkg_index.js":
/*!********************************************!*\
  !*** ../optuna_dashboard/pkg/pkg_index.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   APIClient: () => (/* reexport safe */ _apiClient__WEBPACK_IMPORTED_MODULE_0__.APIClient),
/* harmony export */   APIClientProvider: () => (/* reexport safe */ _apiClientProvider__WEBPACK_IMPORTED_MODULE_1__.APIClientProvider),
/* harmony export */   App: () => (/* reexport safe */ _components_App__WEBPACK_IMPORTED_MODULE_3__.App),
/* harmony export */   AxiosClient: () => (/* reexport safe */ _axiosClient__WEBPACK_IMPORTED_MODULE_2__.AxiosClient),
/* harmony export */   CompareStudiesPlotType: () => (/* reexport safe */ _apiClient__WEBPACK_IMPORTED_MODULE_0__.CompareStudiesPlotType),
/* harmony export */   ConstantsContext: () => (/* reexport safe */ _constantsProvider__WEBPACK_IMPORTED_MODULE_4__.ConstantsContext),
/* harmony export */   PlotType: () => (/* reexport safe */ _apiClient__WEBPACK_IMPORTED_MODULE_0__.PlotType)
/* harmony export */ });
/* harmony import */ var _apiClient__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./apiClient */ "../optuna_dashboard/pkg/apiClient.js");
/* harmony import */ var _apiClientProvider__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./apiClientProvider */ "../optuna_dashboard/pkg/apiClientProvider.js");
/* harmony import */ var _axiosClient__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./axiosClient */ "../optuna_dashboard/pkg/axiosClient.js");
/* harmony import */ var _components_App__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./components/App */ "../optuna_dashboard/pkg/components/App.js");
/* harmony import */ var _constantsProvider__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./constantsProvider */ "../optuna_dashboard/pkg/constantsProvider.js");








/***/ }),

/***/ "../optuna_dashboard/pkg/state.js":
/*!****************************************!*\
  !*** ../optuna_dashboard/pkg/state.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   artifactIsAvailable: () => (/* binding */ artifactIsAvailable),
/* harmony export */   drawerOpenState: () => (/* binding */ drawerOpenState),
/* harmony export */   isFileUploading: () => (/* binding */ isFileUploading),
/* harmony export */   plotlypyIsAvailableState: () => (/* binding */ plotlypyIsAvailableState),
/* harmony export */   reloadIntervalState: () => (/* binding */ reloadIntervalState),
/* harmony export */   studyDetailLoadingState: () => (/* binding */ studyDetailLoadingState),
/* harmony export */   studyDetailsState: () => (/* binding */ studyDetailsState),
/* harmony export */   studySummariesLoadingState: () => (/* binding */ studySummariesLoadingState),
/* harmony export */   studySummariesState: () => (/* binding */ studySummariesState),
/* harmony export */   trialsUpdatingState: () => (/* binding */ trialsUpdatingState),
/* harmony export */   useArtifacts: () => (/* binding */ useArtifacts),
/* harmony export */   useBackendRender: () => (/* binding */ useBackendRender),
/* harmony export */   usePlotBackendRendering: () => (/* binding */ usePlotBackendRendering),
/* harmony export */   usePlotlyColorTheme: () => (/* binding */ usePlotlyColorTheme),
/* harmony export */   usePlotlyColorThemeState: () => (/* binding */ usePlotlyColorThemeState),
/* harmony export */   useStudyDetailValue: () => (/* binding */ useStudyDetailValue),
/* harmony export */   useStudyDirections: () => (/* binding */ useStudyDirections),
/* harmony export */   useStudyIsPreferential: () => (/* binding */ useStudyIsPreferential),
/* harmony export */   useStudyName: () => (/* binding */ useStudyName),
/* harmony export */   useStudySummaryValue: () => (/* binding */ useStudySummaryValue),
/* harmony export */   useTrialUpdatingValue: () => (/* binding */ useTrialUpdatingValue)
/* harmony export */ });
/* harmony import */ var recoil__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! recoil */ "../optuna_dashboard/node_modules/recoil/es/index.js");
/* harmony import */ var usehooks_ts__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! usehooks-ts */ "../optuna_dashboard/node_modules/usehooks-ts/dist/index.js");
/* harmony import */ var _components_PlotlyColorTemplates__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./components/PlotlyColorTemplates */ "../optuna_dashboard/pkg/components/PlotlyColorTemplates.js");



const studySummariesState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "studySummaries",
    default: [],
});
const studyDetailsState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "studyDetails",
    default: {},
});
const trialsUpdatingState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "trialsUpdating",
    default: {},
});
// TODO(c-bata): Consider representing the state as boolean.
const reloadIntervalState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "reloadInterval",
    default: 10,
});
const drawerOpenState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "drawerOpen",
    default: false,
});
const isFileUploading = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "isFileUploading",
    default: false,
});
const artifactIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "artifactIsAvailable",
    default: false,
});
const plotlypyIsAvailableState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "plotlypyIsAvailable",
    default: false,
});
const studySummariesLoadingState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "studySummariesLoadingState",
    default: false,
});
const studyDetailLoadingState = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.atom)({
    key: "studyDetailLoading",
    default: {},
});
const usePlotBackendRendering = () => {
    return (0,usehooks_ts__WEBPACK_IMPORTED_MODULE_2__.useLocalStorage)("plotBackendRendering", false);
};
const usePlotlyColorThemeState = () => {
    return (0,usehooks_ts__WEBPACK_IMPORTED_MODULE_2__.useLocalStorage)("plotlyColorTheme", {
        dark: "default",
        light: "default",
    });
};
const useStudyDetailValue = (studyId) => {
    const studyDetails = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.useRecoilValue)(studyDetailsState);
    return studyDetails[studyId] || null;
};
const useStudySummaryValue = (studyId) => {
    const studySummaries = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.useRecoilValue)(studySummariesState);
    return studySummaries.find((s) => s.study_id === studyId) || null;
};
const useTrialUpdatingValue = (trialId) => {
    const updating = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.useRecoilValue)(trialsUpdatingState);
    return updating[trialId] || false;
};
const useStudyDirections = (studyId) => {
    const studyDetail = useStudyDetailValue(studyId);
    const studySummary = useStudySummaryValue(studyId);
    return (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.directions) || (studySummary === null || studySummary === void 0 ? void 0 : studySummary.directions) || null;
};
const useStudyIsPreferential = (studyId) => {
    const studyDetail = useStudyDetailValue(studyId);
    const studySummary = useStudySummaryValue(studyId);
    return (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.is_preferential) || (studySummary === null || studySummary === void 0 ? void 0 : studySummary.is_preferential) || null;
};
const useStudyName = (studyId) => {
    const studyDetail = useStudyDetailValue(studyId);
    const studySummary = useStudySummaryValue(studyId);
    return (studyDetail === null || studyDetail === void 0 ? void 0 : studyDetail.name) || (studySummary === null || studySummary === void 0 ? void 0 : studySummary.study_name) || null;
};
const useArtifacts = (studyId, trialId) => {
    const study = useStudyDetailValue(studyId);
    const trial = study === null || study === void 0 ? void 0 : study.trials.find((t) => t.trial_id === trialId);
    if (trial === undefined) {
        return [];
    }
    return trial.artifacts;
};
const usePlotlyColorTheme = (mode) => {
    const [theme] = usePlotlyColorThemeState();
    if (mode === "dark") {
        return _components_PlotlyColorTemplates__WEBPACK_IMPORTED_MODULE_1__.DarkColorTemplates[theme.dark];
    }
    else {
        return _components_PlotlyColorTemplates__WEBPACK_IMPORTED_MODULE_1__.LightColorTemplates[theme.light];
    }
};
const useBackendRender = () => {
    const [plotBackendRendering] = usePlotBackendRendering();
    const plotlypyIsAvailable = (0,recoil__WEBPACK_IMPORTED_MODULE_0__.useRecoilValue)(plotlypyIsAvailableState);
    if (plotBackendRendering) {
        if (plotlypyIsAvailable) {
            return true;
        }
    }
    return false;
};


/***/ }),

/***/ "../optuna_dashboard/pkg/urlQuery.js":
/*!*******************************************!*\
  !*** ../optuna_dashboard/pkg/urlQuery.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useQuery: () => (/* binding */ useQuery)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_router_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-router-dom */ "../optuna_dashboard/node_modules/react-router/dist/index.js");


const useQuery = () => {
    const { search } = (0,react_router_dom__WEBPACK_IMPORTED_MODULE_1__.useLocation)();
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => new URLSearchParams(search), [search]);
};


/***/ }),

/***/ "../tslib/react/pkg/components/DataGrid.js":
/*!*************************************************!*\
  !*** ../tslib/react/pkg/components/DataGrid.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DataGrid: () => (/* binding */ DataGrid)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/FilterList.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/CheckBoxOutlineBlank.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/CheckBox.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/LastPage.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/FirstPage.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/KeyboardArrowRight.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/KeyboardArrowLeft.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Menu/Menu.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/ListItem/ListItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableContainer/TableContainer.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Paper/Paper.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Table/Table.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableHead/TableHead.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableRow/TableRow.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableCell/TableCell.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableSortLabel/TableSortLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TableBody/TableBody.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TablePagination/TablePagination.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/TextField/TextField.js");
/* harmony import */ var _mui_system__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/system */ "../tslib/react/node_modules/@mui/system/styled/styled.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _tanstack_react_table__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @tanstack/react-table */ "../tslib/react/node_modules/@tanstack/react-table/build/lib/index.mjs");
/* harmony import */ var _tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @tanstack/react-table */ "../tslib/react/node_modules/@tanstack/table-core/build/lib/index.mjs");






const TableHeaderCellSpan = (0,_mui_system__WEBPACK_IMPORTED_MODULE_2__["default"])("span")({
    display: "inline-flex",
});
const HiddenSpan = (0,_mui_system__WEBPACK_IMPORTED_MODULE_2__["default"])("span")({
    border: 0,
    clip: "rect(0 0 0 0)",
    height: 1,
    margin: -1,
    overflow: "hidden",
    padding: 0,
    position: "absolute",
    top: 20,
    width: 1,
});
function FilterMenu({ header, filterChoices, }) {
    const [filterMenuAnchorEl, setFilterMenuAnchorEl] = react__WEBPACK_IMPORTED_MODULE_1___default().useState(null);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { size: "small", onClick: (e) => {
                    setFilterMenuAnchorEl(e.currentTarget);
                }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_4__["default"], { fontSize: "small" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { anchorEl: filterMenuAnchorEl, open: filterMenuAnchorEl !== null, onClose: () => {
                    setFilterMenuAnchorEl(null);
                }, children: filterChoices.map((choice) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { onClick: () => {
                        const skippedValues = header.column.getFilterValue();
                        const isSkipped = skippedValues.includes(choice);
                        const newSkippedValues = isSkipped
                            ? skippedValues.filter((v) => v !== choice)
                            : skippedValues.concat(choice);
                        header.column.setFilterValue(newSkippedValues);
                    }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { children: header.column.getFilterValue() !== undefined ? (header.column.getFilterValue().includes(choice) ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_8__["default"], { color: "primary" })) : ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_9__["default"], { color: "primary" }))) : null }), choice ?? "(missing value)"] }, choice))) })] }));
}
function DataGrid({ data, columns, initialRowsPerPage, }) {
    const [sorting, setSorting] = react__WEBPACK_IMPORTED_MODULE_1___default().useState([]);
    const [columnFilters, setColumnFilters] = react__WEBPACK_IMPORTED_MODULE_1___default().useState([]);
    const rowsPerPageOptions = [
        5,
        10,
        50,
        100,
        { label: "All", value: data.length },
    ];
    const [pagination, setPagination] = react__WEBPACK_IMPORTED_MODULE_1___default().useState({
        pageIndex: 0,
        pageSize: initialRowsPerPage && rowsPerPageOptions.includes(initialRowsPerPage)
            ? initialRowsPerPage
            : 5,
    });
    const table = (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_10__.useReactTable)({
        data,
        columns,
        state: {
            columnFilters,
            sorting,
            pagination,
        },
        onColumnFiltersChange: setColumnFilters,
        onSortingChange: setSorting,
        onPaginationChange: setPagination,
        getCoreRowModel: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getCoreRowModel)(),
        getFacetedRowModel: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getFacetedRowModel)(),
        getFacetedUniqueValues: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getFacetedUniqueValues)(),
        getSortedRowModel: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getSortedRowModel)(),
        getPaginationRowModel: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getPaginationRowModel)(),
        getFilteredRowModel: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_11__.getFilteredRowModel)(),
        autoResetPageIndex: false,
    });
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "div", sx: { width: "100%" }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { component: _mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { sx: { minWidth: 650 }, "aria-label": "simple table", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], { children: table.getHeaderGroups().map((headerGroup) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { children: headerGroup.headers.map((header) => {
                                    if (header.column.getCanFilter() &&
                                        !header.column.getIsFiltered()) {
                                        header.column.setFilterValue([]);
                                    }
                                    const order = header.column.getIsSorted();
                                    const filterChoices = header.column.getCanFilter()
                                        ? Array.from(header.column.getFacetedUniqueValues().keys()).sort()
                                        : null;
                                    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { colSpan: header.colSpan, children: header.isPlaceholder ? null : ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(TableHeaderCellSpan, { children: [header.column.getCanSort() ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_19__["default"], { active: order !== false, direction: order || "asc", onClick: header.column.getToggleSortingHandler(), children: [(0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_10__.flexRender)(header.column.columnDef.header, header.getContext()), order !== null ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(HiddenSpan, { children: order === "desc"
                                                                ? "sorted descending"
                                                                : "sorted ascending" })) : null] })) : ((0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_10__.flexRender)(header.column.columnDef.header, header.getContext())), filterChoices !== null ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(FilterMenu, { header: header, filterChoices: filterChoices })) : null] })) }, header.id));
                                }) }, headerGroup.id))) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_20__["default"], { children: table.getRowModel().rows.map((row) => {
                                return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { children: row.getVisibleCells().map((cell) => {
                                        return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { children: (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_10__.flexRender)(cell.column.columnDef.cell, cell.getContext()) }, cell.id));
                                    }) }, row.id));
                            }) })] }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "div", display: "flex", alignItems: "center", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_21__["default"], { rowsPerPageOptions: rowsPerPageOptions, component: "div", count: table.getFilteredRowModel().rows.length, rowsPerPage: table.getState().pagination.pageSize, page: table.getState().pagination.pageIndex, slotProps: {
                            select: {
                                inputProps: { "aria-label": "rows per page" },
                                native: true,
                            },
                        }, onPageChange: (_, page) => {
                            table.setPageIndex(page);
                        }, onRowsPerPageChange: (e) => {
                            const size = e.target.value ? Number(e.target.value) : 10;
                            table.setPageSize(size);
                        }, ActionsComponent: TablePaginationActions }), table.getPageCount() > 2 ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(PaginationForm1, { onPageNumberSubmit: (page) => table.setPageIndex(page), maxPageNumber: table.getPageCount() })) : null] })] }));
}
const TablePaginationActions = ({ count, page, rowsPerPage, onPageChange, }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_22__["default"])();
    const handleFirstPageButtonClick = (event) => {
        onPageChange(event, 0);
    };
    const handleBackButtonClick = (event) => {
        onPageChange(event, page - 1);
    };
    const handleNextButtonClick = (event) => {
        onPageChange(event, page + 1);
    };
    const handleLastPageButtonClick = (event) => {
        onPageChange(event, Math.max(0, Math.ceil(count / rowsPerPage) - 1));
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "div", sx: { flexShrink: 0, ml: 2.5 }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { onClick: handleFirstPageButtonClick, disabled: page === 0, "aria-label": "first page", children: theme.direction === "rtl" ? (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_23__["default"], {}) : (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_24__["default"], {}) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { onClick: handleBackButtonClick, disabled: page === 0, "aria-label": "previous page", children: theme.direction === "rtl" ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_25__["default"], {})) : ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_26__["default"], {})) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { onClick: handleNextButtonClick, disabled: page >= Math.ceil(count / rowsPerPage) - 1, "aria-label": "next page", children: theme.direction === "rtl" ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_26__["default"], {})) : ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_25__["default"], {})) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { onClick: handleLastPageButtonClick, disabled: page >= Math.ceil(count / rowsPerPage) - 1, "aria-label": "last page", children: theme.direction === "rtl" ? (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_24__["default"], {}) : (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_23__["default"], {}) })] }));
};
const PaginationForm1 = ({ onPageNumberSubmit, maxPageNumber }) => {
    // This component is separated from DataGrid to prevent `DataGrid` from re-rendering the page,
    // every time any letters are input.
    const [specifiedPageText, setSpecifiedPageText] = react__WEBPACK_IMPORTED_MODULE_1___default().useState("");
    const handleSubmitPageNumber = (event) => {
        event.preventDefault();
        const newPageNumber = parseInt(specifiedPageText, 10);
        // Page is 0-indexed in `TablePagination`.
        onPageNumberSubmit(newPageNumber - 1);
        setSpecifiedPageText(""); // reset the input field
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("form", { onSubmit: handleSubmitPageNumber, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_27__["default"], { size: "small", label: `Go to Page: n / ${maxPageNumber}`, value: specifiedPageText, type: "number", style: { width: 200 }, inputProps: { min: 1, max: maxPageNumber }, onChange: (e) => {
                setSpecifiedPageText(e.target.value);
            } }) }));
};



/***/ }),

/***/ "../tslib/react/pkg/components/GraphContainer.js":
/*!*******************************************************!*\
  !*** ../tslib/react/pkg/components/GraphContainer.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GraphContainer: () => (/* binding */ GraphContainer)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");


const GraphContainer = ({ plotDomId, graphComponentState }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_1__["default"])();
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { component: "div", id: plotDomId, sx: { height: "450px" }, children: graphComponentState !== "graphDidRender" && ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_2__["default"], { component: "div", sx: {
                height: "100%",
                display: "flex",
                alignItems: "center",
                justifyContent: "center",
            }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { color: theme.palette.grey[700], children: "Loading..." }) })) }));
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotEdf.js":
/*!************************************************!*\
  !*** ../tslib/react/pkg/components/PlotEdf.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotEdf: () => (/* binding */ PlotEdf)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../hooks/useGraphComponentState */ "../tslib/react/pkg/hooks/useGraphComponentState.js");
/* harmony import */ var _utils_trialFilter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils/trialFilter */ "../tslib/react/pkg/utils/trialFilter.js");
/* harmony import */ var _GraphContainer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./GraphContainer */ "../tslib/react/pkg/components/GraphContainer.js");
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");








const getPlotDomId = (objectiveId) => `plot-edf-${objectiveId}`;
const PlotEdf = ({ studies, objectiveId, colorTheme }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_6__.plotlyDarkTemplate : {});
    const domId = getPlotDomId(objectiveId);
    const target = (0,react__WEBPACK_IMPORTED_MODULE_2__.useMemo)(() => new _utils_trialFilter__WEBPACK_IMPORTED_MODULE_4__.Target("objective", objectiveId), [objectiveId]);
    const trials = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_4__.useFilteredTrialsFromStudies)(studies, [target], false);
    const edfPlotInfos = studies.map((study, index) => {
        const e = {
            study_name: study?.name,
            trials: trials[index],
        };
        return e;
    });
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (graphComponentState !== "componentWillMount") {
            plotEdf(edfPlotInfos, target, domId, colorThemeUsed)?.then(notifyGraphDidRender);
        }
    }, [studies, target, colorThemeUsed, graphComponentState]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { component: "div", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: `EDF for ${target.toLabel(studies[0].metric_names)}` }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_GraphContainer__WEBPACK_IMPORTED_MODULE_5__.GraphContainer, { plotDomId: domId, graphComponentState: graphComponentState })] }));
};
const plotEdf = (edfPlotInfos, target, domId, colorTheme) => {
    if (document.getElementById(domId) === null) {
        return;
    }
    if (edfPlotInfos.length === 0) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, [], {
            template: colorTheme,
        });
    }
    const target_name = "Objective Value";
    const layout = {
        xaxis: {
            title: target_name,
        },
        yaxis: {
            title: "Cumulative Probability",
        },
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 50,
        },
        template: colorTheme,
        legend: {
            x: 1.0,
            y: 0.95,
        },
    };
    const plotData = edfPlotInfos.map((h) => {
        const values = h.trials.map((t) => target.getTargetValue(t));
        const numValues = values.length;
        const minX = Math.min(...values);
        const maxX = Math.max(...values);
        const numStep = 100;
        const _step = (maxX - minX) / (numStep - 1);
        const xValues = [];
        const yValues = [];
        for (let i = 0; i < numStep; i++) {
            const boundary_right = minX + _step * i;
            xValues.push(boundary_right);
            yValues.push(values.filter((v) => v <= boundary_right).length / numValues);
        }
        return {
            type: "scatter",
            name: `${h.study_name}`,
            x: xValues,
            y: yValues,
        };
    });
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, plotData, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotHistory.js":
/*!****************************************************!*\
  !*** ../tslib/react/pkg/components/PlotHistory.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotHistory: () => (/* binding */ PlotHistory)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/RadioGroup/RadioGroup.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Radio/Radio.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Slider/Slider.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../hooks/useGraphComponentState */ "../tslib/react/pkg/hooks/useGraphComponentState.js");
/* harmony import */ var _utils_graph__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils/graph */ "../tslib/react/pkg/utils/graph.js");
/* harmony import */ var _utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../utils/trialFilter */ "../tslib/react/pkg/utils/trialFilter.js");
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");








const plotDomId = "plot-history";
const PlotHistory = ({ studies, logScale, includePruned, colorTheme, linkURL, router }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_6__.plotlyDarkTemplate : {});
    const [xAxis, setXAxis] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)("number");
    const [logScaleInternal, setLogScaleInternal] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(false);
    const [includePrunedInternal, setIncludePrunedInternal] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(true);
    const [markerSize, setMarkerSize] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(5);
    const [targets, selected, setTarget] = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__.useObjectiveAndUserAttrTargetsFromStudies)(studies);
    const trials = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__.useFilteredTrialsFromStudies)(studies, [selected], includePruned === undefined ? !includePrunedInternal : !includePruned);
    const historyPlotInfos = studies.map((study, index) => {
        const h = {
            study_name: study.name,
            trials: trials[index],
            directions: study.directions,
            metric_names: study.metric_names,
        };
        return h;
    });
    const handleObjectiveChange = (event) => {
        setTarget(event.target.value);
    };
    const handleLogScaleChange = () => {
        setLogScaleInternal(!logScaleInternal);
    };
    const handleIncludePrunedChange = () => {
        setIncludePrunedInternal(!includePrunedInternal);
    };
    const handleXAxisChange = (e) => {
        if (e.target.value === "number") {
            setXAxis("number");
        }
        else if (e.target.value === "datetime_start") {
            setXAxis("datetime_start");
        }
        else if (e.target.value === "datetime_complete") {
            setXAxis("datetime_complete");
        }
    };
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (graphComponentState !== "componentWillMount") {
            plotHistory(historyPlotInfos, selected, xAxis, logScale === undefined ? logScaleInternal : logScale, colorThemeUsed, markerSize)?.then(notifyGraphDidRender);
            const element = document.getElementById(plotDomId);
            if (element !== null &&
                studies.length >= 1 &&
                linkURL !== undefined &&
                router !== undefined) {
                // @ts-ignore
                element.on("plotly_click", (data) => {
                    if (data.points[0].data.mode !== "lines") {
                        let studyId = 1;
                        if (data.points[0].data.name.includes("Infeasible Trial of")) {
                            const studyInfo = [];
                            for (const study of studies) {
                                studyInfo.push({ id: study.id, name: study.name });
                            }
                            const dataPointStudyName = data.points[0].data.name.replace("Infeasible Trial of ", "");
                            const targetId = studyInfo.find((s) => s.name === dataPointStudyName)?.id;
                            if (targetId !== undefined) {
                                studyId = targetId;
                            }
                        }
                        else {
                            studyId = studies[Math.floor(data.points[0].curveNumber / 2)].id;
                        }
                        const trialNumber = data.points[0].x;
                        router(linkURL(studyId, trialNumber));
                    }
                });
                return () => {
                    // @ts-ignore
                    element.removeAllListeners("plotly_click");
                };
            }
        }
    }, [
        historyPlotInfos,
        selected,
        xAxis,
        logScale,
        logScaleInternal,
        colorThemeUsed,
        markerSize,
        graphComponentState,
    ]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { container: true, direction: "row", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 3, container: true, direction: "column", sx: { paddingRight: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "History" }), studies[0] !== null && targets.length >= 2 ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", sx: { marginBottom: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend", children: "y Axis" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { value: selected.identifier(), onChange: handleObjectiveChange, children: targets.map((t) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: t.identifier(), children: t.toLabel(studies[0].metric_names) }, t.identifier()))) })] })) : null, (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", sx: { marginBottom: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend", children: "X-axis:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { "aria-label": "gender", name: "gender1", value: xAxis, onChange: handleXAxisChange, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: "number", control: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], {}), label: "Number" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: "datetime_start", control: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], {}), label: "Datetime start" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { value: "datetime_complete", control: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_16__["default"], {}), label: "Datetime complete" })] })] }), logScale === undefined ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", sx: { marginBottom: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend", children: "Log y scale:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { checked: logScaleInternal, onChange: handleLogScaleChange, value: "enable" })] })) : null, includePruned === undefined ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { component: "fieldset", sx: { marginBottom: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend", children: " Include PRUNED trials:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_17__["default"], { checked: includePrunedInternal, onChange: handleIncludePrunedChange, value: "enable" })] })) : null, (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "legend", children: "Marker size:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_18__["default"], { defaultValue: 5, marks: true, min: 1, max: 10, step: 1, onChange: (e) => {
                                    // @ts-ignore
                                    setMarkerSize(e.target.value);
                                } })] })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { item: true, xs: 9, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { id: plotDomId }) })] }));
};
const plotHistory = (historyPlotInfos, target, xAxis, logScale, colorTheme, markerSize) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    if (historyPlotInfos.length === 0) {
        plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], {
            template: colorTheme,
        });
        return;
    }
    const layout = {
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 0,
        },
        yaxis: {
            title: target.toLabel(historyPlotInfos[0].metric_names),
            type: logScale ? "log" : "linear",
        },
        xaxis: {
            title: xAxis === "number" ? "Trial" : "Time",
            type: xAxis === "number" ? "linear" : "date",
        },
        showlegend: historyPlotInfos.length === 1 ? false : true,
        template: colorTheme,
        legend: {
            x: 1.0,
            y: 0.95,
        },
    };
    const getAxisX = (trial) => {
        return xAxis === "number"
            ? trial.number
            : xAxis === "datetime_start"
                ? trial.datetime_start ?? new Date()
                : trial.datetime_complete ?? new Date();
    };
    const plotData = [];
    const infeasiblePlotData = [];
    for (const h of historyPlotInfos) {
        const feasibleTrials = [];
        const infeasibleTrials = [];
        for (const t of h.trials) {
            if (t.constraints.every((c) => c <= 0)) {
                feasibleTrials.push(t);
            }
            else {
                infeasibleTrials.push(t);
            }
        }
        const hovertemplate = infeasibleTrials.length === 0
            ? "%{text}<extra>Trial</extra>"
            : "%{text}<extra>Feasible Trial</extra>";
        plotData.push({
            x: feasibleTrials.map(getAxisX),
            y: feasibleTrials.map((t) => target.getTargetValue(t)),
            name: `${target.toLabel(h.metric_names)} of ${h.study_name}`,
            marker: {
                size: markerSize,
            },
            mode: "markers",
            type: "scatter",
            text: feasibleTrials.map((t) => (0,_utils_graph__WEBPACK_IMPORTED_MODULE_4__.makeHovertext)(t)),
            hovertemplate: hovertemplate,
        });
        const objectiveId = target.getObjectiveId();
        if (objectiveId !== null) {
            const xForLinePlot = [];
            const yForLinePlot = [];
            let currentBest = null;
            for (let i = 0; i < feasibleTrials.length; i++) {
                const t = feasibleTrials[i];
                const value = target.getTargetValue(t);
                if (t.state !== "Complete") {
                    continue;
                }
                if (currentBest === null) {
                    currentBest = value;
                    xForLinePlot.push(getAxisX(t));
                    yForLinePlot.push(value);
                }
                else if (h.directions[objectiveId] === "maximize" &&
                    value > currentBest) {
                    const p = feasibleTrials[i - 1];
                    if (!xForLinePlot.includes(getAxisX(p))) {
                        xForLinePlot.push(getAxisX(p));
                        yForLinePlot.push(currentBest);
                    }
                    currentBest = value;
                    xForLinePlot.push(getAxisX(t));
                    yForLinePlot.push(value);
                }
                else if (h.directions[objectiveId] === "minimize" &&
                    value < currentBest) {
                    const p = feasibleTrials[i - 1];
                    if (!xForLinePlot.includes(getAxisX(p))) {
                        xForLinePlot.push(getAxisX(p));
                        yForLinePlot.push(currentBest);
                    }
                    currentBest = value;
                    xForLinePlot.push(getAxisX(t));
                    yForLinePlot.push(value);
                }
            }
            if (h.trials.length !== 0) {
                xForLinePlot.push(getAxisX(h.trials[h.trials.length - 1]));
                yForLinePlot.push(yForLinePlot[yForLinePlot.length - 1]);
            }
            plotData.push({
                x: xForLinePlot,
                y: yForLinePlot,
                name: `Best Value of ${h.study_name}`,
                mode: "lines",
                type: "scatter",
            });
        }
        infeasiblePlotData.push({
            x: infeasibleTrials.map(getAxisX),
            y: infeasibleTrials.map((t) => target.getTargetValue(t)),
            name: `Infeasible Trial of ${h.study_name}`,
            marker: {
                size: markerSize,
                color: colorTheme === _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_6__.plotlyDarkTemplate ? "#666666" : "#cccccc",
            },
            mode: "markers",
            type: "scatter",
            text: infeasibleTrials.map((t) => (0,_utils_graph__WEBPACK_IMPORTED_MODULE_4__.makeHovertext)(t)),
            hovertemplate: "%{text}<extra>Infeasible Trial</extra>",
            showlegend: false,
        });
    }
    plotData.push(...infeasiblePlotData);
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotImportance.js":
/*!*******************************************************!*\
  !*** ../tslib/react/pkg/components/PlotImportance.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotImportance: () => (/* binding */ PlotImportance)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");





const plotDomId = "graph-hyperparameter-importances";
const PlotImportance = ({ study = null, importance, graphHeight = "450px", colorTheme }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_3__.plotlyDarkTemplate : {});
    const objectiveNames = study
        ? study.directions.map((_d, i) => `Objective ${i}`)
        : [];
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (study !== null && importance !== undefined && importance.length > 0) {
            plotParamImportancesBeta(importance, objectiveNames, colorThemeUsed);
        }
    }, [study, objectiveNames, importance, colorThemeUsed]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "Hyperparameter Importance" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { id: plotDomId, sx: { height: graphHeight } })] }));
};
const plotParamImportancesBeta = (importances, objectiveNames, colorTheme) => {
    const layout = {
        xaxis: {
            title: "Hyperparameter Importance",
        },
        yaxis: {
            title: "Hyperparameter",
            automargin: true,
        },
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 50,
        },
        barmode: "group",
        bargap: 0.15,
        bargroupgap: 0.1,
        uirevision: "true",
        template: colorTheme,
        legend: {
            x: 1.0,
            y: 0.95,
        },
    };
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    const traces = importances.map((importance, i) => {
        const reversed = [...importance].reverse();
        const importance_values = reversed.map((p) => p.importance);
        const param_names = reversed.map((p) => p.name);
        const param_hover_templates = reversed.map((p) => `${p.name}): ${p.importance} <extra></extra>`);
        return {
            type: "bar",
            orientation: "h",
            name: objectiveNames[i],
            x: importance_values,
            y: param_names,
            text: importance_values.map((v) => String(v.toFixed(2))),
            textposition: "outside",
            hovertemplate: param_hover_templates,
        };
    });
    plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, traces, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotIntermediateValues.js":
/*!***************************************************************!*\
  !*** ../tslib/react/pkg/components/PlotIntermediateValues.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotIntermediateValues: () => (/* binding */ PlotIntermediateValues)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Box/Box.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");





const plotDomId = "graph-intermediate-values";
const PlotIntermediateValues = ({ trials, includePruned, logScale, colorTheme }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_4__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_3__.plotlyDarkTemplate : {});
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        plotIntermediateValue(trials, colorThemeUsed, false, !includePruned, logScale);
    }, [trials, colorThemeUsed, includePruned, logScale]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "Intermediate values" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { id: plotDomId, sx: { height: "450px" } })] }));
};
const plotIntermediateValue = (trials, colorTheme, filterCompleteTrial, filterPrunedTrial, logScale) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    const layout = {
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 0,
        },
        yaxis: {
            title: "Objective Value",
            type: logScale ? "log" : "linear",
        },
        xaxis: {
            title: "Step",
            type: "linear",
        },
        uirevision: "true",
        template: colorTheme,
        legend: {
            x: 1.0,
            y: 0.95,
        },
    };
    if (trials.length === 0) {
        plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], layout);
        return;
    }
    const filteredTrials = trials.filter((t) => (!filterCompleteTrial && t.state === "Complete") ||
        (!filterPrunedTrial &&
            t.state === "Pruned" &&
            t.values &&
            t.values.length > 0) ||
        t.state === "Running");
    const plotData = filteredTrials.map((trial) => {
        const isFeasible = trial.constraints.every((c) => c <= 0);
        return {
            x: trial.intermediate_values.map((iv) => iv.step),
            y: trial.intermediate_values.map((iv) => iv.value),
            marker: { maxdisplayed: 10 },
            mode: "lines+markers",
            type: "scatter",
            name: `trial #${trial.number} ${trial.state === "Running"
                ? "(running)"
                : !isFeasible
                    ? "(infeasible)"
                    : ""}`,
            ...(!isFeasible && { line: { color: "#CCCCCC" } }),
        };
    });
    plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotParallelCoordinate.js":
/*!***************************************************************!*\
  !*** ../tslib/react/pkg/components/PlotParallelCoordinate.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotParallelCoordinate: () => (/* binding */ PlotParallelCoordinate)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormGroup/FormGroup.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControlLabel/FormControlLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Checkbox/Checkbox.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Divider/Divider.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var ___WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! .. */ "../tslib/react/pkg/index.js");
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");






const plotDomId = "plot-parallel-coordinate";
const PlotParallelCoordinate = ({ study = null, colorTheme }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,___WEBPACK_IMPORTED_MODULE_3__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_4__.plotlyDarkTemplate : {});
    const [targets, searchSpace, renderCheckBoxes] = useTargets(study);
    const trials = (0,___WEBPACK_IMPORTED_MODULE_3__.useFilteredTrials)(study, targets, false);
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (study !== null && graphComponentState !== "componentWillMount") {
            // TODO(c-bata): Fix the broken E2E tests.
            // https://github.com/optuna/optuna-dashboard/pull/929#issuecomment-2296632106
            // https://github.com/optuna/optuna-dashboard/actions/runs/10451985071/job/28939493755?pr=937
            try {
                plotCoordinate(study, trials, targets, searchSpace, colorThemeUsed)?.then(notifyGraphDidRender);
            }
            catch (e) {
                console.error(e);
            }
        }
    }, [
        study,
        trials,
        targets,
        searchSpace,
        colorThemeUsed,
        graphComponentState,
        notifyGraphDidRender,
    ]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { container: true, direction: "row", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { item: true, xs: 3, container: true, direction: "column", sx: {
                    paddingRight: theme.spacing(2),
                    display: "flex",
                    flexDirection: "column",
                }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "Parallel Coordinate" }), renderCheckBoxes()] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { item: true, xs: 9, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(___WEBPACK_IMPORTED_MODULE_3__.GraphContainer, { plotDomId: plotDomId, graphComponentState: graphComponentState }) })] }));
};
const plotCoordinate = (study, trials, targets, searchSpace, colorTheme) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    const layout = {
        margin: {
            l: 70,
            t: 50,
            r: 50,
            b: 100,
        },
        template: colorTheme,
        uirevision: "true",
    };
    if (trials.length === 0 || targets.length === 0) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], layout);
    }
    const maxLabelLength = 40;
    const breakLength = maxLabelLength / 2;
    const ellipsis = "…";
    const truncateLabelIfTooLong = (originalLabel) => {
        return originalLabel.length > maxLabelLength
            ? originalLabel.substring(0, maxLabelLength - ellipsis.length) + ellipsis
            : originalLabel;
    };
    const breakLabelIfTooLong = (originalLabel) => {
        const truncated = truncateLabelIfTooLong(originalLabel);
        return truncated
            .split("")
            .map((c, i) => {
            return (i + 1) % breakLength === 0 ? `${c}<br>` : c;
        })
            .join("");
    };
    const calculateLogScale = (values) => {
        const logValues = values.map((v) => {
            return Math.log10(v);
        });
        const minValue = Math.min(...logValues);
        const maxValue = Math.max(...logValues);
        const range = [Math.floor(minValue), Math.ceil(maxValue)];
        const tickvals = Array.from({ length: Math.ceil(maxValue) - Math.floor(minValue) + 1 }, (_, i) => i + Math.floor(minValue));
        const ticktext = tickvals.map((x) => `${(10 ** x).toPrecision(3)}`);
        return { logValues, range, tickvals, ticktext };
    };
    const dimensions = targets.map((target) => {
        if (target.kind === "objective" || target.kind === "user_attr") {
            const values = trials.map((t) => target.getTargetValue(t));
            return {
                label: target.toLabel(study.metric_names),
                values: values,
                range: [Math.min(...values), Math.max(...values)],
            };
        }
        const s = searchSpace.find((s) => s.name === target.key); // Must be already filtered.
        const values = trials.map((t) => target.getTargetValue(t));
        if (s.distribution.type === "CategoricalDistribution") {
            // categorical
            const vocabArr = s.distribution.choices.map((c) => c?.value ?? "null");
            const tickvals = vocabArr.map((_, i) => i);
            return {
                label: breakLabelIfTooLong(s.name),
                values: values,
                range: [0, s.distribution.choices.length - 1],
                // @ts-ignore
                tickvals: tickvals,
                ticktext: vocabArr,
            };
        }
        if (s.distribution.log) {
            // numerical and log
            const { logValues, range, tickvals, ticktext } = calculateLogScale(values);
            return {
                label: breakLabelIfTooLong(s.name),
                values: logValues,
                range,
                tickvals,
                ticktext,
            };
        }
        // numerical and linear
        return {
            label: breakLabelIfTooLong(s.name),
            values: values,
            range: [s.distribution.low, s.distribution.high],
        };
    });
    if (dimensions.length === 0) {
        console.log("Must not reach here.");
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], layout);
    }
    let reversescale = false;
    if (targets[0].kind === "objective" &&
        targets[0].getObjectiveId() < study.directions.length &&
        study.directions[targets[0].getObjectiveId()] === "maximize") {
        reversescale = true;
    }
    const plotData = [
        {
            type: "parcoords",
            dimensions: dimensions,
            labelangle: 30,
            labelside: "bottom",
            line: {
                color: dimensions[0].values,
                // @ts-ignore
                colorscale: "Blues",
                colorbar: {
                    title: targets[0].toLabel(study.metric_names),
                },
                showscale: true,
                reversescale: reversescale,
            },
        },
    ];
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, plotData, layout);
};
const useTargets = (study) => {
    const [targets1] = (0,___WEBPACK_IMPORTED_MODULE_3__.useObjectiveAndUserAttrTargets)(study);
    const searchSpace = (0,___WEBPACK_IMPORTED_MODULE_3__.useMergedUnionSearchSpace)(study?.union_search_space);
    const [targets2] = (0,___WEBPACK_IMPORTED_MODULE_3__.useParamTargets)(searchSpace);
    const [checked, setChecked] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)([true]);
    const [checkedAll, setCheckedAll] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(true);
    const toggleCheckedAll = () => {
        if (checkedAll) {
            setChecked(checked.map(() => false));
        }
        else {
            setChecked(checked.map(() => true));
        }
        setCheckedAll((prevCheckedAll) => !prevCheckedAll);
    };
    const allTargets = [...targets1, ...targets2];
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (allTargets.length !== checked.length) {
            setChecked(allTargets.map((t) => {
                if (t.kind === "user_attr") {
                    return false;
                }
                if (t.kind !== "params" || study === null) {
                    return true;
                }
                // By default, params that is not included in intersection search space should be disabled,
                // otherwise all trials are filtered.
                return (study.intersection_search_space.find((s) => s.name === t.key) !==
                    undefined);
            }));
        }
    }, [allTargets, study, checked.length]);
    const handleOnChange = (event) => {
        setChecked(checked.map((c, i) => i.toString() === event.target.name ? event.target.checked : c));
    };
    const renderCheckBoxes = () => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { control: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { checked: checkedAll, onChange: toggleCheckedAll, name: "checkedAll" }), label: "Check All" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], {}), allTargets.map((t, i) => {
                const key = t.toLabel(study?.metric_names);
                return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { control: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { checked: checked.length > i ? checked[i] : true, onChange: handleOnChange, name: i.toString() }), label: t.toLabel(study?.metric_names) }, key));
            })] }));
    const targets = allTargets.filter((_, i) => checked.length > i ? checked[i] : true);
    return [targets, searchSpace, renderCheckBoxes];
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotSlice.js":
/*!**************************************************!*\
  !*** ../tslib/react/pkg/components/PlotSlice.js ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotSlice: () => (/* binding */ PlotSlice)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Grid/Grid.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormControl/FormControl.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/FormLabel/FormLabel.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Select/Select.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/MenuItem/MenuItem.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Switch/Switch.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../hooks/useGraphComponentState */ "../tslib/react/pkg/hooks/useGraphComponentState.js");
/* harmony import */ var _utils_searchSpace__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils/searchSpace */ "../tslib/react/pkg/utils/searchSpace.js");
/* harmony import */ var _utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../utils/trialFilter */ "../tslib/react/pkg/utils/trialFilter.js");
/* harmony import */ var _GraphContainer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./GraphContainer */ "../tslib/react/pkg/components/GraphContainer.js");
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");









const isLogScale = (s) => {
    if (s.distribution.type === "CategoricalDistribution") {
        return false;
    }
    return s.distribution.log;
};
const domId = "plot-slice";
const PlotSlice = ({ study = null, colorTheme }) => {
    const { graphComponentState, notifyGraphDidRender } = (0,_hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_3__.useGraphComponentState)();
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_7__.plotlyDarkTemplate : {});
    const [objectiveTargets, selectedObjective, setObjectiveTarget] = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__.useObjectiveAndUserAttrTargets)(study);
    const searchSpace = (0,_utils_searchSpace__WEBPACK_IMPORTED_MODULE_4__.useMergedUnionSearchSpace)(study?.union_search_space);
    const [paramTargets, selectedParamTarget, setParamTarget] = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__.useParamTargets)(searchSpace);
    const [logYScale, setLogYScale] = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(false);
    const trials = (0,_utils_trialFilter__WEBPACK_IMPORTED_MODULE_5__.useFilteredTrials)(study, selectedParamTarget !== null
        ? [selectedObjective, selectedParamTarget]
        : [selectedObjective], false);
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (graphComponentState !== "componentWillMount") {
            plotSlice(trials, selectedObjective, selectedParamTarget, searchSpace.find((s) => s.name === selectedParamTarget?.key) || null, logYScale, colorThemeUsed)?.then(notifyGraphDidRender);
        }
    }, [
        trials,
        selectedObjective,
        searchSpace,
        selectedParamTarget,
        logYScale,
        colorThemeUsed,
        graphComponentState,
    ]);
    const handleObjectiveChange = (event) => {
        setObjectiveTarget(event.target.value);
    };
    const handleSelectedParam = (e) => {
        setParamTarget(e.target.value);
    };
    const handleLogYScaleChange = () => {
        setLogYScale(!logYScale);
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { container: true, direction: "row", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { item: true, xs: 3, container: true, direction: "column", sx: { paddingRight: theme.spacing(2) }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_10__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "Slice" }), objectiveTargets.length !== 1 && ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "fieldset", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "legend", children: "Objective:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: selectedObjective.identifier(), onChange: handleObjectiveChange, children: objectiveTargets.map((t, i) => (
                                // biome-ignore lint/suspicious/noArrayIndexKey: <explanation>
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { value: t.identifier(), children: t.toLabel(study?.metric_names) }, i))) })] })), paramTargets.length !== 0 && selectedParamTarget !== null && ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "fieldset", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "legend", children: "Parameter:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_13__["default"], { value: selectedParamTarget.identifier(), onChange: handleSelectedParam, children: paramTargets.map((t, i) => (
                                // biome-ignore lint/suspicious/noArrayIndexKey: <explanation>
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_14__["default"], { value: t.identifier(), children: t.toLabel() }, i))) })] })), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_11__["default"], { component: "fieldset", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_12__["default"], { component: "legend", children: "Log y scale:" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_15__["default"], { checked: logYScale, onChange: handleLogYScaleChange, value: "enable" })] })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_9__["default"], { item: true, xs: 9, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_GraphContainer__WEBPACK_IMPORTED_MODULE_6__.GraphContainer, { plotDomId: domId, graphComponentState: graphComponentState }) })] }));
};
const plotSlice = (trials, objectiveTarget, selectedParamTarget, selectedParamSpace, logYScale, colorTheme) => {
    if (document.getElementById(domId) === null) {
        return;
    }
    const layout = {
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 0,
        },
        xaxis: {
            title: selectedParamTarget?.toLabel() || "",
            type: selectedParamSpace !== null && isLogScale(selectedParamSpace)
                ? "log"
                : "linear",
            gridwidth: 1,
            automargin: true,
        },
        yaxis: {
            title: "Objective Value",
            type: logYScale ? "log" : "linear",
            gridwidth: 1,
            automargin: true,
        },
        showlegend: false,
        uirevision: "true",
        template: colorTheme,
    };
    if (selectedParamSpace === null ||
        selectedParamTarget === null ||
        trials.length === 0) {
        return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, [], layout);
    }
    const feasibleTrials = [];
    const infeasibleTrials = [];
    // biome-ignore lint/complexity/noForEach: <explanation>
    trials.forEach((t) => {
        if (t.constraints.every((c) => c <= 0)) {
            feasibleTrials.push(t);
        }
        else {
            infeasibleTrials.push(t);
        }
    });
    const feasibleObjectiveValues = feasibleTrials.map((t) => objectiveTarget.getTargetValue(t));
    const infeasibleObjectiveValues = infeasibleTrials.map((t) => objectiveTarget.getTargetValue(t));
    const feasibleValues = feasibleTrials.map((t) => selectedParamTarget.getTargetValue(t));
    const infeasibleValues = infeasibleTrials.map((t) => selectedParamTarget.getTargetValue(t));
    const trace = [
        {
            type: "scatter",
            x: feasibleValues,
            y: feasibleObjectiveValues,
            mode: "markers",
            name: "Feasible Trial",
            marker: {
                color: feasibleTrials.map((t) => t.number),
                colorscale: "Blues",
                reversescale: true,
                colorbar: {
                    title: "Trial",
                },
                line: {
                    color: "Grey",
                    width: 0.5,
                },
            },
        },
        {
            type: "scatter",
            x: infeasibleValues,
            y: infeasibleObjectiveValues,
            mode: "markers",
            name: "Infeasible Trial",
            marker: {
                color: "#cccccc",
                reversescale: true,
            },
        },
    ];
    if (selectedParamSpace.distribution.type !== "CategoricalDistribution") {
        layout.xaxis = {
            title: selectedParamTarget.toLabel(),
            type: isLogScale(selectedParamSpace) ? "log" : "linear",
            gridwidth: 1,
            automargin: true, // Otherwise the label is outside of the plot
        };
    }
    else {
        const vocabArr = selectedParamSpace.distribution.choices.map((c) => c?.value ?? "null");
        const tickvals = vocabArr.map((_v, i) => i);
        layout.xaxis = {
            title: selectedParamTarget.toLabel(),
            type: "linear",
            gridwidth: 1,
            tickvals: tickvals,
            ticktext: vocabArr,
            automargin: true, // Otherwise the label is outside of the plot
        };
    }
    return plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(domId, trace, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotTimeline.js":
/*!*****************************************************!*\
  !*** ../tslib/react/pkg/components/PlotTimeline.js ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlotTimeline: () => (/* binding */ PlotTimeline)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/styles/useTheme.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Card/Card.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/CardContent/CardContent.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/Typography/Typography.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! plotly.js-dist-min */ "../tslib/react/node_modules/plotly.js-dist-min/plotly.min.js");
/* harmony import */ var plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _utils_graph__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../utils/graph */ "../tslib/react/pkg/utils/graph.js");
/* harmony import */ var _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");






const plotDomId = "graph-timeline";
const maxBars = 100;
const PlotTimeline = ({ study, colorTheme }) => {
    const theme = (0,_mui_material__WEBPACK_IMPORTED_MODULE_5__["default"])();
    const colorThemeUsed = colorTheme ?? (theme.palette.mode === "dark" ? _PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_4__.plotlyDarkTemplate : {});
    const trials = study?.trials ?? [];
    (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
        if (study !== null) {
            plotTimeline(trials, colorThemeUsed);
        }
    }, [study, trials, colorThemeUsed]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_6__["default"], { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_mui_material__WEBPACK_IMPORTED_MODULE_7__["default"], { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_8__["default"], { variant: "h6", sx: { margin: "1em 0", fontWeight: theme.typography.fontWeightBold }, children: "Timeline" }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { id: plotDomId })] }) }));
};
const plotTimeline = (trials, colorTheme) => {
    if (document.getElementById(plotDomId) === null) {
        return;
    }
    if (trials.length === 0) {
        plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, [], {
            template: colorTheme,
        });
        return;
    }
    const cm = {
        Complete: "blue",
        Fail: "red",
        Pruned: "orange",
        Running: "green",
        Waiting: "gray",
    };
    const runningKey = "Running";
    const lastTrials = trials.slice(-maxBars); // To only show last elements
    const minDatetime = new Date(Math.min(...lastTrials.map((t) => t.datetime_start?.getTime() ?? new Date().getTime())));
    const maxRunDuration = Math.max(...trials.map((t) => {
        return t.datetime_start === undefined || t.datetime_complete === undefined
            ? -Infinity
            : t.datetime_complete.getTime() - t.datetime_start.getTime();
    }));
    const hasRunning = (maxRunDuration === -Infinity &&
        trials.some((t) => t.state === runningKey)) ||
        trials.some((t) => {
            if (t.state !== runningKey) {
                return false;
            }
            const now = new Date().getTime();
            const start = t.datetime_start?.getTime() ?? now;
            // This is an ad-hoc handling to check if the trial is running.
            // We do not check via `trialState` because some trials may have state=RUNNING,
            // even if they are not running because of unexpected job kills.
            // In this case, we would like to ensure that these trials will not squash the timeline plot
            // for the other trials.
            return now - start < maxRunDuration * 5;
        });
    const maxDatetime = hasRunning
        ? new Date()
        : new Date(Math.max(...lastTrials.map((t) => t.datetime_complete?.getTime() ?? minDatetime.getTime())));
    const layout = {
        margin: {
            l: 50,
            t: 0,
            r: 50,
            b: 0,
        },
        xaxis: {
            title: "Datetime",
            type: "date",
            range: [minDatetime, maxDatetime],
        },
        yaxis: {
            title: "Trial",
            range: [lastTrials[0].number, lastTrials[0].number + lastTrials.length],
        },
        uirevision: "true",
        template: colorTheme,
        legend: {
            x: 1.0,
            y: 0.95,
        },
    };
    const makeTrace = (bars, state, color) => {
        const isRunning = state === runningKey;
        // Waiting trials should not squash other trials, so use `maxDatetime` instead of `new Date()`.
        const starts = bars.map((b) => b.datetime_start ?? maxDatetime);
        const runDurations = bars.map((b, i) => {
            const startTime = starts[i].getTime();
            const completeTime = isRunning
                ? maxDatetime.getTime()
                : b.datetime_complete?.getTime() ?? startTime;
            // By using 1 as the min value, we can recognize these bars at least when zooming in.
            return Math.max(1, completeTime - startTime);
        });
        const trace = {
            type: "bar",
            x: runDurations,
            y: bars.map((b) => b.number),
            // @ts-ignore: To suppress ts(2322)
            base: starts,
            name: state,
            text: bars.map((b) => (0,_utils_graph__WEBPACK_IMPORTED_MODULE_3__.makeHovertext)(b)),
            hovertemplate: `%{text}<extra>${state}</extra>`,
            orientation: "h",
            marker: { color: color },
            textposition: "none", // Avoid drawing hovertext in a bar.
        };
        return trace;
    };
    const traces = [];
    for (const [state, color] of Object.entries(cm)) {
        const bars = trials.filter((t) => t.state === state);
        if (bars.length === 0) {
            continue;
        }
        if (state === "Complete") {
            const feasibleTrials = bars.filter((t) => t.constraints.every((c) => c <= 0));
            const infeasibleTrials = bars.filter((t) => t.constraints.some((c) => c > 0));
            if (feasibleTrials.length > 0) {
                traces.push(makeTrace(feasibleTrials, "Complete", color));
            }
            if (infeasibleTrials.length > 0) {
                traces.push(makeTrace(infeasibleTrials, "Infeasible", "#cccccc"));
            }
        }
        else {
            traces.push(makeTrace(bars, state, color));
        }
    }
    plotly_js_dist_min__WEBPACK_IMPORTED_MODULE_1__.react(plotDomId, traces, layout);
};


/***/ }),

/***/ "../tslib/react/pkg/components/PlotlyDarkMode.js":
/*!*******************************************************!*\
  !*** ../tslib/react/pkg/components/PlotlyDarkMode.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   plotlyDarkTemplate: () => (/* binding */ plotlyDarkTemplate)
/* harmony export */ });
// Following template is extracted from the sdist of plotly Python library.
// See https://github.com/plotly/plotly.py/blob/v5.6.0/packages/python/plotly/templategen/__init__.py and
// https://github.com/plotly/plotly.py/blob/v5.6.0/packages/python/plotly/templategen/definitions.py
//@ts-ignore
const plotlyDarkTemplate = { "data": { "bar": [{ "error_x": { "color": "#f2f5fa" }, "error_y": { "color": "#f2f5fa" }, "marker": { "line": { "color": "rgb(17,17,17)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "bar" }], "barpolar": [{ "marker": { "line": { "color": "rgb(17,17,17)", "width": 0.5 }, "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "barpolar" }], "carpet": [{ "aaxis": { "endlinecolor": "#A2B1C6", "gridcolor": "#506784", "linecolor": "#506784", "minorgridcolor": "#506784", "startlinecolor": "#A2B1C6" }, "baxis": { "endlinecolor": "#A2B1C6", "gridcolor": "#506784", "linecolor": "#506784", "minorgridcolor": "#506784", "startlinecolor": "#A2B1C6" }, "type": "carpet" }], "choropleth": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "type": "choropleth" }], "contour": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "contour" }], "contourcarpet": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "type": "contourcarpet" }], "heatmap": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "heatmap" }], "heatmapgl": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "heatmapgl" }], "histogram": [{ "marker": { "pattern": { "fillmode": "overlay", "size": 10, "solidity": 0.2 } }, "type": "histogram" }], "histogram2d": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "histogram2d" }], "histogram2dcontour": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "histogram2dcontour" }], "mesh3d": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "type": "mesh3d" }], "parcoords": [{ "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "parcoords" }], "pie": [{ "automargin": true, "type": "pie" }], "scatter": [{ "marker": { "line": { "color": "#283442" } }, "type": "scatter" }], "scatter3d": [{ "line": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scatter3d" }], "scattercarpet": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scattercarpet" }], "scattergeo": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scattergeo" }], "scattergl": [{ "marker": { "line": { "color": "#283442" } }, "type": "scattergl" }], "scattermapbox": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scattermapbox" }], "scatterpolar": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scatterpolar" }], "scatterpolargl": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scatterpolargl" }], "scatterternary": [{ "marker": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "type": "scatterternary" }], "surface": [{ "colorbar": { "outlinewidth": 0, "ticks": "" }, "colorscale": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "type": "surface" }], "table": [{ "cells": { "fill": { "color": "#506784" }, "line": { "color": "rgb(17,17,17)" } }, "header": { "fill": { "color": "#2a3f5f" }, "line": { "color": "rgb(17,17,17)" } }, "type": "table" }] }, "layout": { "annotationdefaults": { "arrowcolor": "#f2f5fa", "arrowhead": 0, "arrowwidth": 1 }, "autotypenumbers": "strict", "coloraxis": { "colorbar": { "outlinewidth": 0, "ticks": "" } }, "colorscale": { "diverging": [[0, "#8e0152"], [0.1, "#c51b7d"], [0.2, "#de77ae"], [0.3, "#f1b6da"], [0.4, "#fde0ef"], [0.5, "#f7f7f7"], [0.6, "#e6f5d0"], [0.7, "#b8e186"], [0.8, "#7fbc41"], [0.9, "#4d9221"], [1, "#276419"]], "sequential": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]], "sequentialminus": [[0.0, "#0d0887"], [0.1111111111111111, "#46039f"], [0.2222222222222222, "#7201a8"], [0.3333333333333333, "#9c179e"], [0.4444444444444444, "#bd3786"], [0.5555555555555556, "#d8576b"], [0.6666666666666666, "#ed7953"], [0.7777777777777778, "#fb9f3a"], [0.8888888888888888, "#fdca26"], [1.0, "#f0f921"]] }, "colorway": ["#636efa", "#EF553B", "#00cc96", "#ab63fa", "#FFA15A", "#19d3f3", "#FF6692", "#B6E880", "#FF97FF", "#FECB52"], "font": { "color": "#f2f5fa" }, "geo": { "bgcolor": "rgb(17,17,17)", "lakecolor": "rgb(17,17,17)", "landcolor": "rgb(17,17,17)", "showlakes": true, "showland": true, "subunitcolor": "#506784" }, "hoverlabel": { "align": "left" }, "hovermode": "closest", "mapbox": { "style": "dark" }, "paper_bgcolor": "rgb(17,17,17)", "plot_bgcolor": "rgb(17,17,17)", "polar": { "angularaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "bgcolor": "rgb(17,17,17)", "radialaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" } }, "scene": { "xaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "gridwidth": 2, "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3" }, "yaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "gridwidth": 2, "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3" }, "zaxis": { "backgroundcolor": "rgb(17,17,17)", "gridcolor": "#506784", "gridwidth": 2, "linecolor": "#506784", "showbackground": true, "ticks": "", "zerolinecolor": "#C8D4E3" } }, "shapedefaults": { "line": { "color": "#f2f5fa" } }, "sliderdefaults": { "bgcolor": "#C8D4E3", "bordercolor": "rgb(17,17,17)", "borderwidth": 1, "tickwidth": 0 }, "ternary": { "aaxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "baxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" }, "bgcolor": "rgb(17,17,17)", "caxis": { "gridcolor": "#506784", "linecolor": "#506784", "ticks": "" } }, "title": { "x": 0.05 }, "updatemenudefaults": { "bgcolor": "#506784", "borderwidth": 0 }, "xaxis": { "automargin": true, "gridcolor": "#283442", "linecolor": "#506784", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#283442", "zerolinewidth": 2 }, "yaxis": { "automargin": true, "gridcolor": "#283442", "linecolor": "#506784", "ticks": "", "title": { "standoff": 15 }, "zerolinecolor": "#283442", "zerolinewidth": 2 } } };


/***/ }),

/***/ "../tslib/react/pkg/components/TrialTable.js":
/*!***************************************************!*\
  !*** ../tslib/react/pkg/components/TrialTable.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TrialTable: () => (/* binding */ TrialTable)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../tslib/react/node_modules/react/jsx-runtime.js");
/* harmony import */ var _mui_icons_material__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @mui/icons-material */ "../tslib/react/node_modules/@mui/icons-material/esm/Link.js");
/* harmony import */ var _mui_material__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @mui/material */ "../tslib/react/node_modules/@mui/material/IconButton/IconButton.js");
/* harmony import */ var _DataGrid__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./DataGrid */ "../tslib/react/pkg/components/DataGrid.js");
/* harmony import */ var _tanstack_react_table__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @tanstack/react-table */ "../tslib/react/node_modules/@tanstack/table-core/build/lib/index.mjs");





const multiValueFilter = (row, columnId, filterValue) => {
    const rowValue = row.getValue(columnId);
    return !filterValue.includes(rowValue);
};
const TrialTable = ({ study, initialRowsPerPage, linkComponent, linkURL }) => {
    const trials = study.trials;
    const metricNames = study.metric_names || [];
    const columnHelper = (0,_tanstack_react_table__WEBPACK_IMPORTED_MODULE_2__.createColumnHelper)();
    // biome-ignore lint/suspicious/noExplicitAny: It is difficult to specify this type.
    const columns = [
        columnHelper.accessor("number", {
            header: "Number",
            enableColumnFilter: false,
        }),
        columnHelper.accessor("state", {
            header: "State",
            enableSorting: false,
            enableColumnFilter: true,
            filterFn: multiValueFilter,
        }),
    ];
    if (study.directions.length === 1) {
        columns.push(columnHelper.accessor("values", {
            header: "Value",
            enableSorting: true,
            enableColumnFilter: false,
            sortUndefined: "last",
        }));
    }
    else {
        columns.push(...study.directions.map((_s, objectiveId) => columnHelper.accessor((row) => row.values?.[objectiveId], {
            id: `values_${objectiveId}`,
            header: metricNames.length === study.directions.length
                ? metricNames[objectiveId]
                : `Objective ${objectiveId}`,
            enableSorting: true,
            enableColumnFilter: false,
            sortUndefined: "last",
        })));
    }
    const isDynamicSpace = study.union_search_space.length !== study.intersection_search_space.length;
    if (study.union_search_space != null) {
        for (const s of study.union_search_space) {
            const sortable = s.distribution.type !== "CategoricalDistribution";
            const filterChoices = s.distribution.type === "CategoricalDistribution"
                ? s.distribution.choices.map((c) => c?.value ?? "null")
                : undefined;
            const hasMissingValue = trials.some((t) => !t.params.some((p) => p.name === s.name));
            if (filterChoices !== undefined && isDynamicSpace && hasMissingValue) {
                filterChoices.push(null);
            }
            columns.push(columnHelper.accessor((row) => {
                const param_external_value = row.params.find((p) => p.name === s.name)?.param_external_value;
                return param_external_value === undefined
                    ? null
                    : param_external_value;
            }, {
                id: `params_${s.name}`,
                header: `Param ${s.name}`,
                enableSorting: sortable,
                sortUndefined: "last",
                enableColumnFilter: filterChoices !== undefined,
                filterFn: multiValueFilter,
            }));
        }
    }
    if (study.union_search_space != null) {
        for (const attr_spec of study.union_user_attrs) {
            columns.push(columnHelper.accessor((row) => {
                const value = row.user_attrs.find((a) => a.key === attr_spec.key)?.value;
                return value === undefined ? null : value;
            }, {
                id: `user_attrs_${attr_spec.key}`,
                header: `UserAttribute ${attr_spec.key}`,
                enableSorting: attr_spec.sortable,
                sortUndefined: "last",
                enableColumnFilter: false,
            }));
        }
    }
    if (linkComponent !== undefined && linkURL !== undefined) {
        columns.push(columnHelper.accessor((row) => row, {
            header: "Detail",
            cell: (info) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_material__WEBPACK_IMPORTED_MODULE_3__["default"], { component: linkComponent, to: linkURL(info.getValue().study_id, info.getValue().number), color: "inherit", title: "Go to the trial's detail page", size: "small", children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_mui_icons_material__WEBPACK_IMPORTED_MODULE_4__["default"], {}) })),
            enableSorting: false,
            enableColumnFilter: false,
        }));
    }
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_DataGrid__WEBPACK_IMPORTED_MODULE_1__.DataGrid, { data: trials, columns: columns, initialRowsPerPage: initialRowsPerPage }));
};


/***/ }),

/***/ "../tslib/react/pkg/hooks/useGraphComponentState.js":
/*!**********************************************************!*\
  !*** ../tslib/react/pkg/hooks/useGraphComponentState.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useGraphComponentState: () => (/* binding */ useGraphComponentState)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const useGraphComponentState = () => {
    const [graphComponentState, setGraphComponentState] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("componentWillMount");
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        setGraphComponentState("componentDidMount");
    }, []);
    return {
        graphComponentState,
        notifyGraphDidRender: () => setGraphComponentState("graphDidRender"),
    };
};


/***/ }),

/***/ "../tslib/react/pkg/index.js":
/*!***********************************!*\
  !*** ../tslib/react/pkg/index.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DataGrid: () => (/* reexport safe */ _components_DataGrid__WEBPACK_IMPORTED_MODULE_0__.DataGrid),
/* harmony export */   GraphContainer: () => (/* reexport safe */ _components_GraphContainer__WEBPACK_IMPORTED_MODULE_10__.GraphContainer),
/* harmony export */   PlotEdf: () => (/* reexport safe */ _components_PlotEdf__WEBPACK_IMPORTED_MODULE_2__.PlotEdf),
/* harmony export */   PlotHistory: () => (/* reexport safe */ _components_PlotHistory__WEBPACK_IMPORTED_MODULE_3__.PlotHistory),
/* harmony export */   PlotImportance: () => (/* reexport safe */ _components_PlotImportance__WEBPACK_IMPORTED_MODULE_4__.PlotImportance),
/* harmony export */   PlotIntermediateValues: () => (/* reexport safe */ _components_PlotIntermediateValues__WEBPACK_IMPORTED_MODULE_5__.PlotIntermediateValues),
/* harmony export */   PlotParallelCoordinate: () => (/* reexport safe */ _components_PlotParallelCoordinate__WEBPACK_IMPORTED_MODULE_8__.PlotParallelCoordinate),
/* harmony export */   PlotSlice: () => (/* reexport safe */ _components_PlotSlice__WEBPACK_IMPORTED_MODULE_6__.PlotSlice),
/* harmony export */   PlotTimeline: () => (/* reexport safe */ _components_PlotTimeline__WEBPACK_IMPORTED_MODULE_7__.PlotTimeline),
/* harmony export */   Target: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.Target),
/* harmony export */   TrialTable: () => (/* reexport safe */ _components_TrialTable__WEBPACK_IMPORTED_MODULE_9__.TrialTable),
/* harmony export */   plotlyDarkTemplate: () => (/* reexport safe */ _components_PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_1__.plotlyDarkTemplate),
/* harmony export */   useFilteredTrials: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useFilteredTrials),
/* harmony export */   useFilteredTrialsFromStudies: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useFilteredTrialsFromStudies),
/* harmony export */   useGraphComponentState: () => (/* reexport safe */ _hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_11__.useGraphComponentState),
/* harmony export */   useMergedUnionSearchSpace: () => (/* reexport safe */ _utils_searchSpace__WEBPACK_IMPORTED_MODULE_13__.useMergedUnionSearchSpace),
/* harmony export */   useObjectiveAndUserAttrTargets: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useObjectiveAndUserAttrTargets),
/* harmony export */   useObjectiveAndUserAttrTargetsFromStudies: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useObjectiveAndUserAttrTargetsFromStudies),
/* harmony export */   useObjectiveTargets: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useObjectiveTargets),
/* harmony export */   useParamTargets: () => (/* reexport safe */ _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__.useParamTargets)
/* harmony export */ });
/* harmony import */ var _components_DataGrid__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./components/DataGrid */ "../tslib/react/pkg/components/DataGrid.js");
/* harmony import */ var _components_PlotlyDarkMode__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./components/PlotlyDarkMode */ "../tslib/react/pkg/components/PlotlyDarkMode.js");
/* harmony import */ var _components_PlotEdf__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./components/PlotEdf */ "../tslib/react/pkg/components/PlotEdf.js");
/* harmony import */ var _components_PlotHistory__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./components/PlotHistory */ "../tslib/react/pkg/components/PlotHistory.js");
/* harmony import */ var _components_PlotImportance__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./components/PlotImportance */ "../tslib/react/pkg/components/PlotImportance.js");
/* harmony import */ var _components_PlotIntermediateValues__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./components/PlotIntermediateValues */ "../tslib/react/pkg/components/PlotIntermediateValues.js");
/* harmony import */ var _components_PlotSlice__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./components/PlotSlice */ "../tslib/react/pkg/components/PlotSlice.js");
/* harmony import */ var _components_PlotTimeline__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./components/PlotTimeline */ "../tslib/react/pkg/components/PlotTimeline.js");
/* harmony import */ var _components_PlotParallelCoordinate__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./components/PlotParallelCoordinate */ "../tslib/react/pkg/components/PlotParallelCoordinate.js");
/* harmony import */ var _components_TrialTable__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./components/TrialTable */ "../tslib/react/pkg/components/TrialTable.js");
/* harmony import */ var _components_GraphContainer__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./components/GraphContainer */ "../tslib/react/pkg/components/GraphContainer.js");
/* harmony import */ var _hooks_useGraphComponentState__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./hooks/useGraphComponentState */ "../tslib/react/pkg/hooks/useGraphComponentState.js");
/* harmony import */ var _utils_trialFilter__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./utils/trialFilter */ "../tslib/react/pkg/utils/trialFilter.js");
/* harmony import */ var _utils_searchSpace__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./utils/searchSpace */ "../tslib/react/pkg/utils/searchSpace.js");
















/***/ }),

/***/ "../tslib/react/pkg/utils/graph.js":
/*!*****************************************!*\
  !*** ../tslib/react/pkg/utils/graph.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   makeHovertext: () => (/* binding */ makeHovertext)
/* harmony export */ });
const makeHovertext = (trial) => {
    return JSON.stringify({
        number: trial.number,
        values: trial.values,
        params: trial.params.reduce((obj, p) => {
            obj[p.name] = p.param_external_value;
            return obj;
        }, {}),
    }, undefined, "  ").replace(/\n/g, "<br>");
};


/***/ }),

/***/ "../tslib/react/pkg/utils/searchSpace.js":
/*!***********************************************!*\
  !*** ../tslib/react/pkg/utils/searchSpace.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   useMergedUnionSearchSpace: () => (/* binding */ useMergedUnionSearchSpace)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const mergeUnionSearchSpace = (unionSearchSpace) => {
    const knownElements = new Map();
    for (const s of unionSearchSpace) {
        const d = knownElements.get(s.name);
        if (d === undefined) {
            knownElements.set(s.name, s.distribution);
            continue;
        }
        if (d.type === "CategoricalDistribution" ||
            s.distribution.type === "CategoricalDistribution") {
            // CategoricalDistribution.choices will never be changed
            continue;
        }
        const updated = {
            ...d,
            low: Math.min(d.low, s.distribution.low),
            high: Math.max(d.high, s.distribution.high),
        };
        knownElements.set(s.name, updated);
    }
    return Array.from(knownElements.keys())
        .sort((a, b) => (a > b ? 1 : a < b ? -1 : 0))
        .map((name) => ({
        name: name,
        distribution: knownElements.get(name),
    }));
};
const useMergedUnionSearchSpace = (unionSearchSpaces) => (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
    return mergeUnionSearchSpace(unionSearchSpaces || []);
}, [unionSearchSpaces]);


/***/ }),

/***/ "../tslib/react/pkg/utils/trialFilter.js":
/*!***********************************************!*\
  !*** ../tslib/react/pkg/utils/trialFilter.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Target: () => (/* binding */ Target),
/* harmony export */   useFilteredTrials: () => (/* binding */ useFilteredTrials),
/* harmony export */   useFilteredTrialsFromStudies: () => (/* binding */ useFilteredTrialsFromStudies),
/* harmony export */   useObjectiveAndUserAttrTargets: () => (/* binding */ useObjectiveAndUserAttrTargets),
/* harmony export */   useObjectiveAndUserAttrTargetsFromStudies: () => (/* binding */ useObjectiveAndUserAttrTargetsFromStudies),
/* harmony export */   useObjectiveTargets: () => (/* binding */ useObjectiveTargets),
/* harmony export */   useParamTargets: () => (/* binding */ useParamTargets)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

class Target {
    constructor(kind, key) {
        this.kind = kind;
        this.key = key;
    }
    validate() {
        if (this.kind === "objective") {
            if (typeof this.key !== "number") {
                return false;
            }
        }
        else if (this.kind === "user_attr") {
            if (typeof this.key !== "string") {
                return false;
            }
        }
        else if (this.kind === "params") {
            if (typeof this.key !== "string") {
                return false;
            }
        }
        return true;
    }
    identifier() {
        return `${this.kind}:${this.key}`;
    }
    toLabel(objectiveNames) {
        if (this.kind === "objective") {
            const objectiveId = this.key;
            if (objectiveNames !== undefined && objectiveNames.length > objectiveId) {
                return objectiveNames[objectiveId];
            }
            return `Objective ${objectiveId}`;
        }
        if (this.kind === "user_attr") {
            return `User Attribute ${this.key}`;
        }
        return `Param ${this.key}`;
    }
    getObjectiveId() {
        if (this.kind !== "objective") {
            return null;
        }
        return this.key;
    }
    getTargetValue(trial) {
        if (!this.validate()) {
            return null;
        }
        if (this.kind === "objective") {
            const objectiveId = this.getObjectiveId();
            if (objectiveId === null ||
                trial.values === undefined ||
                trial.values.length <= objectiveId) {
                return null;
            }
            const value = trial.values[objectiveId];
            if (value === Infinity || value === -Infinity) {
                return null;
            }
            return value;
        }
        if (this.kind === "user_attr") {
            const attr = trial.user_attrs.find((attr) => attr.key === this.key);
            if (attr === undefined) {
                return null;
            }
            const value = Number(attr.value);
            if (value === undefined) {
                return null;
            }
            return value;
        }
        if (this.kind === "params") {
            const param = trial.params.find((p) => p.name === this.key);
            if (param === undefined) {
                return null;
            }
            return param.param_internal_value;
        }
        return null;
    }
}
const filterTrials = (study, targets, filterPruned) => {
    if (study === null) {
        return [];
    }
    return study.trials.filter((t) => {
        if (t.state !== "Complete" && t.state !== "Pruned") {
            return false;
        }
        if (t.state === "Pruned" && filterPruned) {
            return false;
        }
        return targets.every((target) => target.getTargetValue(t) !== null);
    });
};
const useFilteredTrials = (study, targets, filterPruned) => 
// biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
(0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
    return filterTrials(study, targets, filterPruned);
}, [study?.trials, targets, filterPruned]);
const useFilteredTrialsFromStudies = (studies, targets, filterPruned) => (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
    return studies.map((s) => filterTrials(s, targets, filterPruned));
}, [studies, targets, filterPruned]);
const useObjectiveTargets = (study) => {
    const defaultTarget = new Target("objective", 0);
    const [selected, setTargetIdent] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(defaultTarget.identifier());
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const targetList = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        if (study !== null) {
            return study.directions.map((_v, i) => new Target("objective", i));
        }
        return [defaultTarget];
    }, [study?.directions]);
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const selectedTarget = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => targetList.find((t) => t.identifier() === selected) || defaultTarget, [targetList, selected]);
    return [targetList, selectedTarget, setTargetIdent];
};
const useParamTargets = (searchSpace) => {
    const [selected, setTargetIdent] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("");
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const targetList = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        const targets = searchSpace.map((s) => new Target("params", s.name));
        if (selected === "" && targets.length > 0)
            setTargetIdent(targets[0].identifier());
        return targets;
    }, [searchSpace]);
    const selectedTarget = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => targetList.find((t) => t.identifier() === selected) || null, [targetList, selected]);
    return [targetList, selectedTarget, setTargetIdent];
};
const useObjectiveAndUserAttrTargets = (study) => {
    const defaultTarget = new Target("objective", 0);
    const [selected, setTargetIdent] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(defaultTarget.identifier());
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const targetList = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        if (study !== null) {
            return [
                ...study.directions.map((_v, i) => new Target("objective", i)),
                ...study.union_user_attrs
                    .filter((attr) => attr.sortable)
                    .map((attr) => new Target("user_attr", attr.key)),
            ];
        }
        return [defaultTarget];
    }, [study?.directions, study?.union_user_attrs]);
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const selectedTarget = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => targetList.find((t) => t.identifier() === selected) || defaultTarget, [targetList, selected]);
    return [targetList, selectedTarget, setTargetIdent];
};
const useObjectiveAndUserAttrTargetsFromStudies = (studies) => {
    const defaultTarget = new Target("objective", 0);
    const [selected, setTargetIdent] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(defaultTarget.identifier());
    const minDirections = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        if (studies.length === 0) {
            return 0;
        }
        return studies.reduce((acc, study) => {
            return Math.min(acc, study.directions.length);
        }, Number.MAX_VALUE);
    }, [studies]);
    const intersect = (arrays) => {
        const atrEqual = (obj1, obj2) => {
            return obj1.key === obj2.key;
        };
        return arrays.reduce((a, b) => a.filter((c) => b.some((d) => atrEqual(c, d))));
    };
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const attrTargets = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        if (studies.length === 0) {
            return [];
        }
        const intersection = intersect(studies.map((study) => study.union_user_attrs));
        return intersection
            .filter((attr) => attr.sortable)
            .map((attr) => new Target("user_attr", attr.key));
    }, [studies]);
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const targetList = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => {
        if (studies !== null) {
            return [
                ...Array.from({ length: minDirections }, (_, i) => new Target("objective", i)),
                ...attrTargets,
            ];
        }
        return [defaultTarget];
    }, [minDirections, attrTargets]);
    // biome-ignore lint/correctness/useExhaustiveDependencies: <explanation>
    const selectedTarget = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => targetList.find((t) => t.identifier() === selected) || defaultTarget, [targetList, selected]);
    return [targetList, selectedTarget, setTargetIdent];
};


/***/ })

}]);
//# sourceMappingURL=optuna_dashboard_pkg_pkg_index_js.c6629202812114885633.js.map